c	**************************************************************
c	* Michls convolution subroutine                              *
c	**************************************************************
	
	SUBROUTINE MCONV(f,sizf,sizg,q,f_conv,phi,sizphi,sizfconv)

c       **************************************************************
c	* this routine convolves the vector f with the default phi vector 
c       **************************************************************

c	*  f_conv    oversampled & convolved model vector  OUTPUT
c	*  f	     oversampled & not conv. model vector  INPUT
c	*  sizg      size of the observed vector           INPUT
c	*  sizf      =sizg*q+sizphi!!!!                    INPUT
c	*  q	     oversampling factor                   INPUT
c	*  phi       instrumental profile for the conv.    INPUT
c       *  sizphi    size of IP vector                     INPUT
c	*  sizfconv  size of f_conv                        OUTPUT	

	IMPLICIT NONE
	INTEGER maxsize

	PARAMETER (maxsize=5000)
c	PARAMETER (maxsize=10000)	


	INTEGER i,sizf,sizphi,j,k,sizg,p,sizgnew,sizgsimu,q,count
	INTEGER sizfconv
c	REAL f(1000),phi(1000),g_simu(1000),g_new(1000),conv(1000)
c	REAL f_conv(1000)
	REAL f(maxsize),phi(maxsize),g_simu(maxsize),g_new(maxsize)
	REAL conv(maxsize),f_conv(maxsize)

	REAL gdummy
	REAL*8 sumphi,sumidu
	CHARACTER reply
	
c	write(*,*)'%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%'
c	write(*,*)'START OF MICHLs CONVOLUTION ROUTINE'
c	write(*,*)'Lets go...........'
c	write(*,*)
c	write(*,*)'Size of f-vector, sizf=',sizf
c	write(*,*)'Value of f at index 42, f(42)=',f(42)
c	write(*,*)'%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%'

c	open(200,file='./data/dfi49.asc')

c	************ new test ip: **********
c	open(200,file='./data/testip.dat')


c	read(200,*) sizphi
c	write(*,*) 'Reading the default IP.....'
c	write(*,*) 'Size of default Phi: sizphi=',sizphi
c	write(*,*) 'Oversampling factor=',q
 
c	sumphi=0
c	do i=1,sizphi
c		read(200,*) phi(i)
c		sumphi=sumphi+phi(i)
c	end do
c	close(200)


c	write(*,*) '...Done'
c	write(*,*) 'Sumphi=',sumphi
c	write(*,*) 'Now normalising.........'
	
c	do i=1,sizphi
c		phi(i)=phi(i)/sumphi
c	end do
c	write(*,*) '...Done'

c	write(*,*)'Value of Phi(23)=',phi(23)

c	write(*,*) 'Output to file mikephi.dat....'
c	open(unit=300,file='./plot/testphi.dat', type='new')
c	do i=1,sizphi 
c		write(300,*)phi(i)
c	end do
c	close(300)

c	write(*,*)	
c	write(*,*)'******** C O N V O L U T I O N *********'
c	write(*,*)

c	p=24

	p=sizphi/2

	sizgsimu=0

c	write(*,*)'Cut off value for Phi, p=',p

c	open(456, file='conv.dat', type='new')

	do j=1,sizf
		
		sumidu=0.
		
		do k=1,sizphi

c			if (j.eq.50) then
c
c			    write(*,*)'k ,Phi(k)',k,phi(k)
c			    write(*,*)'(j-(p+1)+k)=',j-(p+1)+k
c			    write(*,*)'f(j-(p+1)+k)=',f(j-(p+1)+k)
c	      write(*,*)'f(j-(p+1)+k)*Phi(k)=',f(j-(p+1)+k)*phi(k)
c			write(*,*)'sumidu=',sumidu	
c
c			end if

		  
		 if ((j-(p+1)+k).gt.0) then	
		
		  sumidu=sumidu+(f(j-(p+1)+k)*phi(k))
			
		 end if


		end do

		conv(j)=sumidu
		sizgsimu=sizgsimu+1

c		if (j.eq.23) then 
c		write(*,*)'Value of convolved vector(23)',conv(j)
c		end if 
		
c		write(456,*)conv(j)
	
	end do

c	close(456)

c	write(*,*)'Convolution done.....'
c	write(*,*)

c	do i=1,sizf
c		f_conv(i)=conv(i)
c	end do
c	sizfconv=sizf

c	goto 978



c	write(*,*)'Now cutting edges......'
	sizfconv=sizf-2*p
c	write(*,*)'New sizf(sizf-2p)=',sizfconv

	sizgnew=0
	
	do i=1,sizfconv
		f_conv(i)=conv(i+p)
		sizgnew=sizgnew+1
	end do

c	write(*,*)'....done. Size of new vector=',sizgnew




c	write(*,*)'Reformatting....'
c	write(*,*)
c	********** g_simu is the 88 pixel lowres spectra *********


c	**************** old way ***********************

c	new way:

c	sizgsimu=0.
c	count=1
c	j=1

c	do i=1,sizgnew

c		gdummy=gdummy+f_conv(i)
c	write(*,*)'i ,count, j, g_new(i),gdummy',i,count,j,g_new(i),gdummy
c		count=count+1
c		if (count.gt.q) then
c			count=1
c			g_simu(j)=gdummy/q
c			write(*,*)'gsimu(j)=',g_simu(j)
c			j=j+1
c			sizgsimu=sizgsimu+1
c			gdummy=0.
c		end if

c	end do



c	write(*,*)'Reformatting done. New size=',sizgsimu
c	write(*,*)'g_simu(23)=',g_simu(23)



c	write(*,*)'Writing to outputfile mikeg.dat....'
       
c	 open(unit=300,file='./plot/testg.dat', type='new')
c        do i=1,sizgsimu
c                write(300,*)g_simu(i)
c         end do
c         close(300)


c	write(*,*)'OK! Lets take a look......'
c	write(*,*)'Do ya wanna continue?'
c	read(*,*)reply

c	write(*,*)'End of MCONV.....'

c978	continue

	return

	end
		
