c********************************************************************   
c** MREAD
c********************************************************************   

      subroutine
& mread(sizf,sizg,sizfi,fi,g_simu,q,p,s,wn,wn2,
& start_mstb,par,ka,wlka,sizka,star,stellarmstb,
& ka2,sizka2,wnka2,baryvel_mstb,baryvel_star,
& size_mstb)

c**********************************************************************
c  This routine constructs the parametrized function F=f(lbd,par(i=1,5))
c  after having looked for its location in the master table,and convolves 
c  it with the default IP vector fi. The resulting vector is returned as g.
c**********************************************************************
c     ------------------------------
c     description of main variables:
c
c     p    Integer              Cut-off on fi                      IN
c     sizg Integer              Size of g vector (px)              IN      
c     sizf Integer              Size of f vector (px)              IN 
c     wn   real*8               Start wavenumber                   IN
c     wn2  real*8               End wavenumber	                   IN
c     fi   Real 1-D array       Default instrumental profile       OUT
c     g    Real 1-D array       Discrete observed spectrum vector  OUT
c     start_mstb Integer        Start index in the master table    OUT
c     ka   Real 1-D array       Hires Array read from masttab      OUT
c     sizka Integer             Size of ka vector                  OUT 
c     wlka Real*8 1-D array     Wavenumber array for ka            OUT	
c     ka2  Real 1-D array       Hires Array read from stellarmstb  OUT
c     sizka2 Integer            Size of ka2 array                  OUT
c     wnka2 Real*8 1-D array    Wavenumber array for ka2           OUT
c     stellarmstb character*25  Filename of stellar mstb           IN  	 	
c     star Integer              Flag 0=Iodine 1=Star               IN
c     size_mstb Integer 	Number of records in star template IN	
c
c
c**********************************************************************

	IMPLICIT NONE

	integer maxsiz,splin_div,nb_params
	parameter (maxsiz=1000,splin_div=10,nb_params=40)
c	parameter (maxsiz=5000,splin_div=10,nb_params=40)

        integer i,j,k,start_mstb,lr,end_mstb,end_try
        integer sizf,sizg,q,p,sizfi,sizka,sizgsimu,sizka2
        integer start_try,kaindex,count,sizfconv,star


	real fi(maxsiz),s(maxsiz)

c       a try 18/01/2000:
	REAL g_simu(5000)

c--------------------------------------------------------------
c	a try 18/01/2000:
	REAL ka(40000),ka2(40000)
cccc	original:
cccc	REAL ka(20000),ka2(20000)

c	real f_conv(maxsiz)
	real f_conv(5000),f(5000)

c       a try 18/01/2000:
	real*8 wlka(40000),wnka2(40000)
cccc    original:
cccc        real*8 wlka(20000),wnka2(20000)

c--------------------------------------------------------------

	REAL par(nb_params)
	REAL*8 baryvel_mstb,baryvel_star,barydiff,barywn,barywndiff

	real*8  wl,wn,wn2,wn0,f0,wtry,kadummi,wlka1,wlka2
	real*8 ratio_wn_mtb,diff_wn,f_wn(maxsiz)
	real*8 step,rest,diff,realkaindex,startkaindex
	real ka0,ka1,num_mstb,sizfreal,gdummy
	character reply
	character*25 stellarmstb

	integer index_stellar,ka2index1,ka2index2
        integer irec,size_mstb 
	real*8 step_stellar,wlka2try,ka2try,wlend,diff2
	REAL*8 c,BJD

c=============================================================================

c       CES: this is 10x the stepsize:
c	ratio_wn_mtb=0.01409413961
c	SARG:
c	ratio_wn_mtb=0.01334083

c	UVES :
c	ratio_wn_mtb=0.0133408318

c	cs23 : ha! like the CES
c	ratio_wn_mtb = 0.0140941395875416

c       HRS:
c	ratio_wn_mtb = 0.01334083214

c       HIRES
c       ratio_wn_mtb = 0.01409413961
c        ratio_wn_mtb = 0.0140941396239214

c	UCLES new 2009 FTS
	ratio_wn_mtb = 0.013542175293

	c=2.99792458D+08

c=============================================================================

	lr=8*2

	irec=1
c	UCLES:
	step_stellar=-0.13542175293D-02


c	CES & cs23:
c	step_stellar=-0.140982175D-02

c	cs23
c	step_stellar=-0.140941395875416D-02

c	UVES & SARG:
c	step_stellar=-0.133408318E-02	

c       HRS:
c        step_stellar=-0.1334083214D-02

c       HIRES
c       step_stellar=-0.1409413961D-02
c        step_stellar=-0.140941396239214D-02

c	HIRES2:
c	step_stellar=-0.13542175293D-02


c	******* VIL!! Size of ka-array!!! *******************
ccc	sizka=10000
c	a try:
	sizka=20000
	sizka2=20000
c	*****************************************************

c=============================================================================

c======	CHECK whether pure iodine or stellar spectrum:
 	
	if (star.eq.1) then

c*****	===============================	
c	UVES:
c	size_mstb=174227
c	size_mstb=196328

c	WRITE(*,*)' Records of stellar template: ',size_mstb

c	VLC:
c	size_mstb=43420
c	CCD#59:
c	size_mstb=87200
c	size_mstb=66000

c	LC:
c	size_mstb=114200
c	size_mstb=114000 
c*****	===============================

c	write(*,*)'*************** STELLAR MASTERTABLE *************'
c	write(*,*)'Using stellar mastertable:',stellarmstb
c	write(*,*)' with barycentric velocity:',baryvel_mstb

        open(unit=01,file='/data2/austral/mike/UCLES/mastertab/'
&       //stellarmstb,status='old',access='direct',
&       form='unformatted',recl=lr)


c	open(unit=01,file='/data1/austral/mike/MCD/mastertab/'//stellarmstb,
c& status='old',access='direct',form='unformatted',recl=lr)

        read(unit=01,rec=irec) wlka2try,ka2try
c        write(*,109) wlka2try,ka2try
        

c        write(*,*)
c        write(*,*)'Wavenumber at beginning of chunk:',wn2
c        write(*,*)'Wavenumber at end of chunk:',wn
c	write(*,*)'Wavelenght at end of chunk:',1./(wn*1E-08)

c	write(*,*)'Barycentric velocity of stellar spectrum:',baryvel_star

	barydiff = baryvel_mstb - baryvel_star
c	write(*,*)'Baryvelocity difference:',barydiff

	barywndiff = (barydiff/c) * wn

c	write(*,*)'Delta in wavenumber:',barywndiff

c	barywndiff = (barydiff/c) * 1./(wn*1E-08)
c	write(*,*)'Delta in wavelength:',barywndiff
c	write(*,*)'LOOKING FOR: ',(1./(wn*1E-08))-barywndiff,' in Angstroem'

	barywn= wn +barywndiff


c        write(*,*)'First Wavenumber in stellar MASTERTAB:'
c        write(*,109) wlka2try
c    write(*,*)'..and the corresponding flux='
c     write(*,109) ka2try
c      write(*,*)'Chunk turns around => wlka2(2500) should be:'   
c       write(*,109) wn
c	write(*,*)'Looking for wavenumber =>wlka2(2500) should be:'
c	write(*,*)barywn


        diff = wn2 - wn
        
c        write(*,*)'Difference (length) of chunk in waven:',diff
c        write(*,*)'and that means that many ka2
c& records:',diff/-(step_stellar)
        
c++     
        ka2index1=INT(diff/-(step_stellar))
        
c++     ka2index1 is now the length of the chunk (sin edges) in
c++     units of mastb records
        
cccccc        diff = wn - wlka2try 

	diff = barywn - wlka2try
        
        ka2index2=INT(diff/-(step_stellar))
        
c++     ka2index2 is the number of how many records wn is away
c++     from the start of the mstb.
        
c        write(*,*)'OK, wn is that many records away:',ka2index2
        
c===    check if still in range of mstb:

c	write(*,*)'1st edge= ',ka2index2-2500.
c	write(*,*)'2nd edge= ',ka2index2+ka2index1+2500.
c	write(*,*)'size_mstb= ',size_mstb

        if (ka2index2-2500.lt.0) then
                sizka2=1
                write(*,*)'!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'
                write(*,*)' OUT OF RANGE FOR THE STELLAR MASTERTABLE'
                write(*,*)'!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'
		write(*,*)'=> Flag=1'
                goto 9999
        end if
        
        if (ka2index2+ka2index1+2500.gt.(size_mstb-5)) then
                sizka2=2
                write(*,*)'!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'
                write(*,*)' OUT OF RANGE FOR THE STELLAR MASTERTABLE'
                write(*,*)'!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'
		write(*,*)'=> Flag=2'
                goto 9999
        end if
        
c===    

                
        irec=ka2index2
                
 300    continue
        read(unit=1,rec=irec) wlka2try,ka2try
c        write(*,*)'OK, wavenumber & flux at record ',irec,' ='
c        write(*,109) wlka2try,ka2try
cccc        diff = ABS(wlka2try-wn)

	diff = ABS(wlka2try-barywn)
                
c        write(*,*)'OK, wavenumber diff=',diff
                
        wlend=diff
        
        read(unit=1,rec=irec+1) wlka2try,ka2try

cccc        diff2 = ABS(wlka2try-wn)
    	diff2 = ABS(wlka2try-barywn)
    
        if (diff2.lt.wlend) then
c               write(*,*)'OK, wavenumber diff=',diff2
c               write(*,*)'DIFF is SMALLER!!'
                irec=irec+1
                goto 300
        end if
        
        read(unit=1,rec=irec-1) wlka2try,ka2try

cccc        diff2 = ABS(wlka2try-wn)
	diff2 = ABS(wlka2try-barywn)

        if (diff2.lt.wlend) then
c                write(*,*)'OK, wavenumber diff=',diff2
c                write(*,*)'DIFF is SMALLER!!'
                irec=irec-1
                goto 300
        end if
        
c        write(*,*)'OK, minimum of diff found...'
c        write(*,*)'OK, wavenumber diff=',diff
c        write(*,*)'Record#=',irec
                
                
c        read(*,*)reply

c----   READING MSTB:     ------------------------------------------
c
c       reading again 2499 pixel more as the first edges!
c       (that's ~ 1 A more at both ends!!!)
c       i.e. at index 2500 of the ka2 array there is the record
c       of the mstb which is closest to the wavenumber at chunk
c       start. So ka2(2500) is the equivalent to ka(start_mastb)
c       for the Iodine.
c       
c-------------------------------------------------------------------

        index_stellar = irec - 2500

        sizka2 = ka2index1 + 5000

c        write(*,*)'OK, size of ka2 array is now (chunk+5000) =',sizka2
c	write(*,*)'OK, index_stellar= ',index_stellar

c-------------------- K A 2   L O O P -----------------------------

        do i=1,sizka2

                read(unit=1,rec=index_stellar+i) wnka2(i),ka2try

                ka2(i)=ka2try

        end do

c-------------------- K A 2   L O O P -----------------------------


c        write(*,*)'OK, Wavenumber at index 2500 =',wnka2(2500)

        wlend=1/(wnka2(2500)*1.E-08)

c        write(*,*)'And that is in Angstroem:',wlend
                
        wlend=1/(wnka2(1)*1.E-08)
 
c        write(*,*)'KA2 starts in Angstroem at:',wlend


c        write(*,*)'And ka2(2500)=',ka2(2500)
c       write(*,*)'Wavenumber at end of ka2=',wnka2(sizka2)  

        wlend=1/(wnka2(sizka2)*1.E-08)

c        write(*,*)'And that is in Angstroem:',wlend

c*************************************************




	end if
c================ end of if (stellar/iodine) loop==============


 
c------- IODINE MASTERTABLE: ----------------------------------


cc Construction of the parametrized array f=f0(a,i), df=df0(a,i)/di
c	*****************************************************
c	ucles_master_air.dat = new (2009) UCLES FTS lambda_air corrected
c	hires2_master_air.dat = new (2009) HIRES mastertab lambda_air corrected
c	hires_master_air.dat = HIRES mastertab lambda_air corrected
c       hrs3_master_air.dat = HRS3 70C mastertab lambda_air corrected
c       hrs1_master_air.dat = HRS1 60C mastertab lambda_air corrected
c	mcd_master_air.dat = cs23 mastertab lambda_air corrected wavenumbers
c	master_air2.dat = UVES mastertab with lambda_air corrected wavenumbers
c	master_da.dat   = UVES original mastertab
c	master_air.dat = CES mastertab with lambda_air corrected wavenumbers
c	master_dat.dat = CES original mastertab
c	*****************************************************

cc      lr=8*2

c*************************************************************************

        open(unit=2,
&	file='/data2/austral/mike/UCLES/mastertab/ucles_master_air.dat',
&      status='old',access='direct',form='unformatted',recl=lr)

c*************************************************************************

c*************************************************************************

c Search the value of the wave number value at the first line of the master tab.
	read(unit=2,rec=1) wn0,f0
c	write(*,*)'First wavenumber of mastertab:'
c	write(*,109) wn0
c	write(*,*)'and its value:',f0

c	write(*,*)'Searching for wavenumber:'
c	write(*,109)wn

c       ** first approximation of the starting value
	start_mstb=int((wn-wn0)*splin_div/ratio_wn_mtb)
c	** approximation of ending value **
	end_mstb=int((wn2-wn0)*splin_div/ratio_wn_mtb)

c	write(*,*)'==== end_mstb:',end_mstb

c	read(*,*)reply

90	read(unit=2,rec=end_mstb) wl,f0
	if ((ABS(wl-wn2)).gt.(ratio_wn_mtb/splin_div)) then
		if (wl.lt.wn2) then
                        end_mstb=end_mstb+1
                        else
                        end_mstb=end_mstb-1
                end if

c                write(*,*)'Yippee! I can do loop for end_mstb!'   
                goto 90
        end if
        
        	if (wl.lt.wn2) then
                        end_try=end_mstb+1
                        else
                        end_try=end_mstb-1
                end if
c        write(*,*)'Hm -  my last try!'
        read(unit=2,rec=end_try) wtry,f0

	if (abs(wtry-wn2).lt.abs(wl-wn2)) then

                end_mstb=end_try
c                write(*,*)'New end_mstb, wn(end_mstb), delta :'
c                write(*,*) end_mstb,wtry,abs(wtry-wn2)

                else

c                write(*,*)'Hm - wasnt a good idea!'
c                write(*,*)'New end_mstb, wn(end_mstb), delta :'
c                write(*,*) end_mstb,wtry,abs(wtry-wn2)

        end if


	read(unit=2,rec=end_try) wl,f0

c	write(*,*)'Wavenumber and flux at end:',wl,f0
	num_mstb=end_mstb-start_mstb
c	write(*,*)'Number of mastertab pixel:',num_mstb
	sizfreal=sizf
c	write(*,*)'REAL Size of f-vector:',sizf
c------

c	write(*,*)'Ok, linear dispersion coeff in spectrum is:',par(2)
	par(2)=par(2)/q
c	write(*,*)'and oversampled:',par(2)
c	write(*,*)'this is that many mstb steps:',
c&	par(2)/(ratio_wn_mtb/splin_div)

	par(2)=par(2)/(ratio_wn_mtb/splin_div)

c	write(*,*)'NON-linear coeff=',par(8)
	par(8)=par(8)/(q**2)
c	write(*,*)'and oversampled:',par(8)
c	write(*,*)'this is that many mstb steps:',
c&       par(8)/((ratio_wn_mtb/splin_div))

	par(8)=par(8)/((ratio_wn_mtb/splin_div))

c	read(*,*)reply
c------
cccc	old way: (before ThAr)

cccc	par(2)=num_mstb/sizfreal
cccc	write(*,*)'Ratio of mastertab/f-vector (par(2))=',par(2)

c------

100	read(unit=2,rec=start_mstb) wl,f0

c       Michl's search algorithm:
c       -------------------------------------------------------
        if ((ABS(wl-wn)).gt.(ratio_wn_mtb/splin_div)) then
                
                if (wl.lt.wn) then
                        start_mstb=start_mstb+1
                        else
                        start_mstb=start_mstb-1
                end if
                
c                write(*,*)'Yippee! I can do loop!'
                goto 100
        end if
                
                
        if (wl.lt.wn) then
                        start_try=start_mstb+1
                        else
                        start_try=start_mstb-1
                end if
c        write(*,*)'Hm -  my last try!'
        read(unit=2,rec=start_try) wtry,f0
        if (abs(wtry-wn).lt.abs(wl-wn)) then

                start_mstb=start_try
c                write(*,*)'New start_mstb, wn(start_mstb), delta :'
c		write(*,*) start_mstb,wtry,abs(wtry-wn)

		else

c		write(*,*)'Hm - wasnt a good idea!'
c		write(*,*)'New start_mstb, wn(start_mstb), delta :'
c		write(*,*) start_mstb,wtry,abs(wtry-wn)

        end if
c       -----------------------------------------------------------

c	WRITE(*,*)'=================================='
c	write(*,*)'MREAD: start_mstb:',start_mstb
c	write(*,*)'	  wavenumber='
c	write(*,109)wtry
c	WRITE(*,*)'=================================='

c	I read about 1 A more on both ends from mastertab!
c	=> start_mstb-2500 


c	2499 because I start loop with start_try+1 ! 
c	start_try=start_mstb-2499
c	Really? I don't thin so, because: if i=2500 =>
c	start_try+2500 =/= start_mstb !!! 
c	 	
	start_try=start_mstb-2500

c	write(*,*)'creating array ka ......'
c	write(*,*)'Start with record#:',start_try+1

c	UVES: check whether start_try becomes negative = red end of FTS

	IF (start_try.le.0.) THEN
		WRITE(*,*)
		WRITE(*,*) 'OK STOP, RED END OF I2 FTS REACHED'
		WRITE(*,*) 'Flag = 3'
		sizka2=3
		GOTO 9999
	END IF


c====================== WLKA & KA ARRAYS =========================

	do i=1,sizka

		read(unit=2,rec=start_try+i) wlka(i),kadummi
		ka(i)=kadummi
	end do

c====================== WLKA & KA ARRAYS =========================

c	write(*,*)'Wlka(2500)='
c	write(*,109)wlka(2500)
c	write(*,*)'CHECK THE IODINE, delta wlka(2500)-wn:'
c	write(*,109)ABS(wlka(2500)-wn)	

c	write(*,*)'wlka(2499)='
c	write(*,109)wlka(2499)
c	write(*,*)'wlka(2501)='
c       write(*,109)wlka(2501)


c	write(*,*)'Record start_try+2500=',start_try+2500
c	write(*,*)'SHOULD BE start_mstb!!!'
c	read(*,*)reply

c******** Writing wlka data to output file *******
c******** REMOVE THAT AFTERWARDS !!!! ************

c	open(31,file='./plot/chunk/wlka.dat',type='old')
c	do i=1,sizka
c		write(31,*)wlka(i)
c	end do
c	write(31,*)'************* NEXT CHUNK: *************'
c	close(31)


c*************************************************	
c	write(*,*)'.... finished!'
c	write(*,*)'Now creating f-vector....'
c	write(*,*)'With end-values of (wn,wn2):',wn,wn2

c	g-chunk starts(ends) with 5384.0 A and ends(starts) with 
c	5386.02 A. The rough shift to the mastertab is
c	1.52 A, => looking for wavenumber of 5384.0+1.52 A


c	wtry=1/((5384.0+1.52)*1E-8)

c	write(*,*)'starting with wavenumber for 5387.5 A:',wn
c	write(*,*)'starting with wavenumber for 5387.1 A:',wn
c	write(*,*)'ending with wavenumber for 5384.0+1.52 A:',wtry
	
c		write(*,*)'ka-wavenumber at i=1890',wlka(1890)
c	do i=2495,2505	
c		write(*,*)'ka-wavenumber at i=2500',wlka(2500)
c	end do
c		write(*,*)'ka-wavenumber at i=6833',wlka(6833)
c		write(*,*)'ka-wavenumber at i=7443',wlka(7443)
	
c	4943 pixel in ka = 88 pixel in g-observed
c	oversampling = 56.170455 
c	oversampling g/f = 5 
c	oversampling ka/f= 11.234091	
c	IP size=49, half size=24 in f-grid => 24*step in ka grid	

c	step=11.234091

	step=par(2)
	rest=step-int(step)

c	write(*,*)'Cut-off (p) of Phi:',p
c	write(*,*)'Old size of f, size of Phi:',sizf,sizfi

c	dealing with edge effects:

	sizf=sizf+2*p

c	write(*,*)'New size of f(=f+2*p):',sizf
c	original:
c	realkaindex=2500.-((sizfi/2)*step)
	startkaindex=2500.-(FLOAT(sizfi/2)*step)-(par(8)*(FLOAT(sizfi/2)**2.))
c	realkaindex=2500.-(((sizfi/2)*step)+(par(8)*((sizfi/2)**2.)

	realkaindex=startkaindex
	kaindex=int(realkaindex)

c	write(*,*)'..... looping on f-vector....'
c	write(*,*)'step (dispersion)=',step
c	write(*,*)'rest=',rest
c	write(*,*)'realkaindex=',realkaindex
c	write(*,*)'kaindex=',kaindex
	


	i=1
	ka0=ka(kaindex)
	ka1=ka(kaindex+1)
	diff=ka1-ka0
	rest=realkaindex-kaindex

c	write(*,*)'i=, ka0, ka1:',i,ka0,ka1
c	write(*,*)'realkaindex, rest=',realkaindex,rest

	wlka1=wlka(kaindex)
	wlka2=wlka(kaindex+1)

	diff_wn=wlka2-wlka1


	
	f(1)=ka0+diff*rest

c	write(*,*)'f(1)=',f(1)

cc	f_wn(1)=wlka1+diff_wn*rest

	
	do i=2,sizf

cc	a try:
		step=par(2)*i+(par(8)*(i**2))
cc		
c----
c		realkaindex=realkaindex+step
		realkaindex=startkaindex+step
c----	

		kaindex=int(realkaindex)
		rest=realkaindex-kaindex

		ka0=ka(kaindex)
		ka1=ka(kaindex+1)
		diff=ka1-ka0

		f(i)=ka0+diff*rest

		wlka1=wlka(kaindex)
	        wlka2=wlka(kaindex+1)

        	diff_wn=wlka2-wlka1

cc		f_wn(i)=wlka1+diff_wn*rest

c		if (i.lt.5) then
c			write(*,*)'i=, ka0, ka1:',i,ka0,ka1
c			write(*,*)'realkaindex, rest=',realkaindex,rest
c			write(*,*)'rest, diff, f(i):',rest,diff,f(i)
c		end if
		

	end do



c	write(*,*)'.... f-vector complete!'
c	write(*,*)'last kaindex=',kaindex

c	goto 9999

c	open(15,file='./plot/chunk/disp2.dat')
c
c		do i=25,534
c			write(15,109)f_wn(i)
c		end do
c
c	close(15)
c
c	write(*,*)'OK, check the wavenumbers...'
c	read(*,*)reply



c	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
c		CONVOLUTION
c	write(*,*)'Calling MCONV.........'
	CALL MCONV(f,sizf,sizg,q,f_conv,fi,sizfi,sizfconv)
c	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


c	write(*,*)'Size of oversamp. and conv. vector:',sizfconv

c	open(15,file='./plot/testf.dat')
c	do i=1,sizfconv
c		write(15,*)f_conv(i)
c	end do
c	close(15)
		



	gdummy=0.
	sizgsimu=0.
        count=1
        j=1

c	BUG?:           
c        do i=1,sizf
	do i=1,sizfconv

                gdummy=gdummy+f_conv(i)
c       write(*,*)'i ,count, j, g_new(i),gdummy',i,count,j,g_new(i),gdummy
                count=count+1
                if (count.gt.q) then
                        count=1
                        g_simu(j)=gdummy/q
c                       write(*,*)'gsimu(j)=',g_simu(j)
                        j=j+1
                        sizgsimu=sizgsimu+1
                        gdummy=0.
                end if

c	comment next line?
c		g_simu(i)=f_conv(i)                


        end do

9999	continue

c	open(unit=19,file='./plot/testf.dat')
c            do i=1,sizf
c                      write(19,*)f(i)
c             end do
c        close(19)
c	read(*,*)reply

 109 	format(2(3x,e25.15))

	CLOSE(01)

        return
        
 	end


