c===============================================================================
c

      subroutine params_opt(g_in,sizg_in,wl,wl2,s_in,fi_in,sizfi_in,
&     f_out,par_out,sizf_out,chunk,chi2,bary_out,order,npix)

c
c============================================================================
c	2010-09-24: UCLESX version clone of HIRESX version
c	2009-03-18: new input file 'chi2rms.in' for end of optimization
c	2009-03-18: include movepix for I2 wavenumber calib!
c	2008-08-12:
c	HIRESX version clone of HRSX version
c
c	6.5.2008:
c	HRSX version clone of: 2.7m / cs23   version 6
c
c	18.3.2008:
c	chunk wheighting scheme inserted, using sums of gradient
c	within chunk as weight, RV = weighted mean of chunks!!!
c
c	21.11.2007:
c	adding 2 new params for 2 widths of satellite gauss!
c
c	20.11.2006:
c	adding new par for additional 4 multigauss!
c	multi5 -> multi8
c
c	03.4.2000:
c	MEM starts now after IP par optimum reached
c	
c	18.1.2000:
c	widths of satellite Gaussians read from inputfile
c
c	22.6.99:
c	new data format (new reduced files)
c
c	21.4.99:
c
c	FULL MODELLING
c
c	09.04.99:
c
c	- star flag for RV measurements
c	- improved box-IP parameter search
c	- using ThAr Solution as startvalues for dispersion
c
c	15.09.98:
c	COMPLETE IODINE SPECTRUM (one chunk after the other!) 
c	using new inputfile INPUT2
c	chunksize variable
c
c	22.09.98:
c	using master_air.dat (mastertable with lambda_air correction)
c	no roughshift any more
c
c	02.11.98: 	sequence of parameters implemented
c	05.11.98:	First test with Parameter#7 =boxed default IP
c	08.11.98: 	Parameter #8 nonlinear term of dispersion
c			Parameter #6 now sigma of center gaussian in oversampl.
c			Parameter #9,#10 satellite gaussian amplitude
c	09.11.98:	Parameter #11,#12 satellite g. Nr.3 and 4
c	11.11.98:	Parameter #13 sigma of gaussian to convolve box IP
c	16.11.98	Parameter #14 width of Lorentz profile IP
c
c	Nov/Dec 2006:	more satellite gaussians: par#21 -> #28 !!
c===============================================================================
c  This program optimizes a set of parameters on a function of the hr data (f),
c  so that it fits the observed data (g), using parabolic interpolation (Brent 
c  method, cf Numerical Recipes p.395)  
c  Parameters include shift,
c  dispersion, slope, depth, and normalisation of the spectrum. 
c  and various IP profiles (Gaussian, multiple Gaussians, Box*Gauss,
c  Lorentz profile)
c
c     ------------------------------
c     description of main variables:
c
c     nb_params  constant       Number of parameters (=19)
c     maxsiz constant           Maximum size of the vectors (=1000)
c
c     par  Real 1-D array       Parameters vector: 
c((       par(1) = zero-point    (lbda0)
c         par(2) = dispersion    (d) linear term 
c         par(3) = slope         (s)
c         par(4) = depth         (a)
c         par(5) = normalisation (n)    ))
c         par(6) = sigma of default gauss
c         par(7) = box-parameter, width of box (conv.with gauss)
c         par(8) = non-linear (2nd order) term of disperison
c	  par(9) = amplitude of left wing gaussian
c	  par(10)= amplitude of right wing gaussian
c	  par(11)= amplitude of second left satellite gaussian
c	  par(12)= amplitude of second right satellite gaussian
c	  par(13)= width of gaussian for convolution with box(par#7)
c	  par(14)= width of Lorentz shaped IP
c	STELLAR PARAMETERS:
c         par(16)= SHIFT of stellar model in units of the mastb (waven)
c         par(17)= NORM of stellar model
c         par(18)= LINEDEPTH of stellar model 
c         par(19)= SLOPE of stellar model
c
c	  par(20)= star flag to ip_2.f & baryvel of mstb to mread.f
c
c	  par(21)= amplitude of 3rd left satellite gaussian
c	  par(22)= amplitude of 3rd right satellite gaussian
c         par(23)= amplitude of 4. left satellite gaussian
c         par(24)= amplitude of 4. right satellite gaussian
c         par(25)= amplitude of 5. left satellite gaussian
c         par(26)= amplitude of 5. right satellite gaussian
c         par(27)= amplitude of 6. left satellite gaussian
c         par(28)= amplitude of 6. right satellite gaussian
c
c	  par(29)= width of 1st sat gauss = par(9)
c	  par(30)= width of 2nd sat gauss = par(10)
c	  par(31)= width of 1st sat gauss = par(11)
c         par(32)= width of 2nd sat gauss = par(12)
c
c=============================================================================== 
c
c     g_in Real 1-D array       Discrete observed spectrum vector (input)
c     g        "                  "         "         "     "  (used in COMMON block)
c     wn   Real*8               Start wave number of vector g
c     wn2  Real*8               End wave number of vector g
c     f    Real 1-D array       Known discrete intrinsic spectrum vector 
c     fi   Real 1-D array       Default instrumental profile       
c     p    Integer              Cut-off on fi                      
c     sizg Integer              Size of g vector (px)                    
c     sizf Integer              Size of f vector (px)                    
c     sizf_out Integer          Size of f_out vector
c     
c       wl      REAL*8          Wavelength at chunk start
c       wl2     REAL*8          Wavelength at chunk end = start in waven.
c
c	ka     Real		chunk of mastertab 
c       sizka  Integer		size of ka
c	wlka   Real*8		wavenumber index for ka
c 	loop   Integer          loop variable, used to control iteration 
c    stopthat  Integer          Value of Chi2 where to stop the prg.
c
c     tol     Real               Accuracy requirement (cf. Num.Rec. p.397)
c     ax,bx,cx   Reals           Bracketing values for the function to be
c                                minimized
c     seq  Integer 1-D array     Sequence for parameter determination order
c     nb_loop Integer            Nb of loops on the sequence
c     fchi2   Real               Function to be minimized
c     dfchi2  Real               Derivative of fchi2/par(i)
c     start_mstb Integer         Start index in the master table
c     
c	chunk	Integer		 Number of chunk of spectrum	
c	chi2	REAL		 final CHI2 will be returned to IP prg.
c
c	f_wn	Real*8		 Array of correct wavenumbers for f-vector 
c	star	Integer		 flag for RV (0=no/1=yes)
c
c	ka2	REAL		 Array of stellar mstb
c	sizka2  INTEGER		 Size of ka2
c	wnka2	REAL*8		 wavenumber array of ka2
c	
c	stellar INTEGER	         star flag returned to ip_2.f 
c
c================================================================================

c	parameter(maxsiz=1000,nb_params=8,nb_seq_max=30,nb_loop_max=20)
c	parameter (const_wl_g=0.022965999320)
c	parameter (const_wl_g=0.0227841)
c       parameter (ratio_wn_g=0.074547)

 	IMPLICIT NONE

	integer maxsiz,nb_params,nb_seq_max,nb_loop_max,matsiz
	real*8 const_wl_g

	parameter (const_wl_g=0.0227841)
	parameter (maxsiz=1000,nb_params=40,nb_seq_max=30,nb_loop_max=20)
c	parameter (maxsiz=5000,nb_params=40,nb_seq_max=30,nb_loop_max=20)
c	parameter (matsiz=5000)
	    	   	
   	integer sizf,sizfi,sizfi_in,sizg,sizg_in,p,q,start_mstb,i,j,k,l
	integer seq(nb_seq_max),nb_seq,nb_loop,simu,parindex
	integer sizka,sizfconv,sizf_out,loop,count,nloop,stopthat
 	real par(nb_params),par_ini(nb_params),par_out(nb_params)
c	REAL*8 par(nb_params),par_ini(nb_params),par_out(nb_params)
ccc
	REAL safe
	integer par_seq(nb_params),sizbox

c
c	BUG? :
c	real f_out(nb_params)
c
c	real f(maxsiz)
	real f(5000),f_conv(5000),f_dummy(5000),f_out(5000)

	real*8 f_wn(5000)

c	real f_out(maxsiz),f_conv(maxsiz),f_dummy(maxsiz)
	real accu(nb_loop_max),resid(maxsiz)
c	real fi(50),tol,fret,div_interval
	real fi(maxsiz),tol,fret,div_interval
 	real g(maxsiz),g_in(maxsiz)
	real g_simu(5000)
	real s(maxsiz),s_in(maxsiz),fi_in(maxsiz)
	real g_samp(maxsiz),box(maxsiz)
c--------------------

cccc	a try 18.01.2000:
	REAL ka(40000),ka2(40000)
cccc	original:
cccc	REAL ka(20000),ka2(20000)
	
c	real*8 ka(10000)

	real matF(maxsiz,maxsiz)

cccc    a try 18.01.2000:
	real*8 wlka(40000),wnka2(40000)
cccc    original:
cccc	real*8 wlka(20000),wnka2(20000)
        
        real ax,bx,cx,fa,fb,fc,xmin,fchi2,dfchi2,rough_shift
	real chi2,chi2sum,chi2min,parmin,iterstep,chi2minlast
	real axchi2,bxchi2,cxchi2,tryx,ltchi2,rtchi2
	real*8 wn,wn2,wl,wl2
	real lb,rb,prec,gdummy,dummy,sdiff,leftsum,rightsum
c	real median,oldmediandelta,mediandelta
	real chi2steig,sdiffmin,chi2old,chi2stmin,pixl
	real mgauss1(1000),mgauss2(1000),mgauss3(1000),mgauss4(1000)
	real mgauss5(1000),mgauss6(1000)
	real bgauss(1000),sgauss(1000),billchi2
	real*8 realwlkaindex,wlka0,wlka1,diffwlka,restwlka
	real*8 wavenumber,startwlkaindex,stepwlka
	REAL*8 c,delta,stellarwn,rv(5000),rvmean,rvrms,rvsum
	REAL*8 wnka0,wnka1,diffwnka
	REAL*8 startwnkaindex,realwnkaindex,restwnka
	real mgpos(30)
	REAL*8 baryvel_mstb,baryvel_star
	REAL*8 bary_out
	REAL chi2_s(10),chi2_mean,chi2_sum,chi2_rms

c MEM:
	real X(maxsiz),fimem(maxsiz),g_mem(maxsiz),s_mem(maxsiz)
	real Xmed(maxsiz)
	real eta,x1,x2,x3,phimax
	real realip(50)

c-----

	integer niter,n1,index,sdiffminloop,sizgsimu
	integer chunk,one,dec,memstart,memruns,memstartloop
	integer center,width,flip,boxlow,boxhigh
	integer wlkaindex,wnkaindex,cien,mill

c	UVES:

	INTEGER order,npix(1000),border1,border2,minfound
	REAL star_guess,parsave1,parsave2
	INTEGER movepix

	character*1 reply,satellit
	character*25 ip_fn,data_fn,chi2_fn,stellarmstb
	character*2 order_fn
	character*25 templates

	integer star,sizka2,stellar
	INTEGER mstb_recs

c       Weight on the chunk by the gradient:
        REAL grad1(1000),grad2(1000),gradient(1000),weight(1000)
	REAL gradsum

c	new chi2rms input:
	REAL torbi,torbi2

c----------- COMMON BLOCK ------------------------------------
 
        common /convol/ sizf,sizg,p,q,fi,g,s,ka,ka2
        common /params/ par,mgpos,star
	common /sizes/ sizka,sizfi,sizka2

c-------------------------------------------------------------


c---------- FUNCTIONS ------------------------------------------

	external shift,disp,slope,depth,norm,gauss,wing1,wing2,boxip
	external disp2,multi1,multi2,multi3,multi4,boxip2,lorentz
	external st_shift,st_slope,st_depth,st_norm
	external multi5,multi6,multi7,multi8
	external multi9,multi10,multi11,multi12
	external width1,width2,width3,width4

c-------------------------------------------------------------



	write(*,*)'************ MPARAMS_OPT: ***********'
	write(*,*)'	Spectral Order= ',order
	write(*,*)'		Chunk Nr.=',chunk

c------	Speed of light in m.s-1

	c=2.99792458D+08

c------ hardcoded things have to vanish!

c 	   q=5
c	   p=24

c-------
	   div_interval=1.
c rogh shift between f and g, in Angstrom:
c	   rough_shift=1.518

c this is just a try:
c	rough_shift=1.52

	sdiffmin=999999.
	chi2old=99999999.

c flag for multiple gaussians:
	mgpos(10)=0.
	
c flag whether MEM is running or not:
	memruns=0

c Some of the input variables are turned into local variables, to be used in
c "common" blocks.
 
	   sizg=sizg_in
c local s and g variables: Indexes are inversed, as we work now with wavenumbers

c----------- OPENING INPUT FILE ------------------
c----------- OPENING INPUT FILE ------------------
c----------- OPENING INPUT FILE ------------------
c----------- OPENING INPUT FILE ------------------
c----------- OPENING INPUT FILE ------------------

cc	input2 = old version

c	open(14, file='./data/input2')

cc	input_main = new version (Sebastian's spectra)

	open(14, file='./data/input_main')


c======== jumping over old lines

100	format(A1)
	do i=1,25
		read(14,100)reply
	end do

c=========

c	write(*,*)'Turn around g-vector (y/n)?'
ccc	read(14,100)reply
ccc	read(14,100)reply

ccc	if (reply.eq.'y') then
ccc		write(*,*)'OK, turning g-vector around....'
ccc		else
ccc		write(*,*)'OK, turning g-vector NOT around...'
ccc	end if

c-----	TURNING G AND S VECTOR AROUND (WAVENUMBERS!)

	   do i=1,sizg
	      		g(i)=g_in((sizg-i)+1)
			s(i)=s_in((sizg-i)+1)
	   end do
c-----  RV Det. or PSF Reconstr.? 

	read(14,100)reply
	read(14,*)star
	
	if (star.eq.0) then

	write(*,*)'OK, PSF Reconstruction using pure IODINE!'
	read(14,100)reply
	read(14,100)reply
	read(14,100)reply
        read(14,100)reply
ccc	read(14,100)reply
ccc     read(14,100)reply
	
	par(20)=0.

	end if

	if (star.eq.1) then

	write(*,*)'OK, RV Determination using STELLAR spectrum!'
	read(14,100) reply
c	read(14,*) stellarmstb

c	new for UVES with template list:
	read(14,*) templates

c	OPEN(17,file='/data1/austral/mike/MCD/mastertab/'
c&//templates,type='old')
c	OPEN(17,file='/data2/austral/mike/HRS/mastertab/'//templates,type='old')
	OPEN(17,file='/data2/austral/mike/UCLES/mastertab/'
& //templates,type='old')

c	jumping to correct template for the order:

c	DO l=20,order-1
c		READ(17,*) reply
c	END DO 

c	OLD: UCLES orders 68 -> 118
c	NEW: UCLES orders 1 -> 51
	
        DO l=1,order-1
                READ(17,*) reply
        END DO

	READ(17,*) stellarmstb, mstb_recs

	WRITE(*,*) 'Spectral order= ',order

	WRITE(*,*) stellarmstb, mstb_recs


	CLOSE(17)

	write(*,*)'STELLAR MASTERTABLE=',stellarmstb

	IF (mstb_recs.eq.0) THEN
		WRITE(*,*)'OK, SKIPPING THIS ORDER COMPLETELY....'
		sizf_out=0
		DO l=1,41
			read(14,100)reply
		END DO
		CLOSE(14)
		WRITE(*,*)'Bary_star=',baryvel_star
		GOTO 99999
	END IF



	read(14,100)reply
	read(14,*)baryvel_mstb
	write(*,*)'Baryvel of stellarmstb:',baryvel_mstb

	baryvel_star=bary_out
	write(*,*)'Baryvel of star=',baryvel_star


	par(20)=1.

	end if


	read(14,100)reply
	read(14,*)memstart
	
ccc	write(*,*)'OK, MEM starts with loop#:',memstart

	write(*,*)'MEMstart= ',memstart

	if (memstart.eq.1) then
		write(*,*)'OK, IP Reconstr. USING MEM'
	else
		write(*,*)'OK, IP Reconstr. WITHOUT MEM'
	end if


	read(14,100)reply
	read(14,*)q
	read(14,100)reply
	read(14,*)p

	write(*,*)' q & p =',q,p
c	read(*,*)reply


	read(14,100)reply
cc	write(*,*)reply
c200 	format(I3)
	read(14,*)niter

	write(*,*)'OK, MEM iterations per loop= ',niter

	read(14,*)reply
	read(14,*)eta
	write(*,*)'OK, Eta= ',eta
	read(14,*)reply
	read(14,*)nloop
	write(*,*)'OK, Maximum number of Optimization Loops:',nloop

cc	just to let it run until chi2_rms < 0.1 and not changing input2!
cc	NOT GOOD, if chi2 is jumpy! Maximum number is necessary!
cc	nloop=nloop*10

cc	
	read(14,*)reply
	read(14,*)stopthat
	write(*,*)'OK, stop the optimization at chi2=',stopthat

	read(14,*)reply
	read(14,*) mgpos(1), mgpos(2)
c	read(14,*) mgpos(2) 

c--	new multi:

	read(14,*) mgpos(3), mgpos(4)
c        read(14,*) mgpos(4) 

c--	even newer:

	read(14,*) mgpos(11), mgpos(12)
c        read(14,*) mgpos(12)
	read(14,*) mgpos(14), mgpos(15)
c        read(14,*) mgpos(15)
	read(14,*) mgpos(17), mgpos(18)
c        read(14,*) mgpos(18)
        read(14,*) mgpos(20), mgpos(21)
c        read(14,*) mgpos(21)

c--
c	write(*,*)'Multiple gaussian positions:'
c	do i=1,4
c		write(*,*)mgpos(i)
c	end do
c	write(*,*) mgpos(11)
c	write(*,*) mgpos(12)
c	write(*,*) mgpos(14)
c	write(*,*) mgpos(15)


c---	NEW 18.01.2000:
c	new multi:
c---	using mgpos(5), mgpos(6), mgpos(13), mgpos(16) as sigma of multi Gaussians!!!

	read(14,*)reply
	read(14,*) mgpos(5)
	read(14,*) mgpos(6)
	read(14,*) mgpos(13)
	read(14,*) mgpos(16)
	read(14,*) mgpos(19)
        read(14,*) mgpos(22)	

c	write(*,*)' Width of satellite Gaussians (oversampled):' 
c	write(*,*) mgpos(5), mgpos(6), mgpos(13), mgpos(16)

c	read(*,*) reply

c---	new order dependent IP parameters:

	IF (order.eq.333) THEN
c	WRITE(*,*)'Order 33!!! setting new IP parms!'
c	positions:
	mgpos(1) = 15
	mgpos(2) = 35
	mgpos(3) = 17
	mgpos(4) = 33
	mgpos(11) = 19
	mgpos(12) = 31
	mgpos(14) = 18
	mgpos(15) = 32
c	widths:
	mgpos(5) = 5.5
	mgpos(6) = 3.0
	mgpos(13) = 2.7
	mgpos(16) = 1.0
	END IF

        IF (order.eq.336) THEN
c       WRITE(*,*)'Order 36!!! setting new IP parms!'
c       positions:
        mgpos(1) = 24
        mgpos(2) = 26  
        mgpos(3) = 14  
        mgpos(4) = 36
        mgpos(11) = 16
        mgpos(12) = 34
        mgpos(14) = 18
        mgpos(15) = 32
c       widths:
        mgpos(5) = 2.5
        mgpos(6) = 3.2
        mgpos(13) = 2.7
        mgpos(16) = 1.0
        END IF


c---	fitting sequence of parameters:

	read(14,*)reply
	read(14,*)reply
	read(14,*)reply

	read(14,*)par_seq(1)
	read(14,*)par_seq(2)
	read(14,*)par_seq(3)
	read(14,*)par_seq(4)
	read(14,*)par_seq(5)
	read(14,*)par_seq(6)
	read(14,*)par_seq(7)
	read(14,*)par_seq(8)
	read(14,*)par_seq(9)
	read(14,*)par_seq(10)
	read(14,*)par_seq(11)
	read(14,*)par_seq(12)
	read(14,*)par_seq(13)
	read(14,*)par_seq(14)
c--	new:
	read(14,*)par_seq(15)
	read(14,*)par_seq(16)
	read(14,*)par_seq(17)
	read(14,*)par_seq(18)
        read(14,*)par_seq(19)
	read(14,*)par_seq(20)
        read(14,*)par_seq(21)
        read(14,*)par_seq(22)
        read(14,*)par_seq(23)
c--	new widths:
	read(14,*)par_seq(24)
        read(14,*)par_seq(25)
	read(14,*)par_seq(26)
        read(14,*)par_seq(27)

c	write(*,*)'OK, Sequence of Parameters:'
c	do i=1,9
c		write(*,*)par_seq(i)
c	end do


	close(14)

c--------- closing INPUT file ---------------------------
c--------- closing INPUT file ---------------------------
c--------- closing INPUT file ---------------------------
c--------- closing INPUT file ---------------------------
c--------- closing INPUT file ---------------------------





c-----------
c	using mgpos(10) as flag whether multiple gauss or not
c	number of parameters now 25!!!

c	new multi & widths:
	do i=1,27
		if (par_seq(i).eq.9) then
			mgpos(10)=1.
		end if

		if (par_seq(i).eq.10) then
			mgpos(10)=1.
		end if

		if (par_seq(i).eq.11) then
                        mgpos(10)=1.
                end if
        
                if (par_seq(i).eq.12) then
                        mgpos(10)=1.
                end if

                if (par_seq(i).eq.21) then
                        mgpos(10)=1.
                end if

                if (par_seq(i).eq.22) then
                        mgpos(10)=1.
                end if

		if (par_seq(i).eq.23) then
                        mgpos(10)=1.
                end if

                if (par_seq(i).ge.24) then
                        mgpos(10)=1.
                end if

	end do



c Wave lenghth at the end of the g_in chunk, in Angstrom:
c	 write (6,*) ' sizg, wl, rough_shift:',sizg, wl,rough_shift

ccc	NOT anymore:
cc	Put back for UVES Mastertab:
cc	NOT with master_air2.dat :
cc	wl=wl+1.49
cc	wl2=wl2+1.49


	 wn2=1/(wl*1D-08)
	write (6,*) '  wl, wn2(g) :',wl,wn2

c	 wl=wl+sizg*const_wl_g
c	write(*,*)' wl(at end of g-chunk):',wl

c Wave number at the end of the g_in chunk (beginning of g chunk)
 	 wn=1./(wl2*1D-08)

c	YOU HAVE TO TURN AROUND ALSO THE IP !!!

	   sizfi=sizfi_in

	   do i=1,sizfi
c	      fi(i)=fi_in(sizfi-i+1)
	      fi(i)=fi_in(i)	
	   end do
c	write(*,*)'Phi(37)=',fi(37)	
c	   sizf=sizg*q

c	   write(*,*) ' Test 0: sizg,sizf,wn: ',sizg,sizf,wl

	   simu=0
		  
c	write(*,*)'Parameters are:',par

c	write(*,*)'Par_out array:',par_out

	
c ================================================================
c	
c		S	T	A	R	T
c
c ================================================================

	sizf=sizg*q

           par_ini(1)=0.
	   
ccc           par_ini(2)=1.
	   par_ini(2)=par_out(2)
ccc
           par_ini(3)=0.
           par_ini(4)=1.
           par_ini(5)=1.

	par_ini(6)=8.

c	par_ini(7)=0.
	par_ini(7)=18.

ccc	par_ini(8)=0.
	par_ini(8)=par_out(8)
ccc
	par_ini(9)=0.
	par_ini(10)=0.
	par_ini(11)=0.
	par_ini(12)=0.

c	par_ini(13)=10.
	par_ini(13)=53.
cc
c	par_ini(13)=0.01
c	par_ini(13)=8.
	par_ini(14)=8.

c	stellar par:
	par_ini(16)=0.
	par_ini(17)=1.
	par_ini(18)=1.
	par_ini(19)=0.

c	new multis:
	par_ini(21)=0.
	par_ini(22)=0.
	par_ini(23)=0.
        par_ini(24)=0.
	par_ini(25)=0.
        par_ini(26)=0.
        par_ini(27)=0.
        par_ini(28)=0.

c	new widths:
	par_ini(29)=mgpos(5)
	par_ini(30)=mgpos(5)
        par_ini(31)=mgpos(6)
        par_ini(32)=mgpos(6)


	if (chunk.eq.1) then
	   do i=1,nb_params
	    par(i)=par_ini(i)
	   end do
	end if

c	Parameters initialising (those which are not 
c	transfered from the previous chunk)

c	UVES try no transfer & roughshift:
	par(1)=0.

	par(2)=1.

c	I2 SHIFT:
c	UVES try not to do: 
c	par(1)=par_out(1)
c	IF (par(1).lt.-200) par(1)=0.
c	IF (par(1).gt.200) par(1)=0.
c
c	write(*,*)'--------> par(1)=',par(1)

	par(3)=0.
	par(4)=1.
	par(5)=1.

c	4.86 = sigma of Default Gauss
c	8.00 = sigma for HRS X
c	par(6)=4.86
	par(6)=8.00

ccc	par(8)=0.
	par(9)=0.
	par(10)=0.
	par(11)=0.
        par(12)=0.

c---	new multis:
	par(21)=0.
	par(22)=0.
	par(23)=0.
        par(24)=0.
        par(25)=0.
        par(26)=0.
        par(27)=0.
        par(28)=0.

c---	new widths:
        par(29)=mgpos(5)
        par(30)=mgpos(5)
	par(31)=mgpos(6)
        par(32)=mgpos(6)



cc	stellar parameters:
	par(16)=0.

c	par(16)=par_out(16)
c
c	IF (par(16).lt.-1000) par(16)=0.
c	IF (par(16).gt.1000) par(16)=0.

c	star_guess=par(16)

	par(17)=1.
	par(18)=1.
	par(19)=0.

	if (par(13).gt.500.) then
		par(13)=50.
	end if
	if (par(13).lt.-500) then
		par(13)=50.
	end if

	par(14)=8.
	
ccc	write(*,*)
ccc	write(*,*)'GO or NO GO ? Lets do it (y/n)?'
ccc	read(*,*)reply

ccc	Dispersion parameters now taken from ThAr fit:

	par(2)=par_out(2)
	par(8)=par_out(8)

ccc

ccc	goto 45



c-------------------------------------------------
c
c	M	R	E	A	D
c
c-------------------------------------------------

45	continue

	   CALL
& mread(sizf,sizg,sizfi,fi,g_simu,q,p,s,wn,wn2,
& start_mstb,par,ka,wlka,sizka,star,stellarmstb,
& ka2,sizka2,wnka2,baryvel_mstb,baryvel_star,
& mstb_recs)

	    write(*,*)'End of MREAD....'
c	    write(*,*)'ka(13)=',ka(13)	
c	    write(*,*)'Size of f=',sizf

c	write(*,*)'OK, baryvel_star=',baryvel_star
c	read(*,*)reply

c-----  UVES: check whether I2 FTS out of range:

c	if yes sizka2 = 3

	IF (sizka2.eq.3) then
		sizf_out=-1
		GOTO 99999
	END IF
	
c---	check if stellar mstb out of range

c	if yes sizka2=1 or 2

	if (star.eq.1) then

		if (sizka2.eq.1) then
			sizf_out=0
			goto 99999
		end if

		if (sizka2.eq.2) then
			sizf_out=1
			goto 99999
		end if

	end if
c---



            open(unit=14,file='./plot/chunk/testf.dat')
		write(*,*)'Size of oversampled vector:',sizf
	            do i=1,sizg
                      write(14,*)g_simu(i),g(i)
                    end do
             close(14)
c
	write(*,*)'Show me f_conv-vector!!!'
	write(*,*)'Calling est_params.......'

	CALL est_params(g,g_simu,sizg,s,par)
	
	call
& mread2(sizf,f,sizg,sizfi,fi,g,g_simu,q,p,s,wn,par,
& ka,sizka,fchi2,star,ka2,sizka2)

	write(*,*)' CHI2 after MREAD2=', fchi2

c	DO i=1,32
c	write(*,*) 'par(',i,') = ',par(i)
c	END DO

c	saving chi2 and shift-parameter:

	chi2old=fchi2
	parsave1=par(1)
	parsave2=par(16)

c============================================================================
c	jumping over ALL roughshifts:
	goto 55
c	jumping over stellar roughshift
c	GOTO 51

c----   loop on normalization: -----------------------------------

c        WRITE(*,*)'Par(5) before loop= ',par(5)

        chi2old=9E+33

       par(5)=par(5)-(25.*0.001)

       DO i=1,50
                par(5)=par(5)+0.001
        CALL
& mread2(sizf,f,sizg,sizfi,fi,g,g_simu,q,p,s,wn,par,
& ka,sizka,fchi2,star,ka2,sizka2)

        IF (fchi2.lt.chi2old) THEN
                chi2old=fchi2
                rough_shift=par(5)
        END IF

       END DO

        par(5)=rough_shift
        WRITE(*,*)'Ok , loop on par(5): chi2 min=',
& chi2old,' par(5)=',par(5)
c==============================================================================
c        write(*,*)'------> LOOPING ON IODINE ROUGH SHIFT:'
c        minfound=0
c---------------------------------------------------------------
c       do i=-1000,1000,10
c       do i=-100,100,1
c        do i=-200,200,5
c                par(1)=FLOAT(i)
c                CALL
c& mread2(sizf,f,sizg,sizfi,fi,g,g_simu,q,p,s,wn,par,
c& ka,sizka,fchi2,star,ka2,sizka2)
c
c               if (fchi2.lt.chi2old) then
c                        minfound=1
c                        chi2old=fchi2
c                        rough_shift=par(1)
c                end if
c        end do
c---------------------------------------------------------------
c        IF (minfound.eq.1) THEN
c        write(*,*)'Minimum found at shift',rough_shift,' chi2=',chi2old
c        par(1)=rough_shift
c        ELSE
c        write(*,*)' NO MINIMUM FOUND !!! '
c        par(1)=parsave1
c        END IF

c================================================================================
        if (star.eq.1) then
c	IF (chunk.eq.1) THEN

        write(*,*)'------> LOOPING ON STELLAR ROUGH SHIFT:'
c	orig:
c        border1=-200
c        border2=200
	border1=-1000
	border2=1000

c	IF (chunk.le.2) THEN
c		border1=-2000
c		border2=2000

c			ELSE

c		border1=star_guess-100
c		border2=star_guess+100

c		IF (border1.lt.-4000) border1=-2000
c		IF (border2.gt.4000) border2=2000 

c	END IF

c	new try for UVES:

c	WRITE(*,*)'LOOP BORDERS ARE: ',border1,border2

	minfound=0

c-------------------------------------
c	orig step=5
	DO i=border1,border2,5

                par(16)=FLOAT(i)
                CALL
& mread2(sizf,f,sizg,sizfi,fi,g,g_simu,q,p,s,wn,par,
& ka,sizka,fchi2,star,ka2,sizka2)

c		WRITE(*,*)'PAR(16)=',par(16),' CHI2=',fchi2

                if (fchi2.lt.chi2old) then
			minfound=1
                        chi2old=fchi2
                        rough_shift=par(16)
                end if
        end do
c-------------------------------------

		IF (minfound.eq.1) THEN
		write(*,*)'Minimum found at shift',rough_shift,' chi2=',chi2old
        	par(16)=rough_shift
		ELSE
		WRITE(*,*)'NO MINIUM FOUND!'
		par(16)=parsave2
		ENDIF

c^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
c
c	new second test loop to catch par(16) if it runs away:
c
c^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

c	IF (chunk.gt.2) THEN

c	parsave2=par(16)

c	CALL
c& mread2(sizf,f,sizg,sizfi,fi,g,g_simu,q,p,s,wn,par,
c& ka,sizka,fchi2,star,ka2,sizka2)

c		chi2old=fchi2	

cc		border1=parsave2-1000
cc		border2=parsave2+1000
c		border1=-2000
c		border2=2000

c		minfound=0

c		DO i=border1,border2,10

c		par(16)=FLOAT(i)

c		CALL
c& mread2(sizf,f,sizg,sizfi,fi,g,g_simu,q,p,s,wn,par,  
c& ka,sizka,fchi2,star,ka2,sizka2)

c		IF (fchi2*5.lt.chi2old) THEN
c			minfound=1
c			chi2old=fchi2
c			rough_shift=par(16)
c		END IF

c		END DO


c		IF (minfound.eq.0) THEN
c			WRITE(*,*)'NO NEW MINIMUM FOUND'	
c			par(16)=parsave2
c		ELSE
c			par(16)=rough_shift
c			WRITE(*,*)'NEW MINIMUM FOUND, SHIFT=',par(16),' CHI2=',chi2old
c		END IF
c
c	END IF

c^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

	END IF
c	END IF
c=============== end of stellar part ==========================================

c----	loop on normalization: -----------------------------------
c	jumping over this:
	goto 57
c	goto 55

	chi2old=9E+33

c	par(17)=0.98
	par(17)=0.90

	DO i=1,200,5
c	DO i=1,50
		par(17)=par(17)+0.001
        CALL
& mread2(sizf,f,sizg,sizfi,fi,g,g_simu,q,p,s,wn,par,
& ka,sizka,fchi2,star,ka2,sizka2)
c	WRITE(*,*)'par(17)= ',par(17),' chi2=',fchi2

	IF (fchi2.lt.chi2old) THEN
		chi2old=fchi2
		rough_shift=par(17)
	END IF

	END DO

	par(17)=rough_shift
	WRITE(*,*)'Ok , loop on par(17): 
& chi2 min=',chi2old,' par(17)=',par(17)


c------------------- end of stellar normalization loop -----------

51	CONTINUE

	CALL
& mread2(sizf,f,sizg,sizfi,fi,g,g_simu,q,p,s,wn,par,
& ka,sizka,fchi2,star,ka2,sizka2)

	chi2old=fchi2

57	CONTINUE
c^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
c	jumping over iodine rough shift:
c	goto 55

c	IF (chunk.eq.1) THEN

	write(*,*)'------> LOOPING ON IODINE ROUGH SHIFT:'
	minfound=0
c---------------------------------------------------------------
c	do i=-1000,1000,10
c	do i=-100,100,1
c	orig:
	do i=-200,200,5
		par(1)=FLOAT(i)
		CALL
& mread2(sizf,f,sizg,sizfi,fi,g,g_simu,q,p,s,wn,par,
& ka,sizka,fchi2,star,ka2,sizka2)
		
		if (fchi2.lt.chi2old) then
			minfound=1
			chi2old=fchi2
			rough_shift=par(1)
		end if
	end do
c---------------------------------------------------------------
	IF (minfound.eq.1) THEN
	write(*,*)'Minimum found at shift',rough_shift,' chi2=',chi2old
	par(1)=rough_shift
	ELSE
	write(*,*)' NO MINIMUM FOUND !!! '
	par(1)=parsave1
	END IF

c	END IF
c==========================================================================

c	jumping over this:
	goto 55

c----   loop on normalization: -----------------------------------

	WRITE(*,*)'Par(5) before loop= ',par(5)

        chi2old=9E+33

        par(5)=par(5)-(25.*0.001)

        DO i=1,50
                par(5)=par(5)+0.001
        CALL
& mread2(sizf,f,sizg,sizfi,fi,g,g_simu,q,p,s,wn,par,
& ka,sizka,fchi2,star,ka2,sizka2)

        IF (fchi2.lt.chi2old) THEN
                chi2old=fchi2
                rough_shift=par(5)
        END IF

        END DO

        par(5)=rough_shift
        WRITE(*,*)'Ok , loop on par(5): chi2 min=', 
& chi2old,' par(5)=',par(5)

c================================================================================

c	GOTO 55
c---------------------- par 2 ----------------------------
c        WRITE(*,*)'Par(2) before loop= ',par(2)

        chi2old=9E+33
        
        par(2)=par(2)-(25*0.001)
        
        DO i=1,50
                par(2)=par(2)+0.001
        CALL
& mread2(sizf,f,sizg,sizfi,fi,g,g_simu,q,p,s,wn,par,
& ka,sizka,fchi2,star,ka2,sizka2)

        IF (fchi2.lt.chi2old) THEN
                chi2old=fchi2
                rough_shift=par(2)
        END IF
        
        END DO
        
        par(2)=rough_shift
        WRITE(*,*)'Ok , loop on par(2): chi2 min='
& ,chi2old,' par(2)=',par(2)

c------------------------- par 3 -------------------------
c        WRITE(*,*)'Par(3) before loop= ',par(3)
                
        chi2old=9E+33

        par(3)=par(3)-(25*0.001) 

        DO i=1,50
                par(3)=par(3)+0.001
        CALL
& mread2(sizf,f,sizg,sizfi,fi,g,g_simu,q,p,s,wn,par,
& ka,sizka,fchi2,star,ka2,sizka2)
        
        IF (fchi2.lt.chi2old) THEN
                chi2old=fchi2
                rough_shift=par(3)
        END IF
        
        END DO
        
        par(3)=rough_shift
        WRITE(*,*)'Ok , loop on par(3): chi2 min='
& ,chi2old,' par(3)=',par(3) 
c------------------------- par 4 -------------------------
c        WRITE(*,*)'Par(4) before loop= ',par(4)
        
        chi2old=9E+33
        
        par(4)=par(4)-(50*0.001)

        DO i=1,100
                par(4)=par(4)+0.001
        CALL
& mread2(sizf,f,sizg,sizfi,fi,g,g_simu,q,p,s,wn,par,
& ka,sizka,fchi2,star,ka2,sizka2) 

        IF (fchi2.lt.chi2old) THEN
                chi2old=fchi2
                rough_shift=par(4)
        END IF

        END DO

        par(4)=rough_shift
        WRITE(*,*)'Ok , loop on par(4): chi2 min='
& ,chi2old,' par(4)=',par(4)
c------------------------- par 8 -------------------------
c        WRITE(*,*)'Par(8) before loop= ',par(8)

        chi2old=9E+33

        par(8)=par(8)-(50*0.000001)

        DO i=1,100
                par(8)=par(8)+0.000001
        CALL
& mread2(sizf,f,sizg,sizfi,fi,g,g_simu,q,p,s,wn,par,
& ka,sizka,fchi2,star,ka2,sizka2)

        IF (fchi2.lt.chi2old) THEN
                chi2old=fchi2
                rough_shift=par(8)
        END IF

        END DO

        par(8)=rough_shift
        WRITE(*,*)'Ok , loop on par(8): chi2 min='
& ,chi2old,' par(8)=',par(8)
c------------------------- par 6 -------------------------
c        WRITE(*,*)'Par(6) before loop= ',par(6)
c                
c        chi2old=9E+33
c
c        par(6)=par(6)-(50*0.01)
c
c        DO i=1,100
c                par(6)=par(6)+0.01
c        CALL
c& mread2(sizf,f,sizg,sizfi,fi,g,g_simu,q,p,s,wn,par,
c& ka,sizka,fchi2,star,ka2,sizka2)
c        WRITE(*,*)'Par6 =',par(6),' chi2= ',fchi2
c        IF (fchi2.lt.chi2old) THEN
c                chi2old=fchi2
c                rough_shift=par(6)
c        END IF
c
c        END DO
c                        
c        par(6)=rough_shift
c        WRITE(*,*)'Ok , loop on par(8): chi2 min='
c& ,chi2old,' par(6)=',par(6)
c-----------------------------------------------------------
c	star?

	IF (star.eq.1) THEN

c------------------------- par 18 -------------------------
c        WRITE(*,*)'Par(18) before loop= ',par(18)   

        chi2old=9E+33
        
        par(18)=par(18)-(50*0.001)
        
        DO i=1,100
                par(18)=par(18)+0.001
        CALL
& mread2(sizf,f,sizg,sizfi,fi,g,g_simu,q,p,s,wn,par,
& ka,sizka,fchi2,star,ka2,sizka2)  

        IF (fchi2.lt.chi2old) THEN
                chi2old=fchi2
                rough_shift=par(18)
        END IF
                
        END DO

        par(18)=rough_shift
        WRITE(*,*)'Ok , loop on par(18): chi2 min='
& ,chi2old,' par(18)=',par(18)
        
c------------------------- par 19 -------------------------
c        WRITE(*,*)'Par(19) before loop= ',par(19)
        
        chi2old=9E+33
        
        par(19)=par(19)-(50*0.001)   
        
        DO i=1,100
                par(19)=par(19)+0.001   
        CALL
& mread2(sizf,f,sizg,sizfi,fi,g,g_simu,q,p,s,wn,par,
& ka,sizka,fchi2,star,ka2,sizka2)
c        WRITE(*,*)'par(19)= ',par(19),' chi2=',fchi2

        IF (fchi2.lt.chi2old) THEN
                chi2old=fchi2
                rough_shift=par(19)
        END IF
        
        END DO
        
        par(19)=rough_shift
        WRITE(*,*)'Ok , loop on par(19): chi2 min='
& ,chi2old,' par(19)=',par(19)


c----------------- if star? end ------------------------------
	END IF

c================================================================================
c	write(*,*)'END of first guess on parameters!'
c	write(*,*)'---------------------------------'
c	write(*,*)
c	write(*,*)'Parameters:',par

c	open(unit=30,file='./plot/chunk/testg.dat')
c
c     	      do i=1,sizg*5
c              write(30,*)g(i),g_simu(i)
c              end do
c
c       close(30)
c	WRITE(*,*)' Output written to testg.dat ...'
c

c	END IF
c--------------- comment next line if you want simulated g-vector

c	goto 66
	goto 55	

c--------------------------------------------------------------------

	
	write(*,*)'OK, CREATING SIMULATED g-chunk!!!!'

	write(*,*)'Now calling MREAD2...'

	CALL
& mread2(sizf,f,sizg,sizfi,fi,g,g_simu,q,p,s,wn,par,
& ka,sizka,fchi2,star,ka2,sizka2)
	
	write(*,*)'Chi2=',fchi2
	write(*,*)'g_simu(13)=',g_simu(13)
        write(*,*)'Size of f=',sizf
	write(*,*)'Size of Phi=',sizfi
	write(*,*)'f(13)=',f(13)
	write(*,*)'Sizfconv=',sizfconv
	count=1
        j=1

        do i=1,440
                gdummy=gdummy+g_simu(i)
c       write(*,*)'i ,count, j, g_new(i),gdummy',i,count,j,g_new(i),gdummy
                count=count+1
                if (count.gt.q) then
                        count=1
                        g_samp(j)=gdummy/q
c                       write(*,*)'gsimu(j)=',g_simu(j)
			 j=j+1
                        gdummy=0.
                end if
        end do


		open(unit=30,file='./plot/gsimu_4.dat',type='new')
		do i=1,sizg
c			write(30,*)g(i),g_samp(i)
			write(30,*)g_samp(i)
		end do
		close(30)

	write(*,*)'OK, check it!'
c	read(*,*)reply



	write(*,*)'Parameters are now:'
	write(*,*)par

	read(*,*)reply

	CALL
& mread2(sizf,f,sizg,sizfi,fi,g,g_simu,q,p,s,wn,par,
& ka,sizka,fchi2,star,ka2,sizka2)

c55 	continue

c------------- testing new function -------------------------
66	continue
	write(*,*)' testing new function......'

c	ax=0.
c	par(6)=26.
c	par(9)=0.
c	par(10)=0.
c	par(11)=0.
c	par(12)=0.01

777	continue

	write(*,*)'Enter Parameter#14:'
	read(*,*)par(14)
	
c	write(*,*)'Enter BOX Parameter#7:'

c	read(*,*)par(7)

	write(*,*)'OK, par(14)=',par(14)
	
	ax=par(14)
	bx=par(14)


	call mgauss(ax,bx,cx,fa,fb,fc,lorentz)

c	open(32,file='./plot/test.dat')
c	do i=1,sizfi
c		write(32,*)fi(i)
c	end do
c	close(32)
c
c	read(*,*)reply

c	write(*,*)'Enter GAUSS Parameter#13:'
c       read(*,*)par(13)
c        write(*,*)'Enter BOX Parameter#7:'
c        
c        read(*,*)par(7)

c        write(*,*)'OK, par(7)=',par(7)

c        ax=par(7)
c        bx=par(7)
c	call mgauss(ax,bx,cx,fa,fb,fc,boxip2)



c	goto 777


c	ax=0.
c	bx=-0.0001

c	par(6)=0..
c	write(*,*)'Parameters #9=',par(9)

c	        CALL
c& mread2(sizf,f,sizg,sizfi,fi,g,g_simu,q,p,s,wn,par,ka,sizka,fchi2)

c	write(*,*)'Chi2=',fchi2
c	write(*,*)'Parameters #6=',par(6)

c	read(*,*)reply


c	par(6)=20.

c	        CALL
c& mread2(sizf,f,sizg,sizfi,fi,g,g_simu,q,p,s,wn,par,ka,sizka,fchi2)

c        write(*,*)'Chi2=',fchi2
c        write(*,*)'Parameters #6=',par(6)


c	read(*,*)reply

c	par(6)=25.
c	write(*,*)'Enter Amplitude of sat.gauss:'
c	read(*,*)par(9)
c	ax=par(9)
c	bx=par(9)+0.001

c	call mgauss(ax,bx,cx,fa,fb,fc,multi1)


c	read(*,*)reply


c	call mgauss(ax,bx,cx,fa,fb,fc,wing2)

c	write(*,*)' ....und??'
c	read(*,*)reply



	ax=0.00001
	bx=30.

	tol=0.0000001

	write(*,*)'Value of ax,bx,cx:',ax,bx,cx

	write(*,*)'Bracketing....'

c    ### Bracketing
        call mnbrak(ax,bx,cx,fa,fb,fc,lorentz)
        write(*,*) ' MNBRAK: [ax, bx ,cx] after bracketing:',ax,bx,cx

        write(*,*) ' And fa,fb,fc:',fa,fb,fc

	open(33,file='./plot/test.dat')
	do i=1,sizfi
		write(33,*)fi(i)
	end do
	close(33)

	read(*,*)reply

	write(*,*) ' AND NOW calling Brent....'
        call brent(fret,ax,bx,cx,boxip,tol,xmin)
        write(*,*) 'BRENT: Minimum found at:',xmin,' Chi2=',fret

        par(7)=xmin

        call
& mread2(sizf,f,sizg,sizfi,fi,g,g_simu,q,p,s,wn,par,
& ka,sizka,fchi2,star,ka2,sizka2)
  
        write(*,*)'Chi2 =',fchi2

	open(25,file='./plot/test.dat')
	do i=1,sizfi
		write(25,*)fi(i)
	end do
	close(25)




c	read(*,*)reply

c	open(20,file='./plot/g_simu.dat')
c		do i=1,450
c			write(20,*)g_simu(i)
c		end do
c	close(20)

        gdummy=0.
        sizgsimu=0.
        count=1
        j=1

        do i=1,sizfconv
                gdummy=gdummy+g_simu(i)
                count=count+1
                if (count.gt.5) then
                        count=1
                        g_samp(j)=gdummy/5.
                        j=j+1
                        sizgsimu=sizgsimu+1
                        gdummy=0.
                end if
        end do

        do i=1,sizg
           
                chi2=chi2+((g(i)-g_samp(i))**2.)/(s(i)**2)
       
        end do

	write(*,*)'CHI2=',chi2

	open(20,file='.plot/g_samp.dat')
	do i=1,sizg
		write(20,*)i,g(i),g_samp(i),s(i)
	end do
	close(20)

	
	read(*,*)reply

        write(*,*) ' AND NOW calling Brent....'
        call brent(fret,ax,bx,cx,boxip,tol,xmin)
	
	write(*,*) 'BRENT: Minimum found at:',xmin,' Chi2=',fret

	par(7)=xmin

	write(*,*) 'Parameters now:',par
	call 
& mread2(sizf,f,sizg,sizfi,fi,g,g_simu,q,p,s,wn,par,
& ka,sizka,fchi2,star,ka2,sizka2)
	write(*,*)'Chi2 with new boxedIP=',fchi2

	write(*,*)'test end'
	read(*,*)reply
c-------------------------------------------------------------------



55	continue

	flip=1

	write(*,*)'STARTING OPTIMIZATION ......' 

c************** L E T S   G O O O O O O O O !!!!!!!!!!!!!! ************

	cien=0
	mill=0
	
	if (order.lt.10) then
		order_fn='0'//CHAR(48+order)
		goto 805
	end if

	if (order.lt.20) then
                order_fn='1'//CHAR(48+(order-10))
                goto 805
        end if   

	if (order.lt.30) then
                order_fn='2'//CHAR(48+(order-20))
                goto 805
        end if

	if (order.lt.40) then
                order_fn='3'//CHAR(48+(order-30))
                goto 805
        end if

	if (order.lt.50) then
                order_fn='4'//CHAR(48+(order-40))
                goto 805
        end if

	if (order.lt.60) then
                order_fn='4'//CHAR(48+(order-50))
                goto 805
        end if


805 	CONTINUE

        if (chunk.lt.10) then
             ip_fn='ip_'//order_fn//'_00'//CHAR(48+chunk)//'.dat'
             data_fn='chunk_'//order_fn//'_00'//CHAR(48+chunk)//'.dat'
c			chi2_fn='chi2_000'//CHAR(48+chunk)//'.dat'
                        goto 809
        end if

        if (chunk.lt.20) then
                dec=1
                one=chunk-dec*10
                goto 808
        end if
        if (chunk.lt.30) then
                dec=2
                one=chunk-dec*10
                goto 808
        end if
        if (chunk.lt.40) then
                dec=3
                one=chunk-dec*10
                goto 808
        end if
        if (chunk.lt.50) then
                dec=4
                one=chunk-dec*10
                goto 808
        end if
        if (chunk.lt.60) then   
                dec=5
                one=chunk-dec*10
                goto 808
        end if
        if (chunk.lt.70) then   
                dec=6
                one=chunk-dec*10
                goto 808
        end if
        if (chunk.lt.80) then   
                dec=7
               one=chunk-dec*10
                goto 808
        end if
        if (chunk.lt.90) then   
                dec=8
                one=chunk-dec*10
                goto 808
        end if
	if (chunk.lt.100) then
                dec=9
                one=chunk-dec*10
                goto 808
        end if                      

	if (chunk.lt.110) then
		cien=1
c		dec=0
		one=chunk-cien*10
		ip_fn='ip_010'//CHAR(48+one)//'.dat'
                data_fn='chunk_010'//CHAR(48+one)//'.dat'   
                goto 809
	end if

	if (chunk.lt.120) then
		cien=1
                dec=1
                one=chunk-cien*10
                goto 808 
	end if
	

808 	continue

c	old CES version:
c        ip_fn='ip_0'//CHAR(48+dec)//CHAR(48+one)//'.dat'
c       data_fn='chunk_0'//CHAR(48+dec)//CHAR(48+one)//'.dat'
c        chi2_fn='chi2_0'//CHAR(48+dec)//CHAR(48+one)//'.dat'        

c	new UVES with orders:
	ip_fn='ip_'//order_fn//'_'//CHAR(48+cien)
& //CHAR(48+dec)//CHAR(48+one)//'.dat'
        data_fn='chunk_'//order_fn//'_'//CHAR(48+cien)
& //CHAR(48+dec)//CHAR(48+one)//'.dat'

809    continue

cc	open(unit=13, file='./plot/chunk/'//chi2_fn)


c****************************************************************************
c 	OPTIMIZATION LOOP 
c****************************************************************************
	loop=1


3000	continue



c--------------- PARAMETER SEQUENCE ------------------
c		27 parameters so far


c	do j=1,15
c	new multi:
c	do j=1,23
c	new widths:
	do j=1,27

c------------------------------------------------------------------------------

	if (par_seq(j).eq.1) then
c	if (loop.lt.memstart) then

c	write(*,*) ' ----> Optimizing the IODINE SHIFT'
c	write(*,*)'Parameter 1=',par(1)
  
c	20 instead of 50 and 5 for the later chunks
c	if (chunk.eq.1) then
c       ax=par(1)-20.
c        bx=par(1)+20.
c		else
c	2 instead 5

c	ax=par(1)-8.
	ax=par(1)-1.
	bx=par(1)
c	cx=par(1)+8.
	cx=par(1)+1.	

c	end if

	tol=0.000001
	
c	write(*,*) ' [, x , ] before bracketing:',ax,bx,cx

ccc    ### Bracketing
        call mnbrak(ax,bx,cx,fa,fb,fc,shift)
c        write(*,*) ' MNBRAK: [ax, bx ,cx] after bracketing:',ax,bx,cx
ccc	write(*,*) ' And fa,fb,fc:',fa,fb,fc
ccc	write(*,*) ' AND NOW calling Brent....'
	call brent(fret,ax,bx,cx,shift,tol,xmin)

c	write(*,*) 'BRENT: par1 Minimum found at:',xmin,' Chi2=',fret
	
	par(1)=xmin

c	IF (fret.gt.1E+06) GOTO 9555

ccc	write(*,*)'Parameters before MREAD2:',par

	call
& mread2(sizf,f,sizg,sizfi,fi,g,g_simu,q,p,s,wn,par,
& ka,sizka,fchi2,star,ka2,sizka2)

ccc	write(*,*)'Chi2 after MREAD2:',fchi2
c	write(*,*)'Parameters after MREAD2:', par

c	end if


	end if
c------------------------------------------------------------------------------
	if (star.eq.1) then
        if (par_seq(j).eq.16) then
c       if (loop.lt.memstart) then

c        write(*,*) ' ----> Optimizing the STELLAR SHIFT'
c        write(*,*)'Parameter 16=',par(16)

c       20 instead of 50 and 5 for the later chunks
c       if (chunk.eq.1) then
c       ax=par(16)-20.
c        bx=par(16)+20.
c               else
c	2 instead 5

c        ax=par(16)-8.
	ax=par(16)-1.
        bx=par(16)
c	cx=par(16)+8.
	cx=par(16)+1.

c       end if

        tol=0.000001

c       cx=Par(1)+50.
c        write(*,*) ' [, x , ] before bracketing:',ax,bx,cx

c    ### Bracketing
        call mnbrak(ax,bx,cx,fa,fb,fc,st_shift)
c        write(*,*) ' MNBRAK: [ax, bx ,cx] after bracketing:',ax,bx,cx
c        write(*,*) ' And fa,fb,fc:',fa,fb,fc
c        write(*,*) ' AND NOW calling Brent....'

        call brent(fret,ax,bx,cx,st_shift,tol,xmin)

c        write(*,*) 'BRENT: par16 Minimum found at:',xmin,' Chi2=',fret

        par(16)=xmin

c	IF (fret.gt.1E+06) GOTO 9555

c       write(*,*)'Parameters before MREAD2:',par

        call
& mread2(sizf,f,sizg,sizfi,fi,g,g_simu,q,p,s,wn,par,
& ka,sizka,fchi2,star,ka2,sizka2)

c       write(*,*)'Chi2 after MREAD2:',fchi2
c       write(*,*)'Parameters after MREAD2:', par

c       end if
        end if
	end if

c------------------------------------------------------------------------------


	if (par_seq(j).eq.4) then

c        write(*,*) ' -----> Optimizing the IODINE LINEDEPTH'
c        write(*,*)'Parameter 4=',par(4)

c        ax=par(4)-0.1 
	ax=par(4)-0.2
	bx=par(4)
c        cx=par(4)+0.1
        cx=par(4)+0.2

        tol=0.00001
        
c    ### Bracketing
        call mnbrak(ax,bx,cx,fa,fb,fc,depth)
c        write(*,*) 'MNBRAK: [ax, bx ,cx] after bracketing:',ax,bx,cx
c        write(*,*) ' And fa,fb,fc:',fa,fb,fc

        call brent(fret,ax,bx,cx,depth,tol,xmin)
c	write(*,*) 'BRENT: par 4 Minimum found at:',xmin,' Chi2=',fret
	par(4)=xmin

c	IF (fret.gt.1E+06) GOTO 9555

	call
& mread2(sizf,f,sizg,sizfi,fi,g,g_simu,q,p,s,wn,par,
& ka,sizka,fchi2,star,ka2,sizka2)

	end if
c------------------------------------------------------------------------------
	if (star.eq.1) then
        if (par_seq(j).eq.18) then

c        write(*,*) ' -----> Optimizing the STELLAR LINEDEPTH'
c        write(*,*)'Parameter 18=',par(18)

        ax=par(18)-0.2
c	ax=par(18)-0.2
	bx=par(18)
        cx=par(18)+0.2
c	cx=par(18)+0.2


        tol=0.0001
       
        
c    ### Bracketing
        call mnbrak(ax,bx,cx,fa,fb,fc,st_depth)
c        write(*,*) 'MNBRAK: [ax, bx ,cx] after bracketing:',ax,bx,cx
c        write(*,*) ' And fa,fb,fc:',fa,fb,fc
        call brent(fret,ax,bx,cx,st_depth,tol,xmin)
c        write(*,*) 'BRENT: par 18 Minimum found at:',xmin,' Chi2=',fret
        par(18)=xmin

c	IF (fret.gt.1E+06) GOTO 9555
	
        call
& mread2(sizf,f,sizg,sizfi,fi,g,g_simu,q,p,s,wn,par,
& ka,sizka,fchi2,star,ka2,sizka2)

        end if
	end if
c------------------------------------------------------------------------------

	if (par_seq(j).eq.5) then

c	write(*,*) ' -----> Optimizing the IODINE NORMALISATION'
c	write(*,*) 'Parameter #5=',par(5)
	
c	ax=par(5)-0.2
	ax=par(5)-0.2
	bx=par(5)
c	cx=par(5)+0.2
	cx=par(5)+0.2

	tol=0.0001  

c    ### Bracketing
        call mnbrak(ax,bx,cx,fa,fb,fc,norm)
c        write(*,*) 'MNBRAK: [ax, bx ,cx] after bracketing:',ax,bx,cx
cc        write(*,*) ' And fa,fb,fc:',fa,fb,fc   
        call brent(fret,ax,bx,cx,norm,tol,xmin)
c        write(*,*) 'BRENT: par5 Minimum found at:',xmin,' Chi2=',fret

	par(5)=xmin

c	IF (fret.gt.1E+06) GOTO 9555

	call
& mread2(sizf,f,sizg,sizfi,fi,g,g_simu,q,p,s,wn,par,
& ka,sizka,fchi2,star,ka2,sizka2)

	end if
c------------------------------------------------------------------------------
	if (star.eq.1) then
        if (par_seq(j).eq.17) then

c        write(*,*) ' -----> Optimizing the STELLAR NORMALISATION'
c        write(*,*) 'Parameter #17=',par(17)
        
        ax=par(17)-0.2
	bx=par(17)
        cx=par(17)+0.2
        
        tol=0.0001  
        
c    ### Bracketing  
        call mnbrak(ax,bx,cx,fa,fb,fc,st_norm)
c        write(*,*) 'MNBRAK: [ax, bx ,cx] after bracketing:',ax,bx,cx
c        write(*,*) ' And fa,fb,fc:',fa,fb,fc

        call brent(fret,ax,bx,cx,st_norm,tol,xmin)
c        write(*,*) 'BRENT: par17 Minimum found at:',xmin,' Chi2=',fret

        par(17)=xmin

c	IF (fret.gt.1E+06) GOTO 9555
        
        call
& mread2(sizf,f,sizg,sizfi,fi,g,g_simu,q,p,s,wn,par,
& ka,sizka,fchi2,star,ka2,sizka2)

        end if
	end if
c------------------------------------------------------------------------------

	if (par_seq(j).eq.2) then
c	if (loop.lt.memstart) then
c	if (loop.le.25) then

c        write(*,*) ' -----> Optimizing the DISPERSION'
c        write(*,*) 'Parameter #2=',par(2)

c        ax=par(2)-0.1 
c        bx=par(2)+0.1 
c	if (chunk.eq.1) then
c		ax=par(2)-0.5
c       	bx=par(2)+0.5

c		ax=par(2)-0.5
c		bx=par(2)
c               cx=par(2)+0.5

c			else
		ax=par(2)-0.1
		bx=par(2)
		cx=par(2)+0.1
c	end if

        tol=0.000001
        
c    ### Bracketing
        call mnbrak(ax,bx,cx,fa,fb,fc,disp)
c        write(*,*) 'MNBRAK: [ax, bx ,cx] after bracketing:',ax,bx,cx
c        write(*,*) ' And fa,fb,fc:',fa,fb,fc

        call brent(fret,ax,bx,cx,disp,tol,xmin)
c        write(*,*) 'BRENT: Minimum found at:',xmin,' Chi2=',fret
        
        par(2)=xmin

c	IF (fret.gt.1E+06) GOTO 9555	

        call
& mread2(sizf,f,sizg,sizfi,fi,g,g_simu,q,p,s,wn,par,
& ka,sizka,fchi2,star,ka2,sizka2)

c	end if
c	end if
	end if
c------------------------------------------------------------------------------
        if (par_seq(j).eq.8) then
c	if (loop.gt.25) then
c	if (loop.lt.memstart) then

c        write(*,*) ' -----> Optimizing the nonlinear DISPERSION term'
c        write(*,*) 'Parameter #8=',par(8)

	
c       ax=par(8)-0.00001
c	original 0.0001
	ax=par(8)-0.0001
	bx=par(8)
c        cx=par(8)+0.00001
	cx=par(8)+0.0001

c	ax=par(8)-0.0000001
c	cx=par(8)+0.0000001

c	write(*,*)'ax=',ax,' bx=',bx
c	write(*,*)'calling mgauss...'
c	call mgauss(ax,bx,cx,fa,fb,fc,disp2)

        tol=0.000001

c	read(*,*)reply
c	write(*,*)'calling MNBRAK....'

c    ### Bracketing
        call mnbrak(ax,bx,cx,fa,fb,fc,disp2)
c        write(*,*) 'MNBRAK: [ax, bx ,cx] after bracketing:',ax,bx,cx
c        write(*,*) ' And fa,fb,fc:',fa,fb,fc
c	read(*,*)reply

        call brent(fret,ax,bx,cx,disp2,tol,xmin)
c       write(*,*) 'BRENT: Minimum found at:',xmin,' Chi2=',fret

        par(8)=xmin

c	IF (fret.gt.1E+06) GOTO 9555

        call
& mread2(sizf,f,sizg,sizfi,fi,g,g_simu,q,p,s,wn,par,
& ka,sizka,fchi2,star,ka2,sizka2)

c        end if
c	end if
	end if
c--------------------------------------------------------------------------

c	par(3)=0.
c	goto 9000

	if (par_seq(j).eq.3) then 

c        write(*,*) ' -----> Optimizing the IODINE SLOPE'
c        write(*,*) 'Parameter #3=',par(3)
        
        ax=par(3)-0.2
	bx=par(3)
        cx=par(3)+0.2 
        
        tol=0.0001
        
c    ### Bracketing
        call mnbrak(ax,bx,cx,fa,fb,fc,slope)
c        write(*,*) 'MNBRAK: [ax, bx ,cx] after bracketing:',ax,bx,cx
c        write(*,*) ' And fa,fb,fc:',fa,fb,fc
        call brent(fret,ax,bx,cx,slope,tol,xmin)
c        write(*,*) 'BRENT: Minimum found at:',xmin,' Chi2=',fret
        
        par(3)=xmin

c	IF (fret.gt.1E+06) GOTO 9555

        call
& mread2(sizf,f,sizg,sizfi,fi,g,g_simu,q,p,s,wn,par,
& ka,sizka,fchi2,star,ka2,sizka2)

	end if	
c------------------------------------------------------------------------------
	if (star.eq.1) then
        if (par_seq(j).eq.19) then
        
c        write(*,*) ' -----> Optimizing the STELLAR SLOPE'
c        write(*,*) 'Parameter #19=',par(19)

        ax=par(19)-0.2
	bx=par(19)
        cx=par(19)+0.2
        
        tol=0.0001

c    ### Bracketing   
        call mnbrak(ax,bx,cx,fa,fb,fc,st_slope)
c        write(*,*) 'MNBRAK: [ax, bx ,cx] after bracketing:',ax,bx,cx
c        write(*,*) ' And fa,fb,fc:',fa,fb,fc
        call brent(fret,ax,bx,cx,st_slope,tol,xmin)
c        write(*,*) 'BRENT: Minimum found at:',xmin,' Chi2=',fret
        
        par(19)=xmin

c	IF (fret.gt.1E+06) GOTO 9555

        call
& mread2(sizf,f,sizg,sizfi,fi,g,g_simu,q,p,s,wn,par,
& ka,sizka,fchi2,star,ka2,sizka2)

        end if
	end if
c--------------------------------------------------------------------------
	if (par_seq(j).eq.6) then
cc	if (loop.lt.memstart) then
	if (memruns.eq.0) then

c	write(*,*) ' ------> Optimizing Par#6 IP(SINGLE GAUSS)'
c	write(*,*) 'Parameter #6=',par(6)
	
c	ax=par(6)-3.
c	bx=par(6)+3.

c****	to get specific IPs

	ax=par(6)-3.
	bx=par(6)
	cx=par(6)+3.

	tol=0.00001

c    ### Bracketing
        call mnbrak(ax,bx,cx,fa,fb,fc,gauss)
c        write(*,*) 'MNBRAK: [ax, bx ,cx] after bracketing:',ax,bx,cx
c       write(*,*) ' And fa,fb,fc:',fa,fb,fc

	IF (ax.gt.20.or.bx.gt.20.) THEN
		WRITE(*,*) 'OJO! ax or bx have too large values!' 
		ax=5.0
		bx=8.0
		cx=11.
	END IF


        call brent(fret,ax,bx,cx,gauss,tol,xmin)
c        write(*,*) 'BRENT: Minimum found at:',xmin,' Chi2=',fret

        par(6)=xmin

c	IF (fret.gt.1E+06) GOTO 9555

	call
& mread2(sizf,f,sizg,sizfi,fi,g,g_simu,q,p,s,wn,par,
& ka,sizka,fchi2,star,ka2,sizka2)

cc	end if
	end if
	end if
c-------------------------Parameter 14----------------------------------
        if (par_seq(j).eq.14) then
cc        if (loop.lt.memstart) then
 	if (memruns.eq.0) then
       
cc        write(*,*) ' ------> Optimizing default IP(LORENTZ)'
cc        write(*,*) 'Parameter #14=',par(14)

        ax=par(14)-5.
	bx=par(14)
        cx=par(14)+5.
        
        tol=0.0000001  
        
c    ### Bracketing
        call mnbrak(ax,bx,cx,fa,fb,fc,lorentz)
c        write(*,*) 'MNBRAK: [ax, bx ,cx] after bracketing:',ax,bx,cx
c        write(*,*) ' And fa,fb,fc:',fa,fb,fc
        call brent(fret,ax,bx,cx,lorentz,tol,xmin)
ccc        write(*,*) 'BRENT: Minimum found at:',xmin,' Chi2=',fret

        par(14)=xmin
        
c	IF (fret.gt.1E+06) GOTO 9555

        call
& mread2(sizf,f,sizg,sizfi,fi,g,g_simu,q,p,s,wn,par,
& ka,sizka,fchi2,star,ka2,sizka2)
        
cc	end if
        end if
        end if

c--------------------------Parameter 9 ---------------------------------

        if (par_seq(j).eq.9) then
cc	if (loop.lt.memstart) then
	if (memruns.eq.0) then

c	if (loop.gt.25) then

c        write(*,*) ' ------> Optimizing Par#9 MULTI1: WING'
c        write(*,*) 'Parameter #9=',par(9)

c        ax=par(9)-0.001
	bx=par(9)
c        cx=par(9)+0.001

	ax=par(9)-0.005
	cx=par(9)+0.005

        tol=0.0001

c    ### Bracketing
	safe=par(9)
        call mnbrak(ax,bx,cx,fa,fb,fc,multi1)
c        write(*,*) 'MNBRAK: [ax, bx ,cx] after bracketing:',ax,bx,cx

        IF (ax.gt.10.or.ax.lt.-10) THEN
                ax=safe-0.01
                bx=safe
                cx=safe+0.01
        END IF
        IF (cx.gt.10.or.cx.lt.-10) THEN
                ax=safe-0.01
                bx=safe
                cx=safe+0.01
        END IF

c        write(*,*) ' And fa,fb,fc:',fa,fb,fc

        call brent(fret,ax,bx,cx,multi1,tol,xmin)
c        write(*,*) 'BRENT: Minimum found at:',xmin,' Chi2=',fret
        
        par(9)=xmin
        
c	IF (fret.gt.1E+06) GOTO 9555

        call
& mread2(sizf,f,sizg,sizfi,fi,g,g_simu,q,p,s,wn,par,
& ka,sizka,fchi2,star,ka2,sizka2)

cc        end if
	end if
	end if
c--------------------------Parameter 29 ---------------------------------

        if (par_seq(j).eq.29) then
cc      if (loop.lt.memstart) then
        if (memruns.eq.0) then

c        write(*,*) ' ------> Optimizing Par#29 WIDTH OF MULTI1'
c        write(*,*) 'Parameter #29=',par(29)

        ax=par(29)-0.5
        bx=par(29)
        cx=par(29)+0.5

        tol=0.00001

c    ### Bracketing
        call mnbrak(ax,bx,cx,fa,fb,fc,width1)
c       write(*,*) 'MNBRAK: [ax, bx ,cx] after bracketing:',ax,bx,cx
c	write(*,*) ' And fa,fb,fc:',fa,fb,fc
c	IF (ax.lt.0) ax=0.
c	IF (cx.gt.20) cx=20.
c	IF (cx.lt.0) cx=0.
c       IF (ax.gt.20) ax=20.
c	IF (bx.gt.20) bx=20.
c        IF (bx.lt.0) bx=0.

        IF (ax.gt.20.or.ax.lt.0) THEN
                ax=par_ini(29)/2.
                bx=par_ini(29)
                cx=par_ini(29)*2.
        END IF
        IF (cx.gt.20.or.cx.lt.0) THEN
                ax=par_ini(29)/2.
                bx=par_ini(29)
                cx=par_ini(29)*2.
        END IF

        call brent(fret,ax,bx,cx,width1,tol,xmin)
c        write(*,*) 'BRENT: Minimum found at:',xmin,' Chi2=',fret

        par(29)=xmin

c       IF (fret.gt.1E+06) GOTO 9555

        call
& mread2(sizf,f,sizg,sizfi,fi,g,g_simu,q,p,s,wn,par,
& ka,sizka,fchi2,star,ka2,sizka2)

cc        end if
        end if
        end if

c--------------------------Parameter 30 ---------------------------------

        if (par_seq(j).eq.30) then
cc      if (loop.lt.memstart) then
        if (memruns.eq.0) then

c        write(*,*) ' ------> Optimizing Par#30 WIDTH OF MULTI2'
c        write(*,*) 'Parameter #30=',par(30)

        ax=par(30)-0.5
        bx=par(30)
        cx=par(30)+0.5

        tol=0.00001

c    ### Bracketing
        call mnbrak(ax,bx,cx,fa,fb,fc,width2)
c        write(*,*) 'MNBRAK: [ax, bx ,cx] after bracketing:',ax,bx,cx
c	write(*,*) ' And fa,fb,fc:',fa,fb,fc

c        IF (ax.lt.0) ax=0.
c        IF (cx.gt.20) cx=20.
c        IF (cx.lt.0) cx=0.
c        IF (ax.gt.20) ax=20.
c        IF (bx.gt.20) bx=20.
c        IF (bx.lt.0) bx=0.

        IF (ax.gt.20.or.ax.lt.0) THEN
               ax=par_ini(30)/2.
                bx=par_ini(30)
                cx=par_ini(30)*2.
        END IF
        IF (cx.gt.20.or.cx.lt.0) THEN
                ax=par_ini(30)/2.
                bx=par_ini(30)
                cx=par_ini(30)*2.
        END IF

        call brent(fret,ax,bx,cx,width2,tol,xmin)
c        write(*,*) 'BRENT: Minimum found at:',xmin,' Chi2=',fret

        par(30)=xmin

c       IF (fret.gt.1E+06) GOTO 9555

        call
& mread2(sizf,f,sizg,sizfi,fi,g,g_simu,q,p,s,wn,par,
& ka,sizka,fchi2,star,ka2,sizka2)


cc        end if
        end if
        end if

c--------------------------Parameter 31 ---------------------------------

        if (par_seq(j).eq.31) then
cc      if (loop.lt.memstart) then
        if (memruns.eq.0) then

c        write(*,*) ' ------> Optimizing Par#31 WIDTH OF MULTI3'
c        write(*,*) 'Parameter #31=',par(31)

        ax=par(31)-0.5
        bx=par(31)
        cx=par(31)+0.5

        tol=0.00001

c    ### Bracketing
        call mnbrak(ax,bx,cx,fa,fb,fc,width3)
c        write(*,*) 'MNBRAK: [ax, bx ,cx] after bracketing:',ax,bx,cx
c	write(*,*) ' And fa,fb,fc:',fa,fb,fc

c        IF (ax.lt.0) ax=0.
c       IF (cx.gt.20) cx=20.
c        IF (cx.lt.0) cx=0.
c        IF (ax.gt.20) ax=20.
c        IF (bx.gt.20) bx=20.
c        IF (bx.lt.0) bx=0.

        IF (ax.gt.20.or.ax.lt.0) THEN
                ax=par_ini(31)/2.
                bx=par_ini(31)
                cx=par_ini(31)*2.
        END IF
        IF (cx.gt.20.or.cx.lt.0) THEN
                ax=par_ini(31)/2.
                bx=par_ini(31)
                cx=par_ini(31)*2.
        END IF

        call brent(fret,ax,bx,cx,width3,tol,xmin)
c        write(*,*) 'BRENT: Minimum found at:',xmin,' Chi2=',fret

        par(31)=xmin

c       IF (fret.gt.1E+06) GOTO 9555

        call
& mread2(sizf,f,sizg,sizfi,fi,g,g_simu,q,p,s,wn,par,
& ka,sizka,fchi2,star,ka2,sizka2)


cc        end if
        end if
        end if

c--------------------------Parameter 32 ---------------------------------

        if (par_seq(j).eq.32) then
cc      if (loop.lt.memstart) then
        if (memruns.eq.0) then

c        write(*,*) ' ------> Optimizing Par#32 WIDTH OF MULTI4'
c        write(*,*) 'Parameter #32=',par(32)

        ax=par(32)-0.5
        bx=par(32)
        cx=par(32)+0.5

        tol=0.00001

c    ### Bracketing
        call mnbrak(ax,bx,cx,fa,fb,fc,width4)
c        write(*,*) 'MNBRAK: [ax, bx ,cx] after bracketing:',ax,bx,cx
c	write(*,*) ' And fa,fb,fc:',fa,fb,fc

c        IF (ax.lt.0) ax=0.
c        IF (cx.gt.20) cx=20.
c        IF (cx.lt.0) cx=0.
c        IF (ax.gt.20) ax=20.
c        IF (bx.gt.20) bx=20.
c        IF (bx.lt.0) bx=0.

	
        IF (ax.gt.20.or.ax.lt.0) THEN
                ax=par_ini(32)/2.
                bx=par_ini(32)
                cx=par_ini(32)*2.
        END IF
        IF (cx.gt.20.or.cx.lt.0) THEN
                ax=par_ini(32)/2.
                bx=par_ini(32)
                cx=par_ini(32)*2.
        END IF

        call brent(fret,ax,bx,cx,width4,tol,xmin)
c        write(*,*) 'BRENT: Minimum found at:',xmin,' Chi2=',fret

        par(32)=xmin

c       IF (fret.gt.1E+06) GOTO 9555

        call
& mread2(sizf,f,sizg,sizfi,fi,g,g_simu,q,p,s,wn,par,
& ka,sizka,fchi2,star,ka2,sizka2)


cc        end if
        end if
        end if

c--------------------------Parameter 10 -------------------------------

        if (par_seq(j).eq.10) then
cc        if (loop.lt.memstart) then
	if (memruns.eq.0) then

c	if (loop.gt.25) then
c        write(*,*) ' ------> Optimizing Par#10 MULTI2: WING'
c        write(*,*) 'Parameter #10=',par(10)

c        ax=par(10)-0.001
	bx=par(10)
c        cx=par(10)+0.001

	ax=par(10)-0.005
	cx=par(10)+0.005

        tol=0.0001
        
c    ### Bracketing
	safe=par(10)
        call mnbrak(ax,bx,cx,fa,fb,fc,multi2)
c        write(*,*) 'MNBRAK: [ax, bx ,cx] after bracketing:',ax,bx,cx
c        write(*,*) ' And fa,fb,fc:',fa,fb,fc

        IF (ax.gt.10.or.ax.lt.-10) THEN
                ax=safe-0.01
                bx=safe
                cx=safe+0.01
        END IF
        IF (cx.gt.10.or.cx.lt.-10) THEN
                ax=safe-0.01
                bx=safe
                cx=safe+0.01
        END IF

        call brent(fret,ax,bx,cx,multi2,tol,xmin)
c        write(*,*) 'BRENT: Minimum found at:',xmin,' Chi2=',fret
        
        par(10)=xmin

c	IF (fret.gt.1E+06) GOTO 9555

        call
& mread2(sizf,f,sizg,sizfi,fi,g,g_simu,q,p,s,wn,par,
& ka,sizka,fchi2,star,ka2,sizka2)


cc	end if
        end if
	end if
c--------------------------Parameter 11 -------------------------------

        if (par_seq(j).eq.11) then

cc	if (loop.gt.40) then

cc	if (loop.lt.memstart) then
	if (memruns.eq.0) then

c       write(*,*) ' ------> Optimizing Par#11 (multigaussian)'
c        write(*,*) 'Parameter #11=',par(11)

        ax=par(11)-0.005
        bx=par(11)
	cx=par(11)+0.005

        tol=0.0001

c    ### Bracketing
	safe=par(11)
        call mnbrak(ax,bx,cx,fa,fb,fc,multi3)
c        write(*,*) 'MNBRAK: [ax, bx ,cx] after bracketing:',ax,bx,cx
c        write(*,*) ' And fa,fb,fc:',fa,fb,fc

        IF (ax.gt.10.or.ax.lt.-10) THEN
                ax=safe-0.01
                bx=safe
                cx=safe+0.01
        END IF
        IF (cx.gt.10.or.cx.lt.-10) THEN
                ax=safe-0.01
                bx=safe
                cx=safe+0.01
        END IF

        call brent(fret,ax,bx,cx,multi3,tol,xmin)
c        write(*,*) 'BRENT: Minimum found at:',xmin,' Chi2=',fret

        par(11)=xmin

c	IF (fret.gt.1E+06) GOTO 9555

        call
& mread2(sizf,f,sizg,sizfi,fi,g,g_simu,q,p,s,wn,par,
& ka,sizka,fchi2,star,ka2,sizka2)

cc        end if
	end if
	end if
c--------------------------Parameter 12 -------------------------------
        
        if (par_seq(j).eq.12) then

cc        if (loop.gt.40) then

cc	if (loop.lt.memstart) then
	if (memruns.eq.0) then

c        write(*,*) ' ------> Optimizing Par#12 (multigaussian)'
c        write(*,*) 'Parameter #12=',par(12)
        
        ax=par(12)-0.005
        bx=par(12)
	cx=par(12)+0.005
        
        tol=0.0001

c    ### Bracketing
	safe = par(12)
        call mnbrak(ax,bx,cx,fa,fb,fc,multi4)
c        write(*,*) 'MNBRAK: [ax, bx ,cx] after bracketing:',ax,bx,cx
c        write(*,*) ' And fa,fb,fc:',fa,fb,fc

        IF (ax.gt.10.or.ax.lt.-10) THEN
                ax=safe-0.01
                bx=safe
                cx=safe+0.01
        END IF
        IF (cx.gt.10.or.cx.lt.-10) THEN
		ax=safe-0.01
                bx=safe
                cx=safe+0.01
        END IF

        call brent(fret,ax,bx,cx,multi4,tol,xmin)
c        write(*,*) 'BRENT: Minimum found at:',xmin,' Chi2=',fret
        
        par(12)=xmin

c	IF (fret.gt.1E+06) GOTO 9555
        
        call
& mread2(sizf,f,sizg,sizfi,fi,g,g_simu,q,p,s,wn,par,
& ka,sizka,fchi2,star,ka2,sizka2)
        
cc        end if
	end if
	end if
c------------------ Parameter 21 ----------------------------------------

        if (par_seq(j).eq.21) then

        if (memruns.eq.0) then

ccc        write(*,*) ' ------> Optimizing Par#21 (multigaussian)'
c        write(*,*) 'Parameter #21=',par(21)

        ax=par(21)-0.005
        bx=par(21)
        cx=par(21)+0.005

        tol=0.0001

c    ### Bracketing
	safe=par(21)
        call mnbrak(ax,bx,cx,fa,fb,fc,multi5)
c        write(*,*) 'MNBRAK: [ax, bx ,cx] after bracketing:',ax,bx,cx
c        write(*,*) ' And fa,fb,fc:',fa,fb,fc

        IF (ax.gt.10.or.ax.lt.-10) THEN
                ax=safe-0.01
                bx=safe
                cx=safe+0.01
        END IF
        IF (cx.gt.10.or.cx.lt.-10) THEN
                ax=safe-0.01
                bx=safe
                cx=safe+0.01
        END IF

        call brent(fret,ax,bx,cx,multi5,tol,xmin)
c        write(*,*) 'BRENT: Minimum found at:',xmin,' Chi2=',fret

        par(21)=xmin

c       IF (fret.gt.1E+06) GOTO 9555

        call
& mread2(sizf,f,sizg,sizfi,fi,g,g_simu,q,p,s,wn,par,
& ka,sizka,fchi2,star,ka2,sizka2)

cc        end if
        end if
        end if

c------------------- Parameter 22 ---------------------------------------

        if (par_seq(j).eq.22) then

        if (memruns.eq.0) then

ccc        write(*,*) ' ------> Optimizing Par#22 (multigaussian)'
c        write(*,*) 'Parameter #22=',par(22)

        ax=par(22)-0.005
        bx=par(22)
        cx=par(22)+0.005

        tol=0.0001

c    ### Bracketing
	safe=par(22)
        call mnbrak(ax,bx,cx,fa,fb,fc,multi6)
c        write(*,*) 'MNBRAK: [ax, bx ,cx] after bracketing:',ax,bx,cx
c        write(*,*) ' And fa,fb,fc:',fa,fb,fc

        IF (ax.gt.10.or.ax.lt.-10) THEN
                ax=safe-0.01
                bx=safe
                cx=safe+0.01
        END IF
        IF (cx.gt.10.or.cx.lt.-10) THEN
                ax=safe-0.01
                bx=safe
                cx=safe+0.01
        END IF

        call brent(fret,ax,bx,cx,multi6,tol,xmin)
c        write(*,*) 'BRENT: Minimum found at:',xmin,' Chi2=',fret

        par(22)=xmin

        call
& mread2(sizf,f,sizg,sizfi,fi,g,g_simu,q,p,s,wn,par,
& ka,sizka,fchi2,star,ka2,sizka2)

        end if
        end if
 
c------------------- Parameter 23 ---------------------------------------

        if (par_seq(j).eq.23) then

        if (memruns.eq.0) then

c        write(*,*) ' ------> Optimizing Par#23 (multigaussian)'
c        write(*,*) 'Parameter #23=',par(23)

        ax=par(23)-0.005
        bx=par(23)
        cx=par(23)+0.005

        tol=0.0001

c    ### Bracketing
	safe=par(23)
        call mnbrak(ax,bx,cx,fa,fb,fc,multi7)
c        write(*,*) 'MNBRAK: [ax, bx ,cx] after bracketing:',ax,bx,cx
c        write(*,*) ' And fa,fb,fc:',fa,fb,fc

        IF (ax.gt.10.or.ax.lt.-10) THEN
                ax=safe-0.01
                bx=safe
                cx=safe+0.01
        END IF
        IF (cx.gt.10.or.cx.lt.-10) THEN
                ax=safe-0.01
                bx=safe
                cx=safe+0.01
        END IF

        call brent(fret,ax,bx,cx,multi7,tol,xmin)
c        write(*,*) 'BRENT: Minimum found at:',xmin,' Chi2=',fret

        par(23)=xmin

        call
& mread2(sizf,f,sizg,sizfi,fi,g,g_simu,q,p,s,wn,par,
& ka,sizka,fchi2,star,ka2,sizka2)

        end if
        end if

c------------------- Parameter 24 ---------------------------------------

        if (par_seq(j).eq.24) then

        if (memruns.eq.0) then

ccc        write(*,*) ' ------> Optimizing Par#24 (multigaussian)'
c        write(*,*) 'Parameter #24=',par(24)

        ax=par(24)-0.005
        bx=par(24)
        cx=par(24)+0.005

        tol=0.0001

c    ### Bracketing
	safe=par(24)
        call mnbrak(ax,bx,cx,fa,fb,fc,multi8)
c        write(*,*) 'MNBRAK: [ax, bx ,cx] after bracketing:',ax,bx,cx
c        write(*,*) ' And fa,fb,fc:',fa,fb,fc

        IF (ax.gt.10.or.ax.lt.-10) THEN
                ax=safe-0.01
                bx=safe
                cx=safe+0.01
        END IF
        IF (cx.gt.10.or.cx.lt.-10) THEN
                ax=safe-0.01
                bx=safe
                cx=safe+0.01
        END IF

        call brent(fret,ax,bx,cx,multi8,tol,xmin)
c        write(*,*) 'BRENT: Minimum found at:',xmin,' Chi2=',fret

        par(24)=xmin

        call
& mread2(sizf,f,sizg,sizfi,fi,g,g_simu,q,p,s,wn,par,
& ka,sizka,fchi2,star,ka2,sizka2)

        end if
        end if

c------------------- Parameter 25 ---------------------------------------

        if (par_seq(j).eq.25) then

        if (memruns.eq.0) then

ccc        write(*,*) ' ------> Optimizing Par#25 (multigaussian)'
ccc        write(*,*) 'Parameter #25=',par(25)

        ax=par(25)-0.005
        bx=par(25)
        cx=par(25)+0.005

        tol=0.0001

c    ### Bracketing
	safe=par(25)
        call mnbrak(ax,bx,cx,fa,fb,fc,multi9)
c        write(*,*) 'MNBRAK: [ax, bx ,cx] after bracketing:',ax,bx,cx
c        write(*,*) ' And fa,fb,fc:',fa,fb,fc

        IF (ax.gt.10.or.ax.lt.-10) THEN
                ax=safe-0.01
                bx=safe
                cx=safe+0.01
        END IF
        IF (cx.gt.10.or.cx.lt.-10) THEN
                ax=safe-0.01
                bx=safe
                cx=safe+0.01
        END IF

        call brent(fret,ax,bx,cx,multi9,tol,xmin)
ccc        write(*,*) 'BRENT: Minimum found at:',xmin,' Chi2=',fret

        par(25)=xmin

        call
& mread2(sizf,f,sizg,sizfi,fi,g,g_simu,q,p,s,wn,par,
& ka,sizka,fchi2,star,ka2,sizka2)

        end if
        end if

c------------------- Parameter 26 ---------------------------------------
        if (par_seq(j).eq.26) then
        if (memruns.eq.0) then

ccc        write(*,*) ' ------> Optimizing Par#26 (multigaussian)'
ccc        write(*,*) 'Parameter #26=',par(26)

        ax=par(26)-0.005
        bx=par(26)
        cx=par(26)+0.005
        tol=0.0001

c    ### Bracketing
	safe=par(26)
        call mnbrak(ax,bx,cx,fa,fb,fc,multi10)
c        write(*,*) 'MNBRAK: [ax, bx ,cx] after bracketing:',ax,bx,cx
c        write(*,*) ' And fa,fb,fc:',fa,fb,fc

        IF (ax.gt.10.or.ax.lt.-10) THEN
                ax=safe-0.01
                bx=safe
                cx=safe+0.01
        END IF
        IF (cx.gt.10.or.cx.lt.-10) THEN
                ax=safe-0.01
                bx=safe
                cx=safe+0.01
        END IF

        call brent(fret,ax,bx,cx,multi10,tol,xmin)
ccc        write(*,*) 'BRENT: Minimum found at:',xmin,' Chi2=',fret

        par(26)=xmin
        call
& mread2(sizf,f,sizg,sizfi,fi,g,g_simu,q,p,s,wn,par,
& ka,sizka,fchi2,star,ka2,sizka2)
        end if
        end if

c------------------- Parameter 27 ---------------------------------------
        if (par_seq(j).eq.27) then
        if (memruns.eq.0) then

c        write(*,*) ' ------> Optimizing Par#27 (multigaussian)'
c        write(*,*) 'Parameter #27=',par(27)

        ax=par(27)-0.005
        bx=par(27)
        cx=par(27)+0.005
        tol=0.0001

c    ### Bracketing
	safe=par(27)
        call mnbrak(ax,bx,cx,fa,fb,fc,multi11)
c        write(*,*) 'MNBRAK: [ax, bx ,cx] after bracketing:',ax,bx,cx
c        write(*,*) ' And fa,fb,fc:',fa,fb,fc

        IF (ax.gt.10.or.ax.lt.-10) THEN
                ax=safe-0.01
                bx=safe
                cx=safe+0.01
        END IF
        IF (cx.gt.10.or.cx.lt.-10) THEN
                ax=safe-0.01
                bx=safe
                cx=safe+0.01
        END IF

        call brent(fret,ax,bx,cx,multi11,tol,xmin)
ccc        write(*,*) 'BRENT: Minimum found at:',xmin,' Chi2=',fret

        par(27)=xmin
        call
& mread2(sizf,f,sizg,sizfi,fi,g,g_simu,q,p,s,wn,par,
& ka,sizka,fchi2,star,ka2,sizka2)
        end if
        end if
c------------------- Parameter 28 ---------------------------------------
        if (par_seq(j).eq.28) then
        if (memruns.eq.0) then

c        write(*,*) ' ------> Optimizing Par#28 (multigaussian)'
c        write(*,*) 'Parameter #28=',par(28)

        ax=par(28)-0.005
        bx=par(28)
        cx=par(28)+0.005
        tol=0.0001

c    ### Bracketing
	safe=par(28)
        call mnbrak(ax,bx,cx,fa,fb,fc,multi12)
c        write(*,*) 'MNBRAK: [ax, bx ,cx] after bracketing:',ax,bx,cx
c        write(*,*) ' And fa,fb,fc:',fa,fb,fc

        IF (ax.gt.10.or.ax.lt.-10) THEN
                ax=safe-0.01
                bx=safe
                cx=safe+0.01
        END IF
        IF (cx.gt.10.or.cx.lt.-10) THEN
                ax=safe-0.01
                bx=safe
                cx=safe+0.01
        END IF

        call brent(fret,ax,bx,cx,multi12,tol,xmin)
ccc        write(*,*) 'BRENT: Minimum found at:',xmin,' Chi2=',fret

        par(28)=xmin
        call
& mread2(sizf,f,sizg,sizfi,fi,g,g_simu,q,p,s,wn,par,
& ka,sizka,fchi2,star,ka2,sizka2)
        end if
        end if

c------------------ Parameter #7 & 13 -----------------------------------

        if (par_seq(j).eq.7) then


cc	if (loop.lt.memstart) then
	if (memruns.eq.0) then

	if (loop.eq.6) goto 35000

	if (flip.eq.1) then

cc        write(*,*) ' ------> Optimizing BOX for (Box*Gauss)'
cc        write(*,*) 'Parameter #7=',par(7)

c	if (chunk.eq.1.and.loop.lt.6) then
c		ax=219.
c		bx=0.
c	else
c		ax=par(7)-5.
c		ax=par(7)-10.

		ax=par(7)-30.
		bx=par(7)
		cx=par(7)+30.

c	end if


c        tol=0.00001
	tol=0.000001

c    ### Bracketing
c	if (chunk.eq.1) then
        call mnbrak(ax,bx,cx,fa,fb,fc,boxip)
c	end if
c        write(*,*) 'MNBRAK: [ax, bx ,cx] after bracketing:',ax,bx,cx
c        write(*,*) ' And fa,fb,fc:',fa,fb,fc

        call brent(fret,ax,bx,cx,boxip,tol,xmin)

cc       write(*,*) 'BRENT: Minimum found at:',xmin,' Chi2=',fret

        par(7)=xmin

c	IF (fret.gt.1E+06) GOTO 9555

        call
& mread2(sizf,f,sizg,sizfi,fi,g,g_simu,q,p,s,wn,par,
& ka,sizka,fchi2,star,ka2,sizka2)

c	write(*,*)'After MREAD2 Chi2:',fchi2,' and par(7)=',par(7)

c        end if

c	open(26,file='./plot/box.dat')
c	do i=1,sizfi
c		write(26,*)fi(i)
c	end do
c	close(26)
c	write(*,*)'IP written to box.dat'
c	read(*,*)reply



	flip=2

	else 

	flip=1

c	end if
c	end if
c        end if
	

c-------------------------Parameter 13 	
c       if (par_seq(j).eq.13) then

c        if (loop.lt.201) then
c        if (flip.eq.2) then

cc        write(*,*) ' ------> Optimizing Gaussian for (Box*Gauss)'
cc        write(*,*) 'Parameter #13=',par(13)

c	30. instead of 15. :
c        ax=par(13)-30.
c        bx=par(13)+30.

	ax=par(13)-10.
	bx=par(13)
	cx=par(13)+10.

        tol=0.000001
        
c    ### Bracketing
        call mnbrak(ax,bx,cx,fa,fb,fc,boxip2)
c        write(*,*) 'MNBRAK: [ax, bx ,cx] after bracketing:',ax,bx,cx
c        write(*,*) ' And fa,fb,fc:',fa,fb,fc


        call brent(fret,ax,bx,cx,boxip2,tol,xmin)
        
cc        write(*,*) 'BRENT: Minimum found at:',xmin,' Chi2=',fret
                
        par(13)=xmin

c	IF (fret.gt.1E+06) GOTO 9555

        call
& mread2(sizf,f,sizg,sizfi,fi,g,g_simu,q,p,s,wn,par,
& ka,sizka,fchi2,star,ka2,sizka2)
                
cc        write(*,*)'After MREAD2 Chi2:',fchi2,' and par(13)=',par(13)

c	open(26,file='./plot/box.dat')
c       do i=1,sizfi
c                write(26,*)fi(i)
c        end do
c        close(26)
c        write(*,*)'IP written to box.dat'
c        read(*,*)reply

        
cc	end if
        end if
        end if

	goto 36000
c-----  Complete Loop on both BOXIP parameters
35000	continue

        write(*,*)'------> SEARCHING IN BOX-PSF PARAMETERSPACE:'
	write(*,*)'Looping........'

	chi2old=999999.	
	par_ini(13)=par(13)
	par_ini(7)=par(7)

	CALL FUNC_VALUE(par(13),fchi2,boxip2)
	chi2old=fchi2
	
c        do i=1,70,2
ccc	do i=INT(ABS(par(7)-20.)),INT(ABS(par(7)+20.)),1
c
c               par(7)=FLOAT(i)
c        
c                do k=1,40,2
c		do k=INT(ABS(par(13)-20.)),INT(ABS(par(13)+20.)),1
c
c                       par(13)=FLOAT(k)
c                        CALL FUNC_VALUE(par(13),fchi2,boxip2)
c                        if (fchi2.lt.chi2old) then
c                        write(*,*)'Minimum found=',fchi2
c                        chi2old=fchi2
c                        par_ini(13)=par(13)
c                        par_ini(7)=par(7)
c                        end if
c                end do  
c
c        end do

c---------------------
c now with BRENT:

	boxlow=INT(par(7)-20.)
	boxhigh=INT(par(7)+20.)

	if (chunk.lt.3) then
		boxlow=0
		boxhigh=70
	end if

	do i=boxlow,boxhigh

c	do i=0,70,1

	par(7)=FLOAT(i)

c	ax=-10.
c	bx=40.
	ax=par(13)-30.
	bx=par(13)
	cx=par(13)+30.

	tol=0.000001

	call mnbrak(ax,bx,cx,fa,fb,fc,boxip2)
	
	call brent(fret,ax,bx,cx,boxip2,tol,xmin)

	if (fret.lt.chi2old) then

	write(*,*) 'BRENT: Minimum found at:',xmin,' Chi2=',fret
	write(*,*) '       par7=',par(7)
	chi2old=fret
	par_ini(13)=xmin
        par_ini(7)=par(7)

        end if

	end do	

        write(*,*)'...finished'
        write(*,*)'Minimum at Chi2=',chi2old
        write(*,*)'And Par(13)=',par_ini(13)
        write(*,*)'And Par(7)=',par_ini(7)
                        
        par(13)=par_ini(13)
        par(7)=par_ini(7)
                        
        CALL FUNC_VALUE(par(7),fchi2,boxip)
                        
                        
c       write(*,*)'fi(24)=',fi(24)
c       write(*,*)'Parameters:',par
        
        CALL
& mread2(sizf,f,sizg,sizfi,fi,g,g_simu,q,p,s,wn,par,
& ka,sizka,fchi2,star,ka2,sizka2)
        
        write(*,*)'Chi2 after calling MREAD2=',fchi2

c	par(13)=-31.6108
c	par(7)=46.

c	CALL FUNC_VALUE(par(7),fchi2,boxip)
c	write(*,*)'Chi2 with values -31.6,46.:',fchi2


c       read(*,*)reply
         

	end if	
36000	continue

c-----------------------------------------------------------------

c-------	END OF PARAMETER SEQUENCE LOOP
	end do
c-------


9000	continue

ccc	write(*,*)'Chi2:',fchi2,' Escape at:',stopthat

	if (fchi2.lt.stopthat) goto 12000

c	write(*,*)'Parameters are:',par


c	if (loop.lt.memstart) goto 11000
	if (memruns.eq.0) goto 11000


c++++++	Making fi_in IP (default) before MEM +++++

c	if (loop.eq.memstart) then
ccc	if (memstart.eq.1) then
	if (loop.eq.memstartloop) then

	do i=1,sizfi
		fi_in(i)=fi(i)
c		write(*,*)i,fi(i),fi_in(i)

c************* OK LETS TRY WITHOUT DEFAULT!!!! *********************
c
c		fi(i)=1./sizfi
c
c************* OK LETS TRY WITHOUT DEFAULT!!!! ********************* 


	end do

c	memstart=0

c	write(*,*)'OK, making IP default for MEM....'
c	read(*,*)reply

	end if

c+++++++++++++++++++++++++++++++++++++++++++++++++++++++





c********************************************************************
c*                                                                
c*
c************************* M E M    P A R T *************************
c*
c*
c********************************************************************


c______________________________________________________________________
c	if (loop.eq.21) then
c
c
c	call
c& mread2(sizf,f,sizg,sizfi,fi,g,g_simu,q,p,s,wn,par,
c& ka,sizka,fchi2,star,ka2,sizka2)
c
c	write(*,*)'Chi2 (BRENT) is now:',fchi2
c	write(*,*)'OK 1, end of optimisation loop #',loop
c	write(*,*)'OK, parameters are now:',par
c
c	end if
c______________________________________________________________________


	write(*,*)'Reconstructing IP.... => MEM part...'
c	write(*,*)'sizf = ',sizf
c	write(*,*)'sizg = ',sizg
c	write(*,*)'p = ',p
c	write(*,*)'q = ',q

	call mcal_mat2(f,sizf,matF,p,q,sizg)

ccc	write(*,*)'OK 2, matrix matF is ready....'
ccc	write(*,*)'... default solution => matF ...'
	
	    do i=1,sizg
	           do k=1,sizfi
        		   matF(i,k)=matF(i,k)*fi(k)
           	   end do
            end do

ccc	write(*,*)'OK 3, matF ready for MEM....'

c______________________________________________________________________
c	if (loop.eq.400) then 
c
c	write(*,*)'....Now checking the chi2!'
c
c       open(unit=18, file='./plot/testg.dat')
c        chi2=0.
c        do i=1,sizg
c               g_samp(i)=0.
c               do k=1,sizfi
c                       g_samp(i)=g_samp(i)+matF(i,k)
c               end do 
c               g_samp(i)=g_samp(i)/q
c               write(18,*)g(i),g_samp(i)
c               chi2=chi2+((g(i)-g_samp(i))/s(i))**2.
c       end do
c       close(18)
c
c        write(*,*)'Matrix transformed back into the g_samp vector!'
c        write(*,*)'Chi2 is now:',chi2
c	write(*,*)'Calling MREAD2 again...'
c
c	call
c& mread2(sizf,f,sizg,sizfi,fi,g,g_simu,q,p,s,wn,par,ka,sizka,fchi2)
c	write(*,*)'Chi2 (BRENT)is still:',fchi2
c
c	read(*,*)reply
c
c	end if
c______________________________________________________________________


	write(*,*)'..... => MEM Routine .....'

	do i=1,sizg 
		g_mem(i)=g(i)
		s_mem(i)=s(i)
	end do
	
c       Original QUICK:

        call quick(X,matF,g_mem,s_mem,sizg,sizfi,niter,eta,1,n1
&      ,x1,x2,x3)
  
c	open(unit=55, file='./plot/x.dat', type='new')
c        do i=1,sizfi
c                write(55,*)X(i)
c        end do
c        close(55)
c        write(*,*)'Vector X written to file x.dat'
c	read(*,*)reply

c---------- OK, default solution steering? ----

c	do i=1,24
c		Xmed(i)=(X(i)+X(50-i))/2.
c	end do

c	open(unit=10, file='./plot/x.dat')
c	do i=1,sizfi
c		write(10,*)X(i),Xmed(i)
c	end do

c	write(*,*)' OK, check the Xmed vector...'
c	close(10)
c	read(*,*)reply
	
c	do i=1,24
c		fimem(i)=fi(i)*Xmed(i)
c		fimem(25+i)=fi(25+i)*Xmed(25-i)
c	end do
c	fimem(25)=fi(i)*X(i)

c	goto 9900		

c----------------------------------------------


	  do i=1,sizfi
            fimem(i)=fi(i)*X(i)
          end do

9900 	continue

ccc	write(*,*)'Normalizing results.....'
	phimax=0.

        do i=1,sizfi
                        phimax=phimax+fimem(i)
        end do

        do i=1,sizfi
                fimem(i)=fimem(i)/phimax
        end do

c______________________________________________________________________
c	if (loop.eq.60) then
c	open(15,file='./plot/x.dat')
c	sdiff=0.
c	do i=1,sizfi
c		sdiff=sdiff+((fimem(i)-realip(i))**2.)
c		sdiff=sdiff+((fimem(i)-fi_in(i))**2.)
c		write(15,*)x(i),fimem(i),fi_in(i)
c	end do
c	close(15)
c	write(*,*)'Loop 60, delta MEM IP-Multigauss=',sdiff
c	write(*,*)'X-vector, MEM-IP, INPUT-IP' 
c	end if
c______________________________________________________________________

c	leftsum=0.
c	rightsum=0.
c	do i=1,p
c		leftsum=leftsum+fimem(i)
c		rightsum=rightsum+fimem(p+1+i)
c	end do


ccc	write(*,*)'Now updating Phi with MEM results!!...'

	do i=1,sizfi
		fi(i)=fimem(i)
	end do

	call
& mread2(sizf,f,sizg,sizfi,fi,g,g_simu,q,p,s,wn,par,
& ka,sizka,fchi2,star,ka2,sizka2)



c*********************************************************************

cc	if (loop.eq.21) then

cc	call
cc& mread2(sizf,f,sizg,sizfi,fi,g,g_simu,q,p,s,wn,par,
cc& ka,sizka,fchi2,star,ka2,sizka2)

cc	write(*,*)'Chi2 (MREAD2) is......',fchi2
c	write(*,*)'Area of Phi=',phimax


cc	call mcal_mat2(f,sizf,matF,p,q,sizg)

cc       write(*,*)'OK 2, matrix matF is ready....'
cc        write(*,*)'... default solution => matF ...'

        
cc            do i=1,sizg
cc                   do k=1,sizfi
cc                           matF(i,k)=matF(i,k)*fi(k)
cc                   end do  
cc            end do

cc        write(*,*)'OK 3, matF ready for MEM....'
cc        write(*,*)'....Now checking the chi2!'

c       open(unit=18, file='./plot/testg.dat')
cc        chi2=0.  
cc        do i=1,sizg
cc               g_samp(i)=0.
cc               do k=1,sizfi
cc                       g_samp(i)=g_samp(i)+matF(i,k)
cc               end do
cc               g_samp(i)=g_samp(i)/q
c               write(18,*)g(i),g_samp(i)
cc               chi2=chi2+((g(i)-g_samp(i))/s(i))**2.
cc        end do
c	write(*,*)'Simulated g-vector written to testg.dat' 
c       close(18)
c 
cc       write(*,*)'Matrix transformed back into the g_samp vector!'
cc       write(*,*)'Chi2 is now:',chi2

cc		open(unit=34, file='./plot/phi21.dat')
cc		do i=1,sizfi
cc			write(34,*)fi(i),fi_in(i)
cc		end do
cc		write(*,*)'First IP written to phi40.dat!'
cc		call
cc& mread2(sizf,f,sizg,sizfi,fi,g,g_simu,q,p,s,wn,par,
cc& ka,sizka,fchi2,star,ka2,sizka2)

cc		write(*,*)'Chi2 (MREAD2)with first MEM-IP:',fchi2
cc		write(*,*)'Parameters:',par
c		do i=1,sizfi
c			fi(i)=fi_in(i)
c		end do
c		call
c& mread2(sizf,f,sizg,sizfi,fi,g,g_simu,q,p,s,wn,par,ka,sizka,fchi2)
c		write(*,*)'Check:chi2 with old Multi-Gauss-IP:',fchi2
c		
c		write(*,*)'Continue(y/n)?'
c		read(*,*)reply
cc		close(34)
cc	end if

c************************************************************************

c	if (loop.eq.44) then
c                open(unit=34, file='./plot/phi44.dat')
c                do i=1,sizfi
c                        write(34,*)fi(i)
c                end do
c                close(34)
c        end if

c	if (loop.eq.54) then
c                open(unit=34, file='./plot/phi54.dat')
c                do i=1,sizfi
c                        write(34,*)fi(i)
c                end do
c                close(34)
c        end if

c	if (loop.eq.100) then
c                open(unit=34, file='./plot/phi100.dat')
c                do i=1,sizfi
c                        write(34,*)fi(i)
c                end do
c                close(34)
c        end if

c	if (loop.eq.300) then
c                open(unit=34, file='./plot/phi300.dat')
c                do i=1,sizfi
c                        write(34,*)fi(i)
c                end do
c                close(34)
c        end if

c	if (loop.eq.1000) then
c                open(unit=34, file='./plot/phi1000.dat')
c                do i=1,sizfi
c                        write(34,*)fi(i)
c                end do   
c                close(34)
c        end if
	

c-----------------------------------------------------------------------
11000   continue

	write(*,*)'======> END OF LOOP Nr.:',loop,'===>','Chi^2=',fchi2



c	if (star.eq.1) then
c	write(13,*)fchi2,par(1),par(16),par(2),par(8)
c	else
c	write(13,*)fchi2,par(1),par(2),par(8),par(7),par(13)
c	end if


ccc	if (loop.gt.memstart) then
	if (fchi2.gt.chi2old) then
		write(*,*)'CHI2 IS NOT CONVERGING!!!!'
		write(*,*)'stopping..... => next chunk'
c		AUSE
		goto 12000
	end if
ccc 	end if

	if (fchi2.gt.100000) then
                write(*,*)'CHI2 IS TOO LARGE!!!!'
                write(*,*)'skip..... => next chunk'
c               AUSE
                goto 12000
        end if



        chi2old=fchi2


	if (loop.eq.nloop) goto 12000


c------	CHI2_S ARRAY:

	IF (loop.lt.6) then
	
		chi2_s(loop)=fchi2
	else
		do k=1,4	
			chi2_s(k)=chi2_s(k+1)
		end do
		chi2_s(5)=fchi2
	end if

c---	Statistics of CHI2_S ARRAY:

	IF (LOOP.GT.5) THEN

	chi2_sum=0.
	
	do k=1,5
		chi2_sum=chi2_sum+chi2_s(k)
	end do

	chi2_mean=chi2_sum/5.
	chi2_rms=0.

	do k=1,5
		chi2_rms=chi2_rms+(chi2_s(k)-chi2_mean)**2.
	end do
	chi2_rms=SQRT(chi2_rms/4.)
c	chi2_rms=SQRT(chi2_rms)
		
c	WRITE(*,*)'RMS of CHI2=',chi2_rms

	IF (chi2_rms.gt.0) THEN 

c---	End of Optimization?
c	BORDERS OF OPTIMIZATION:

c	new input file 'chi2rms.in' now! 
	OPEN(76,file='chi2rms.in',type='old')
	READ(76,*) torbi
	CLOSE(76)
	
	IF (torbi.eq.33.) torbi2=chi2_mean/3.
	IF (torbi.eq.20.) torbi2=chi2_mean/5.
	IF (torbi.eq.15.) torbi2=chi2_mean/6.7
	IF (torbi.eq.10.) torbi2=chi2_mean/10.
	IF (torbi.eq.5.0) torbi2=chi2_mean/20.
	IF (torbi.eq.1.0) torbi2=chi2_mean/100.
	IF (torbi.eq.0.5) torbi2=chi2_mean/200.
	IF (torbi.eq.0.2) torbi2=chi2_mean/500. 
	IF (torbi.eq.0.1) torbi2=chi2_mean/1000.	

	IF (chi2_rms.lt.torbi2) THEN
	
c	0.1 % :
c	IF (chi2_rms.lt.(chi2_mean/1000.)) then
c	0.2 % : 
c	IF (chi2_rms.lt.(chi2_mean/500.)) then
c	33 % :
c	IF (chi2_rms.lt.(chi2_mean/3.)) then
c	20 % :
c	IF (chi2_rms.lt.(chi2_mean/5.)) then
c	15 % :
c	IF (chi2_rms.lt.(chi2_mean/6.7)) then
c******** usual:
c	10 % :
c	IF (chi2_rms.lt.(chi2_mean/10.)) then
c********
c	5 % 
c	IF (chi2_rms.lt.(chi2_mean/50.)) then
c	IF (chi2_rms.lt.0.5) then
c	0.5 % :
c	IF (chi2_rms.lt.(chi2_mean/200.)) then
c	1 % :
c	IF (chi2_rms.lt.(chi2_mean/100.)) then

c		WRITE(*,*)
c		WRITE(*,*)'OKAY, RMS OF CHI2 SMALLER THAN STOP CRITERION !!!!'

c	MEM?
		IF (memstart.eq.1) THEN
			WRITE(*,*)'CONTINUING WITH MEM-TREATMENT...'
			memruns=1
cc			AUSEL
			loop=loop+1
			memstartloop=loop 
			memstart=0 
			goto 3000
		END IF

		IF (memruns.eq.1) THEN

			IF (loop.lt.memstartloop+4) THEN
				WRITE(*,*)'CONTINUING MEM-TREATMENT......'
				loop=loop+1 
				GOTO 3000
			ELSE

				WRITE(*,*)'=> End of Optimization!'
				GOTO 12000
			END IF
		END IF

c		WRITE(*,*)'=> End of Optimization!'
		GOTO 12000

	END IF
c---

		ELSE

c	NAN?  
                        GOTO 9555


	END IF
c------ chi2rms > 0. ?


	END IF
c------ loop > 5 ?



	loop=loop+1

	goto 3000

c=============================================================================
c	SAVETY BAIL OUT IF chi2>10E+06 !!! to prevent NANs
c=============================================================================

9555	continue

	WRITE(*,*)
c	WRITE(*,*)' HEY! Chi2 > 1 million !'
	WRITE(*,*)' ====> BAIL OUT! and next chunk!'
	WRITE(*,*)

	

c=============================================================================
c	E N D    O F    L O O P  
c=============================================================================

12000	continue

c	close(13)

c	loop=loop-1


c***************************************************************
c	if (chunk.eq.54) then
c		ax=0.1
c
c		open(13,file='./plot/chunk/box_024.dat')
c		do i=1,50000
c			ax=ax+0.01
c			call mgauss(ax,bx,cx,fa,fb,fc,box)
c			write(13,*)ax,fa
c		end do
c		call mgauss(par(7),bx,cx,fa,fb,fc,box)
c		write(13,*)ax,fa
c		close(13)
c		write(*,*)'OK, box_024.dat completed....'
c		read(*,*)reply
c	end if
c***************************************************************
	



c------ 	WRITING IP DATA TO OUTPUT FILE: ------------------------

c------

c	 open(unit=30,file='./plot/phi.dat')
	open(unit=31, file='./plot/chunk/'//ip_fn)

                       do i=1,sizfi
c	old:
c				pixl=-((25-i)/5.)

c	new:
c		write(*,*)'p = ',p
c		pause
				pixl=-((p+1-i)/5.)

c				write(30,*)fi(i),fi_in(i)
				write(31,*)pixl,fi(i),fi_in(i)
c                             write(30,*)fi(i),fi_in(sizfi-i+1)
c				write(30,*)fi(i) 
                      end do
c         close(30)
	 close(31)
c-----------------------------------------------------------------------
	
c-------	WRITING CHUNK DATA (IODINE + MODEL) TO OUTPUTFILE

	call mcal_mat2(f,sizf,matF,p,q,sizg)

	do i=1,sizg
                   do k=1,sizfi
                           matF(i,k)=matF(i,k)*fi(k)
                   end do
        end do


c	open(unit=27, file='./plot/testg.dat')
	open(unit=28, file='./plot/chunk/'//data_fn) 

        chi2=0.
	billchi2=0.

        do i=1,sizg  
               g_samp(i)=0.
               do k=1,sizfi
                       g_samp(i)=g_samp(i)+matF(i,k)
               end do
               g_samp(i)=g_samp(i)/q

		resid(i)=g_samp(i)-g(i)

		billchi2=billchi2+(resid(i)**2.)

		write(28,*)i,g(i),g_samp(i),s(i),resid(i),npix(i)


               chi2=chi2+((g(i)-g_samp(i))/s(i))**2.
        end do         

c	write(28,*)'Bill Chi2=',billchi2

	close(28)

c------- output of true f-vector for deconvolution check:

c	open(28,file='./plot/deconv/truef.dat')
c	Chunk #1:
c	if (chunk.eq.1) then
c		do i=1,sizf
c			write(28,*)f(i)
c		end do
c	end if
c	close(28)

c---------------------------------------------------------


c------	WRITING MULTIPLE GAUSSIANS TO OUTPUTFILE: -----------------------

c	call megauss(245,par(6),123.,bgauss)
c	call megauss(97,18.75,49.,sgauss)
c
c	do i=1,245
c		mgauss1(i)=0.
c		mgauss2(i)=0.
c		mgauss3(i)=bgauss(i)
c	end do
c
c	do i=1,97
c		mgauss1(61+i)=sgauss(i)*par(11)
c		mgauss2(87+i)=sgauss(i)*par(12)
c		mgauss3(61+i)=mgauss3(61+i)+sgauss(i)*par(11)
c		mgauss3(87+i)=mgauss3(87+i)+sgauss(i)*par(12)
c	end do
c
c
c	open(31, file='./plot/chunk/mul'//ip_fn)
c
c	do i=1,245
c
c	pixl=-((123-i)/25.)
c	write(31,*)pixl,bgauss(i),mgauss1(i),mgauss2(i),mgauss3(i)
c
c	end do
c
c	close(31)

	
c------------------------------------------------------------------------



c        write(*,*)'The final Chi2 is:',chi2
c	write(*,*)'=====> Number of Optimization loops:',loop,'  <======='
c	write(*,*)'(with ',niter,' MEM iterations, Eta=',eta,')'
	
c	write(*,*)'End of parameter optimisation & IP reconstruction.'
c	write(*,*)'Parameters are now:'
c	write(*,*)par

c	write(*,*)'SIMULATION: Min of IP-delta:',sdiffmin,' at
c& loop:',sdiffminloop
c	write(*,*)'Drop of chi2 there:',chi2stmin

c	write(*,*)'    HASTA LA VISTA BABY....'
	

c	read(*,*)reply

c	write(*,*)'Returning to IP prg.......'

c	write(*,*)'Now! Plot the two graphs!....'
	
c	call
c& mread2(sizf,f,sizg,sizfi,fi,g,g_simu,q,p,s,wn,par,ka,sizka,fchi2)

	do i=1,nb_params
		par_out(i)=par(i)
	end do

	do i=1,sizf
		f_out(i)=f(sizf-i+1)
	end do

	sizf_out=sizf

	stellar=star


c	write(*,*)'q=',q
c	write(*,*)'Size of f=',sizf

c	do i=1,sizf

c		f_dummy((sizfi/2)+i)=g_simu(i)
		
c	end do


c	open(unit=300,file='./plot/testf.dat',type='new')
c                      do i=1,sizf
c                           write(300,*)f(i),f_dummy(i),f_out(i)
c                    end do
c        close(300)


c------------------------ RV results: -------------------------------
c	Aeh, I mean wavelength calib for this chunk:
c--------------------------------------------------------------------

c	write(*,*)'Writing wavenumber calc to wave.dat'
c	write(*,*)'Size of overs. vector=',sizf

c	write(36,*)'Chunk#=',chunk,' SHIFT='
c	write(36,*) par(1)
c	write(*,*)'	Waven(2500)-Waven(2501)='
c	write(*,109) wlka(2500)-wlka(2501)
c	write(*,*)'    Waven(5000)-Waven(5001)='
c       write(*,109) wlka(5000)-wlka(5001)

c--------------- wavenumbers for the iodine -----------

c	open(unit=37,file='./plot/chunk/indeces2.dat')

c	new dispersion algorithm:

	stepwlka=par(2)

cc	startwlkaindex=2500.d0-(FLOAT(sizfi/2)*stepwlka)-
cc&       (par(8)*(FLOAT(sizfi/2)**2.))+par(1)
	startwlkaindex=2500.d0-(DBLE(sizfi/2)*stepwlka)-
&       (par(8)*(DBLE(sizfi/2)**2.))+par(1)


	realwlkaindex=startwlkaindex
	
c	realwlkaindex=2500.d0-((sizfi/2)*par(2))+par(1)

c	write(37,109)realwlkaindex
c	write(*,*)'Starting WLKA Chunk from index:'
c	write(*,109)realwlkaindex

	wlkaindex=int(realwlkaindex)
	wlka0=wlka(wlkaindex)
	wlka1=wlka(wlkaindex+1)

	diffwlka=wlka1-wlka0

	restwlka=realwlkaindex-wlkaindex
	wavenumber=(wlka0+diffwlka*restwlka)

c---	Determing the DELTA between star and iodine:
c	and output to radvel.dat

	if (star.eq.1) then

cc	startwnkaindex=2500.d0-(FLOAT(sizfi/2)*stepwlka)-
cc&       (par(8)*(FLOAT(sizfi/2)**2.))+par(16)

	startwnkaindex=2500.d0-(DBLE(sizfi/2)*stepwlka)-
&       (par(8)*(DBLE(sizfi/2)**2.))+par(16) 

        realwnkaindex=startwnkaindex
	
	wnkaindex=int(realwnkaindex)
	wnka0=wnka2(wnkaindex)
        wnka1=wnka2(wnkaindex+1)
c	write(*,*)'Calculation wavenumber position for star..'
c	write(37,*)'CHUNK=',chunk,' wlka(2500) & wnka2(2500)='
c	write(37,109)wlka(2500)
c	write(37,109)wnka2(2500)
c	write(37,*)'Delta: wlka(2500)-wnka2(2500) ='
c	write(37,109)wlka(2500)-wnka2(2500)

c	write(37,*)'realwlkaindex=',realwlkaindex
c	write(37,*)'wlka(wlkaindex)+1 ='
c	write(37,109)wlka(wlkaindex)
c	write(37,109)wlka(wlkaindex+1)
c	write(37,*)'Step in IODINE='
c	write(37,109)wlka(wlkaindex+1)-wlka(wlkaindex)

c	write(37,*)'wnka2(wlkaindex)+1 ='
c	write(37,109)wnka2(wlkaindex)
c	write(37,109)wnka2(wlkaindex+1)
c	write(37,*)'Step in STAR='
c	write(37,109)wnka2(wlkaindex+1)-wnka2(wlkaindex)

	diffwnka=wnka1-wnka0
	restwnka=realwnkaindex-wnkaindex
	stellarwn=(wnka0+diffwnka*restwnka)

	delta=wavenumber-stellarwn

c	rv(1)=(delta/stellarwn)*c
	rv(1)=(delta/wavenumber)*c

ccc	write(37,110) wavenumber,stellarwn,delta,rv(1)
ccc	write(*,*)wavenumber,stellarwn,delta,rv(1)

c	write(37,*)'Chunk #=',chunk,' RV(mean) [m.s-1]'

	end if
c---

c	write(36,*)'Index of chunkstart=',realwlkaindex
c	write(36,*)'Wavenumber(',wlkaindex,')='
c	write(36,109) wlka0
c	write(36,*)'Wavenumber(',wlkaindex+1,')='
c	write(38,109) wlka1

c	write(36,*)'interpolated WAVENUMBER at zero point='
c	write(36,109) wavenumber


C	write(36,119) 1,wavenumber,1.D0/(wavenumber*1.E-08)

c	write(36,*)'------------------------------------------' 

c	count=1
	count=0

c	WRITE(*,*)'sizf=',sizf
c	WRITE(*,*)'sizfi=',sizfi
c	WRITE(*,*)'(sizfi/2)=',sizfi/2.	

c       2009-03-18:
c       movepix.dat = input file of how many oversampled pixel the beginning
c       of the wavenumber output should be moved

        IF (star.eq.0) THEN
        OPEN(89,file='movepix.dat')
        READ(89,*) movepix
        WRITE(*,*) 'movepix= ',movepix
        CLOSE(89)
        END IF


	do i=2,sizf
	
c	stepwlka=par(2)*i+(par(8)*(i**2))
	stepwlka=par(2)*DBLE(i)+(par(8)*(DBLE(i)**2.D0))

c
c       do i=25,sizf-(sizfi/2)
c
c	Okay, this is really a BUG:
c	index runs from 25 to sizf-(sizfi/2) but the
c	realwlkaindex is still at 2,3,4,....

c	realwlkaindex=realwlkaindex+par(2)+(par(8)*(i**2))

	realwlkaindex=startwlkaindex+stepwlka

c	write(37,109)realwlkaindex

	wlkaindex=int(realwlkaindex)
        wlka0=wlka(wlkaindex)
        wlka1=wlka(wlkaindex+1)
        diffwlka=wlka1-wlka0
        restwlka=realwlkaindex-wlkaindex
        wavenumber=(wlka0+diffwlka*restwlka)
c	write(36,109) wavenumber,1.d0/(wavenumber*1.E-08)

	IF (i.gt.(sizfi/2.)+movepix) THEN
c	IF (i.gt.(sizfi/2.)) THEN

c	IF (i.le.(sizf-(sizfi/2.-1.))) THEN 
	IF (i.le.(sizf-(sizfi/2.-1.)+movepix)) THEN
	write(36,119) i,wavenumber,1.D0/(wavenumber*1.E-08)
	count=count+1
	END IF
	END IF

c---	STAR: writing RV results to radvel.dat:

	if (star.eq.1) then
	
	realwnkaindex=startwnkaindex+stepwlka
        wnkaindex=int(realwnkaindex)
	wnka0=wnka2(wnkaindex)
	wnka1=wnka2(wnkaindex+1)

	diffwnka=wnka1-wnka0
	restwnka=realwnkaindex-wnkaindex
	stellarwn=(wnka0+diffwnka*restwnka)

	delta=wavenumber-stellarwn
c	rv(i)=(delta/stellarwn)*c
	rv(i)=(delta/wavenumber)*c

ccc	write(37,110)wavenumber,stellarwn,delta,rv(i)

	end if

c---


	end do

c---	
	if (star.eq.1) then

c	new!!!
c	now forming sum of gradients to form weight of chunk:

	gradsum=0.
	grad1(1)=0.
        grad2(1)=0.
        grad1(sizg)=0.
        grad2(sizg)=0.
c        gradient(1)=1.
c        gradient(sizg)=1.
	gradient(1)=0.
	gradient(sizg)=0.


        do i=2,sizg-1
                grad1(i)=ABS(g(i-1)-g(i))
                grad2(i)=ABS(g(i+1)-g(i))
c                gradient(i)=((grad1(i)+grad2(i))/2.)+1.
		gradient(i)=((grad1(i)+grad2(i))/2.)
        end do

c	open(23,file='./plot/chunk/gradtest.dat')
	do i=1,sizg
c	write(23,*) i,g(i),gradient(i)
	gradsum = gradsum + gradient(i)
	end do
c	close(23)

	rvsum=0.
	do i=1,sizf	
		rvsum=rvsum+rv(i)
	end do
	rvmean=rvsum/DBLE(sizf)
cc	write(37,*)'CHUNK #=',chunk,' RV mean [m.s-1]:'

ccc-------------------------------------------------
ccc	check to prevent -INF and INF entries:

	if (rvmean.lt.-999999.) then
		rvmean=0.
	end if

	if (rvmean.gt.999999.) then
		rvmean=0.
	end if
ccc-------------------------------------------------

c	WRITE(*,*)'RV MEAN OF THAT CHUNK= ',rvmean
c	WRITE(*,*)'and DELTA= ',delta


c	write(37,109) rvmean, delta

c	normal:
c	write(37,107) order,chunk,rvmean, delta

	write(37,108) order,chunk,rvmean,delta,gradsum

c	setting star flag for ip_2:
	par(20)=1.

	end if
c---	


	
c	write(36,*)'------------------------------------------'

c	write(*,*)count,' wavenumbers written'
c	write(*,*)'Done...'

c	write(*,*)'And ending WLKA chunk with index:'
c	write(*,109)realwlkaindex


c	open(37,file='./plot/chunk/wlka.dat')
c	do i=1,sizka
c		write(37,109)wlka(i)
c	end do
c	close(37)
c	write(*,*)'OK, wavenumber array WLKA written to wlka.dat'	


c--------------------------------------------------------------------

ccc	if (chunk.eq.15) then
c	write(*,*)'OK, next Chunk?'
c	read(*,*)reply
ccc	end if

c--------------------------------------------------------------------

	goto 99999


c***************************************************************************
c	* getting chi2 function

	write(*,*)'START of chi2-determination..........'

	par(1)=-1700.
	open(400, file='./plot/chi.dat', type='new')

	do i=1,185
		par(1)=par(1)+20.

	call
& mread2(sizf,f,sizg,sizfi,fi,g,g_simu,q,p,s,wn,par,
& ka,sizka,fchi2,star,ka2,sizka2)

		write(400,*)par(1),fchi2

	end do

	close(400)

	write(*,*)'chi2-function loop finished!'
	
		open(unit=300,file='./plot/testg.dat',type='new')
                       do i=1,sizg
                             write(300,*)g(i),g_simu(i)
                       end do
                close(300)





	read(*,*)reply

c*****************************************************************************


        open(100,file='./data/sequence.asc')
	read(100,*)
	read(100,*)
	read(100,*) nb_seq
	write(*,*) 
	write(*,*) '* sequence order:'
	write(*,*) 'nb_seq',nb_seq
	read(100,*)
	do i=1,nb_seq
	   read(100,*) seq(i)
           write(*,*) 'seq(i) ',seq(i)
	end do
	read(100,*)
	read(100,*) nb_loop
	read(100,*)
	do i=1,nb_loop
	  read(100,*) accu(i)
	end do
	close(100)

c   	do i=1,5
c	write(*,*) ' i, init_par, par :',par_ini(i)
c	end do


	write(*,*) ' Testing the new shift algorithm'
        ax=par(1)+5.53632
        bx=par(1)
        cx=par(1)+50.

        write(*,*) ' [, x , ] before bracketing:',ax,bx,cx

	par(1)=ax

	write(*,*)'Calling MREAD2, shiftparameter=',par(1)
	call
& mread2(sizf,f,sizg,sizfi,fi,g,g_simu,q,p,s,wn,par,
& ka,sizka,fchi2,star,ka2,sizka2)
        
        open(unit=300,file='./plot/testg.dat', type='new')
         do i=1,sizg
                write(300,*)g(i),g_simu(i)
         end do
        close(300)


	
	read(*,*)reply

c------------------------------------------------------------
c	
c	T	H	E		E	N	D
c
c------------------------------------------------------------
c	geronimo!

99999	continue
 107	FORMAT(I2,1X,I2,1X,E25.15,1X,E25.15)
 108	FORMAT(I2,1X,I2,1X,E25.15,1X,E25.15,1X,E25.15)
 109    format(2(3x,e25.15))
 110 	format(4(3x,e25.15))
 119 	FORMAT(I3,1X,E25.15,1X,E25.15)

cc	write(*,*)'Stellar, star=',stellar,star

	bary_out=baryvel_star
c	write(*,*)'Bary_out=',bary_out
cc	write(*,*)'Return to IP?'
cc	read(*,*)reply


	return

   	end



c=================================================================================
c       Functions giving fchi2(param(i)) (i=1,5) and the derivative d_fchi2 (i=1,2)
c=================================================================================

c****Parameters: *********************************************
c
c    par(1) = SHIFT     (units = mastertab units)
c    par(2) = dispersion    (d)
c    par(3) = slope         (s)
c    par(4) = depth         (a)
c    par(5) = normalisation (n)
c    par(6) = sigma of default gauss= 5.5+par(6)
c    par(7) = box-parameter = width of box (3x oversampl.)	
c    par(8) = nonlinear term of dispersion
c    par(9) = left wing gaussian amplitude
c    par(10)= right wing
c
c   STELLAR PARAMETERS:
c
c	par(16) = Stellar SHIFT (units= mastertab units)
c	par(17) = Stellar Normalisation
c	par(18) = Stellar Linedepth
c	par(19) = Stellar Slope
c
c****Parameters *********************************************




c************************* new function shift par(1) ***********

	function shift(x)
	integer nb_params,maxsiz
	parameter(nb_params=40, maxsiz=1000)
c	parameter(nb_params=40, maxsiz=5000)
	real shift,x
c	real fchi2,par(nb_params)
	REAL fchi2
	REAL par(nb_params)
	real mgpos(30)

	integer sizf,sizg,sizfi,q,p,sizka,sizka2
	integer star
	real*8 wn
	REAL f(5000)
c	real fi(50),g(maxsiz),g_simu(maxsiz),s(maxsiz)
	real fi(maxsiz),g(maxsiz),s(maxsiz)
	REAL g_simu(5000)
c	real ka(10000)
	real ka(40000),ka2(40000)
c	real ka(20000),ka2(20000)
c	real*8 ka(10000)

	common /params/ par,mgpos,star
	common /sizes/ sizka,sizfi,sizka2
	common /convol/ sizf,sizg,p,q,fi,g,s,ka,ka2
 
	par(1)=x
c	write(*,*)'x=',x,'Sizef=',sizf,'Sizeg=',sizg,'Sizfi=',sizfi

c	write(*,*)'FUNCTION shift: parameters=',par

	call
& mread2(sizf,f,sizg,sizfi,fi,g,g_simu,q,p,s,wn,par,
& ka,sizka,fchi2,star,ka2,sizka2)

	shift=fchi2
cc	write(*,*)' SHIFT=',par(1),'  CHi2:',shift

	return
	end

c********************* new function st_shift ********************
c	stellar shift 
        
        function st_shift(x)
        integer nb_params,maxsiz
        parameter(nb_params=40, maxsiz=1000)
c       parameter(nb_params=40, maxsiz=5000)
        real st_shift,x
c       real fchi2,par(nb_params)
        REAL fchi2
        REAL par(nb_params)
        real mgpos(30)

        integer sizf,sizg,sizfi,q,p,sizka,sizka2
        integer star
        real*8 wn
	REAL f(5000),g_simu(5000)
c       real fi(50),g(maxsiz),g_simu(maxsiz),s(maxsiz)
        real fi(maxsiz),g(maxsiz),s(maxsiz)
        
c       real ka(10000)
	real ka(40000),ka2(40000)
c        real ka(20000),ka2(20000)
c       real*8 ka(10000)
        
        common /params/ par,mgpos,star
        common /sizes/ sizka,sizfi,sizka2   
        common /convol/ sizf,sizg,p,q,fi,g,s,ka,ka2
        
        par(16)=x
c       write(*,*)'x=',x,'Sizef=',sizf,'Sizeg=',sizg,'Sizfi=',sizfi
        
c       write(*,*)'FUNCTION st_shift: parameters=',par

        call
& mread2(sizf,f,sizg,sizfi,fi,g,g_simu,q,p,s,wn,par,
& ka,sizka,fchi2,star,ka2,sizka2)

        st_shift=fchi2
cc      write(*,*)' SHIFT=',par(1),'  CHi2:',shift
        
        return
	end


c********************** new function depth **********************

	function depth(x)
	parameter(nb_params=40, maxsiz=1000)
c	parameter(nb_params=40, maxsiz=5000)
        real depth,x
        real fchi2
	REAL par(nb_params)
        integer sizf,sizg,sizfi,q,p,sizka,sizka2
        real*8 wn
	real mgpos(30)
	REAL f(5000),g_simu(5000)
c        real fi(50),g(maxsiz),g_simu(maxsiz),s(maxsiz)
	real fi(maxsiz),g(maxsiz),s(maxsiz)

c	real ka(10000)
	real ka(40000),ka2(40000)
c	real ka(20000),ka2(20000)

c	real*8 ka(10000)
	integer star


        common /params/ par,mgpos,star
        common /sizes/ sizka,sizfi,sizka2
        common /convol/ sizf,sizg,p,q,fi,g,s,ka,ka2
      
        par(4)=x
        
        call
& mread2(sizf,f,sizg,sizfi,fi,g,g_simu,q,p,s,wn,par,
& ka,sizka,fchi2,star,ka2,sizka2)
        
        depth=fchi2
        return
        end

c********************** new function st_depth **********************
c	stellar linedepth
        
        function st_depth(x)
        parameter(nb_params=40, maxsiz=1000)
c       parameter(nb_params=40, maxsiz=5000)
        real st_depth,x
        real fchi2
        REAL par(nb_params)
        integer sizf,sizg,sizfi,q,p,sizka,sizka2
        real*8 wn
        real mgpos(30)
	REAL f(5000),g_simu(5000)
c        real fi(50),g(maxsiz),g_simu(maxsiz),s(maxsiz)
        real fi(maxsiz),g(maxsiz),s(maxsiz)

c       real ka(10000)
	real ka(40000),ka2(40000)
c        real ka(20000),ka2(20000)
           
c       real*8 ka(10000)
        integer star

        
        common /params/ par,mgpos,star
        common /sizes/ sizka,sizfi,sizka2   
        common /convol/ sizf,sizg,p,q,fi,g,s,ka,ka2
        
        par(18)=x  
        
        call
& mread2(sizf,f,sizg,sizfi,fi,g,g_simu,q,p,s,wn,par,
& ka,sizka,fchi2,star,ka2,sizka2)

        st_depth=fchi2
        return
        end

c********************** new function dispersion **********************

        function disp(x)
        parameter(nb_params=40, maxsiz=1000)
c	parameter(nb_params=40, maxsiz=5000)
        real disp,x
        real fchi2
	REAL par(nb_params)
        integer sizf,sizg,sizfi,q,p,sizka,sizka2
        real*8 wn
	real mgpos(30)
	REAL f(5000),g_simu(5000)

c        real fi(50),g(maxsiz),g_simu(maxsiz),s(maxsiz)
	real fi(maxsiz),g(maxsiz),s(maxsiz)

c	real ka(10000)
	real ka(40000),ka2(40000)
c	real ka(20000),ka2(20000)
	integer star
c	real*8 ka(10000)

        common /params/ par,mgpos,star
        common /sizes/ sizka,sizfi,sizka2
        common /convol/ sizf,sizg,p,q,fi,g,s,ka,ka2
      
        par(2)=x
      
        call
& mread2(sizf,f,sizg,sizfi,fi,g,g_simu,q,p,s,wn,par,
& ka,sizka,fchi2,star,ka2,sizka2)

c	write(*,*)'DISP:',par(2),' Chi2=',fchi2

        disp=fchi2
        return
        end

c********************** new function dispersion2 **********************
        
        function disp2(x)   
        parameter(nb_params=40, maxsiz=1000)
c	parameter(nb_params=40, maxsiz=5000)
        real disp2,x
        real fchi2
	REAL par(nb_params)
        integer sizf,sizg,sizfi,q,p,sizka,sizka2
        real*8 wn
	real mgpos(30)
	REAL f(5000),g_simu(5000)
c        real fi(50),g(maxsiz),g_simu(maxsiz),s(maxsiz)
	real fi(maxsiz),g(maxsiz),s(maxsiz)

c	real ka(10000)
	real ka(40000),ka2(40000)
c	real ka(20000),ka2(20000)
	integer star
c	real*8 ka(10000)

        common /params/ par,mgpos,star
        common /sizes/ sizka,sizfi,sizka2
        common /convol/ sizf,sizg,p,q,fi,g,s,ka,ka2
           
        par(8)=x
        
        call
& mread2(sizf,f,sizg,sizfi,fi,g,g_simu,q,p,s,wn,par,
& ka,sizka,fchi2,star,ka2,sizka2)

c        write(*,*)'Chi2 with par(8)=',par(8),' is:',fchi2
 
        disp2=fchi2
        return
        end

c********************** new function slope **********************
        
        function slope(x)
        parameter(nb_params=40, maxsiz=1000)
c	parameter(nb_params=40, maxsiz=5000)
        real slope,x
        real fchi2
	REAL par(nb_params)
        integer sizf,sizg,sizfi,q,p,sizka,sizka2
        real*8 wn
	real mgpos(30)
	REAL f(5000),g_simu(5000)

c        real fi(50),g(maxsiz),g_simu(maxsiz),s(maxsiz)
	real fi(maxsiz),g(maxsiz),s(maxsiz)

c	real ka(10000)
	real ka(40000),ka2(40000)
c	real ka(20000),ka2(20000)
	integer star
c	real*8 ka(10000)

        common /params/ par,mgpos,star
        common /sizes/ sizka,sizfi,sizka2
        common /convol/ sizf,sizg,p,q,fi,g,s,ka,ka2   
      
        par(3)=x

        call
& mread2(sizf,f,sizg,sizfi,fi,g,g_simu,q,p,s,wn,par,
& ka,sizka,fchi2,star,ka2,sizka2)

        slope=fchi2  
	return
	end

c********************** new function st_slope **********************
c	stellar slope:

        function st_slope(x)
        parameter(nb_params=40, maxsiz=1000)
c       parameter(nb_params=40, maxsiz=5000)
        real st_slope,x
        real fchi2
        REAL par(nb_params)
	REAL f(5000),g_simu(5000)
        integer sizf,sizg,sizfi,q,p,sizka,sizka2
        real*8 wn
        real mgpos(30)

c        real fi(50),g(maxsiz),g_simu(maxsiz),s(maxsiz)
        real fi(maxsiz),g(maxsiz),s(maxsiz)

c       real ka(10000)
	real ka(40000),ka2(40000)
c        real ka(20000),ka2(20000)
        integer star
c       real*8 ka(10000)

        common /params/ par,mgpos,star
        common /sizes/ sizka,sizfi,sizka2
        common /convol/ sizf,sizg,p,q,fi,g,s,ka,ka2

        par(19)=x

        call
& mread2(sizf,f,sizg,sizfi,fi,g,g_simu,q,p,s,wn,par,
& ka,sizka,fchi2,star,ka2,sizka2)

        st_slope=fchi2
        return
        end

c********************** new function normalisation **********************
        
        function norm(x)
        parameter(nb_params=40, maxsiz=1000)
c	parameter(nb_params=40, maxsiz=5000)
        real norm,x
        real fchi2
	REAL par(nb_params)
	REAL f(5000),g_simu(5000)
        integer sizf,sizg,sizfi,q,p,sizka,sizka2
        real*8 wn
	real mgpos(30)
	integer star
c        real fi(50),g(maxsiz),g_simu(maxsiz),s(maxsiz)
	real fi(maxsiz),g(maxsiz),s(maxsiz)

c	real ka(10000)
	real ka(40000),ka2(40000)
c	real ka(20000),ka2(20000)

c	real*8 ka(10000)

        common /params/ par,mgpos,star
        common /sizes/ sizka,sizfi,sizka2
        common /convol/ sizf,sizg,p,q,fi,g,s,ka,ka2

        par(5)=x

        call
& mread2(sizf,f,sizg,sizfi,fi,g,g_simu,q,p,s,wn,par,
& ka,sizka,fchi2,star,ka2,sizka2)

        norm=fchi2
        return
        end

c********************** new function st_norm **********************
c	stellar normalisation
        
        function st_norm(x)
        parameter(nb_params=40, maxsiz=1000)
c       parameter(nb_params=40, maxsiz=5000)
        real st_norm,x   
        real fchi2
        REAL par(nb_params)
        integer sizf,sizg,sizfi,q,p,sizka,sizka2
        real*8 wn
        real mgpos(30)
        integer star
c        real fi(50),g(maxsiz),g_simu(maxsiz),s(maxsiz)
        real fi(maxsiz),g(maxsiz),s(maxsiz)
        REAL f(5000),g_simu(5000)
c       real ka(10000)
	real ka(40000),ka2(40000)
c        real ka(20000),ka2(20000)

c       real*8 ka(10000)
        
        common /params/ par,mgpos,star
        common /sizes/ sizka,sizfi,sizka2
        common /convol/ sizf,sizg,p,q,fi,g,s,ka,ka2
        
        par(17)=x

        call
& mread2(sizf,f,sizg,sizfi,fi,g,g_simu,q,p,s,wn,par,
& ka,sizka,fchi2,star,ka2,sizka2)
        
        st_norm=fchi2
        return
        end

c********************** new function gauss *******************************

	function gauss(x)
	parameter(nb_params=40, maxsiz=1000)
c	parameter(nb_params=40, maxsiz=5000)
	real gauss,x
	real fchi2,fisum
	REAL par(nb_params)
	integer sizf,sizg,sizfi,q,p,sizka,sizka2
	real*8 wn
c	real fi(50),g(maxsiz),g_simu(maxsiz),s(maxsiz)
	real fi(maxsiz),g(maxsiz),s(maxsiz)
	REAL f(5000),g_simu(5000)
c	real ka(10000)
	real ka(40000),ka2(40000)
c	real ka(20000),ka2(20000)
	integer star
c	real*8 ka(10000)

	real*8 pi,sigma,mu,gaus(50),ix
        real*8 term1,term2,term3
        real realgauss(50),biggauss(245),sgauss1(245),sgauss2(245)
	real sgauss3(245),sgauss4(245)
c	new multi:
	real sgauss5(245),sgauss6(245),sgauss7(245),sgauss8(245)
	real sgauss9(245),sgauss10(245),sgauss11(245),sgauss12(245)

c	real smallgauss(97)
	real mgpos(30)
	
	common /params/ par,mgpos,star
        common /sizes/ sizka,sizfi,sizka2
        common /convol/ sizf,sizg,p,q,fi,g,s,ka,ka2


c	goto 70000
c--	no more oversampling: 
	goto 70500

c	mu=25.
c	pi=3.1415927

c	write(*,*)'This is Function GAUSS....' 
c	write(*,*)'x=',x

c	par(6)=x
c	sigma=5.5+x

c	write(*,*)'Sigma (5.5+x)=',sigma

c	term1=1/(sigma*(SQRT(2*pi)))
c	
c	do ix=1.,49.	
c		term2=-((ix-mu)**2/(2*sigma**2))
c		term3=EXP(term2)
c		gaus(ix)=term1*term3
c       	realgauss(ix)=gaus(ix)
c	end do
c
c	fisum=0.
c	do i=1,sizfi
c		fi(i)=realgauss(i)
c		fisum=fisum+fi(i)
c	end do
c
c	goto 71000
c
c
	
c------------new algorithm with oversampling ---------------

70000	continue

	par(6)=x

c************* main gaussian ***********************************

c	size of gaussian=245 => center=123.
	mu=123.

	call megauss(245,x,123.,biggauss)
cc	call megauss(245,par(6),123.d0,biggauss)

c************* satellite gaussians *************************

c       size of satellite gaussian=97 => center=49.

cccc        call megauss(97,18.75,49.,smallgauss)

	if (mgpos(10).eq.1) then

ccc	call megauss(245,18.75,49.,sgauss1)
ccc	call megauss(245,18.75,197.,sgauss2)
c        call megauss(245,18.75,mgpos(1),sgauss1)
c        call megauss(245,18.75,mgpos(2),sgauss2)

	call megauss(245,10.75,mgpos(1),sgauss1)
	call megauss(245,10.75,mgpos(2),sgauss2)

c***********************************************************

c        write(*,*)'Amplitude of smallgauss=',x
cc---
c        do i=1,97
c                biggauss(i)=biggauss(i)+smallgauss(i)*par(9)
c		biggauss(42+i)=biggauss(42+i)+smallgauss(i)*par(11)
c               biggauss(106+i)=biggauss(106+i)+smallgauss(i)*par(12)
c		biggauss(148+i)=biggauss(148+i)+smallgauss(i)*par(10)
c        end do
cc---

	do i=1,245
		biggauss(i)=biggauss(i)+sgauss1(i)*par(9)
		biggauss(i)=biggauss(i)+sgauss2(i)*par(10)
	end do

	end if

c------------ downsampling & normalizing --------------------

	do i=1,sizfi
		fi(i)=0.
	end do

	sizfi=0.
	fisum=0.
	j=1
	count=0

	do i=1,245
		fi(j)=fi(j)+biggauss(i)
		count=count+1
		if(count.eq.5) then 
			fi(j)=fi(j)/5.

cc	avoid negative Wings:
			if (fi(j).lt.0.) then
				fi(j)=0.
			end if
cc
			fisum=fisum+fi(j)
			sizfi=sizfi+1
			j=j+1
			count=0
		end if
	end do

c------------ downsampling & normalizing --------------------
	goto 71000

70500	CONTINUE

c	Main gauss too small?
c	if (ABS(par(6)).lt.3.) par(6)=3.

	par(6)=x

c	write(*,*)'function gauss: p=',p

c	new IP:
	call megauss(sizfi,x,FLOAT(p+1),biggauss)

c	old:
c	call megauss(sizfi,x,25.,biggauss)

c====== MULTI GAUSS 

	if (mgpos(10).eq.1) then
	
c	call megauss(sizfi,4.5,mgpos(1),sgauss1)
c        call megauss(sizfi,4.5,mgpos(2),sgauss2)

c---->	for LC data width = 3.

c	 call megauss(sizfi,3.,mgpos(1),sgauss1)
c	call megauss(sizfi,mgpos(5),mgpos(1),sgauss1)
c	new widths:
	call megauss(sizfi,par(29),mgpos(1),sgauss1)

c	 call megauss(sizfi,3.,mgpos(2),sgauss2)
c	call megauss(sizfi,mgpos(5),mgpos(2),sgauss2)
c       new widths:
	call megauss(sizfi,par(30),mgpos(2),sgauss2)

c	 call megauss(sizfi,3.,mgpos(3),sgauss3)
c	call megauss(sizfi,mgpos(6),mgpos(3),sgauss3)
c       new widths:
	call megauss(sizfi,par(31),mgpos(3),sgauss3)

c	 call megauss(sizfi,3.,mgpos(4),sgauss4)
c	call megauss(sizfi,mgpos(6),mgpos(4),sgauss4)
c       new widths:
	call megauss(sizfi,par(32),mgpos(4),sgauss4)

c	new multi:
	call megauss(sizfi,mgpos(13),mgpos(11),sgauss5)
        call megauss(sizfi,mgpos(13),mgpos(12),sgauss6)
	call megauss(sizfi,mgpos(16),mgpos(14),sgauss7)
        call megauss(sizfi,mgpos(16),mgpos(15),sgauss8)
	call megauss(sizfi,mgpos(19),mgpos(17),sgauss9)
        call megauss(sizfi,mgpos(19),mgpos(18),sgauss10)
        call megauss(sizfi,mgpos(22),mgpos(20),sgauss11)
        call megauss(sizfi,mgpos(22),mgpos(21),sgauss12)

	do i=1,sizfi

                biggauss(i)=biggauss(i)+sgauss1(i)*par(9)
                biggauss(i)=biggauss(i)+sgauss2(i)*par(10)
		biggauss(i)=biggauss(i)+sgauss3(i)*par(11)
                biggauss(i)=biggauss(i)+sgauss4(i)*par(12)
		biggauss(i)=biggauss(i)+sgauss5(i)*par(21)
                biggauss(i)=biggauss(i)+sgauss6(i)*par(22)
		biggauss(i)=biggauss(i)+sgauss7(i)*par(23)
                biggauss(i)=biggauss(i)+sgauss8(i)*par(24)
		biggauss(i)=biggauss(i)+sgauss9(i)*par(25)
                biggauss(i)=biggauss(i)+sgauss10(i)*par(26)
                biggauss(i)=biggauss(i)+sgauss11(i)*par(27)
                biggauss(i)=biggauss(i)+sgauss12(i)*par(28)


c==	negative wings:
		if (biggauss(i).lt.0.) biggauss(i)=0.
c==
        end do

	end if
c=======

	fisum=0.
	do i=1,sizfi
		fi(i)=biggauss(i)	
		fisum=fisum+fi(i)
	end do

71000   continue

	do i=1,sizfi
		fi(i)=fi(i)/fisum
	end do

ccc	if (sizfi.ne.49) then
ccc	write(*,*)'Size of single gaussian is not correct!=',sizfi
ccc	read(*,*)reply
ccc	end if	

	
	call
& mread2(sizf,f,sizg,sizfi,fi,g,g_simu,q,p,s,wn,par,
& ka,sizka,fchi2,star,ka2,sizka2)
	
c	write(*,*)'Chi2 with new gauss=',fchi2


c	open(32,file='./plot/chunk/megauss.dat')
c	do i=1,sizfi
c		write(32,*)fi(i)
c	end do
c	close(32)

c===	Borders:
c	Oversampled:
c	if (ABS(x).lt.10.) fchi2=999999.
c	if (ABS(x).gt.50.) fchi2=999999.
c	Not oversampled:
c	if (ABS(x).lt.1.) fchi2=999999.
c	if (ABS(x).gt.10.) fchi2=999999.
c===

	gauss=fchi2
	return
	end

c***********************************************************************

c************** new function multi1 ************************************

        function multi1(x)
        parameter(nb_params=40, maxsiz=1000)
c	parameter(nb_params=40, maxsiz=5000)
        real multi1,x
        real fchi2,fisum
	REAL par(nb_params)
        integer sizf,sizg,sizfi,q,p,sizka,sizka2
        real*8 wn
c        real fi(50),g(maxsiz),g_simu(maxsiz),s(maxsiz)
	real fi(maxsiz),g(maxsiz),s(maxsiz)
	REAL f(5000),g_simu(5000)
c	real ka(10000)
	real ka(40000),ka2(40000)
c	real ka(20000),ka2(20000)
	integer star
c	real*8 ka(10000)

        real*8 pi,sigma,mu,gaus(50),ix
        real*8 term1,term2,term3
        real realgauss(50),biggauss(245),sgauss1(245)
	real sgauss2(245),sgauss3(245),sgauss4(245)
	real sgauss5(245),sgauss6(245),sgauss7(245),sgauss8(245)
	real sgauss9(245),sgauss10(245),sgauss11(245),sgauss12(245)
c	real smallgauss(121)
	real mgpos(30)
           
        common /params/ par,mgpos,star
        common /sizes/ sizka,sizfi,sizka2
        common /convol/ sizf,sizg,p,q,fi,g,s,ka,ka2
                
                
        pi=3.1415927    
        
        par(9)=x
                
	goto 80500

c       size of center gaussian=245 => center=123.
        mu=123.
        
        call megauss(245,par(6),123.,biggauss)

c        open(32,file='./plot/chunk/biggauss.dat')
c
c       do i=1,245
c                write(32,*) biggauss(i) 
c        end do
c
c	close(32)



c	size of satellite gaussian=97 => center=49.
c	new bill sigma=8. NO I think it is 18.75
	
cccc	call megauss(97,18.75,49.,smallgauss)

cc	write(*,*)'OKAY, Position of first Sat.gaussian=',mgpos(1)
cc	read(*,*)reply

ccc	call megauss(245,18.75,49.,sgauss2)
c	call megauss(245,18.75,mgpos(1),sgauss1)
ccc	call megauss(245,18.75,197.,sgauss2)
c	call megauss(245,18.75,mgpos(2),sgauss2)

	call megauss(245,10.75,mgpos(1),sgauss1)
	call megauss(245,10.75,mgpos(2),sgauss2)

c	write(*,*)'Enter amplitude of satellite:'
c	read(*,*) x

c	write(*,*) biggauss(13)

c	if (x.gt.0.) then
c	do i=1,245
cc		smallgauss(i)=(smallgauss(i)*x)
c		biggauss(i)=biggauss(i)+smallgauss(i)*x
cc		smallgauss(i)=smallgauss(i)-1.
c	end do
c	end if

c	write(*,*) biggauss(13)

c	write(*,*)'Amplitude of smallgauss=',x
c	inner multi gaussians at center: 110,135

	do i=1,245
		biggauss(i)=biggauss(i)+sgauss1(i)*x
		biggauss(i)=biggauss(i)+sgauss2(i)*par(10)
	end do

cc---
c	do i=1,97
c		biggauss(i)=biggauss(i)+smallgauss(i)*x
c		biggauss(61+i)=biggauss(61+i)+smallgauss(i)*par(11)
c		biggauss(87+i)=biggauss(87+i)+smallgauss(i)*par(12)
c		biggauss(148+i)=biggauss(148+i)+smallgauss(i)*par(10)
c	end do
cc---


c	open(32,file='./plot/chunk/smallgauss.dat')
c	do i=1,245
c		write(32,*)smallgauss(i),biggauss(i)
c	end do
c	close(32)

c	open(31,file='./plot/chunk/biggauss.dat')
c	do i=1,245
c		write(31,*)biggauss(i)
c	end do
c	close(31)
c	write(*,*)'OK, check the whole gaussian...'
c
c	read(*,*)reply

c-------------- downsampling & normalizing -------------

        do i=1,sizfi
                fi(i)=0.
        end do
        
        sizfi=0.
        fisum=0.
        j=1
        count=0

        do i=1,245
 
                fi(j)=fi(j)+biggauss(i)
                 count=count+1
              
		  if(count.eq.5) then
                        fi(j)=fi(j)/5.

cc	negative Wings!
			if (fi(j).lt.0.) then
				fi(j)=0.
			end if
cc
                        fisum=fisum+fi(j)
                        sizfi=sizfi+1
                        j=j+1
                        count=0
                  end if  
        end do
           
	GOTO 81000

c====================== START ==================================
80500 	CONTINUE

	call megauss(sizfi,par(6),FLOAT(p+1),biggauss)
c	call megauss(sizfi,par(6),25.,biggauss)


c        call megauss(sizfi,3.,mgpos(1),sgauss1)
c	call megauss(sizfi,mgpos(5),mgpos(1),sgauss1)
c	new widths
	call megauss(sizfi,par(29),mgpos(1),sgauss1)

c        call megauss(sizfi,3.,mgpos(2),sgauss2)
c	call megauss(sizfi,mgpos(5),mgpos(2),sgauss2)
c       new widths
	call megauss(sizfi,par(30),mgpos(2),sgauss2)

c	 call megauss(sizfi,3.,mgpos(3),sgauss3)
c	call megauss(sizfi,mgpos(6),mgpos(3),sgauss3)
c       new widths
	call megauss(sizfi,par(31),mgpos(3),sgauss3)
	call megauss(sizfi,par(32),mgpos(4),sgauss4)

c        call megauss(sizfi,3.,mgpos(4),sgauss4)
c	call megauss(sizfi,mgpos(6),mgpos(4),sgauss4)
c	new multi:
	call megauss(sizfi,mgpos(13),mgpos(11),sgauss5)
        call megauss(sizfi,mgpos(13),mgpos(12),sgauss6)
	call megauss(sizfi,mgpos(16),mgpos(14),sgauss7)
        call megauss(sizfi,mgpos(16),mgpos(15),sgauss8)
	call megauss(sizfi,mgpos(19),mgpos(17),sgauss9)
        call megauss(sizfi,mgpos(19),mgpos(18),sgauss10)
        call megauss(sizfi,mgpos(22),mgpos(20),sgauss11)
        call megauss(sizfi,mgpos(22),mgpos(21),sgauss12)

        do i=1,sizfi

                biggauss(i)=biggauss(i)+sgauss1(i)*x
                biggauss(i)=biggauss(i)+sgauss2(i)*par(10)
		biggauss(i)=biggauss(i)+sgauss3(i)*par(11)
                biggauss(i)=biggauss(i)+sgauss4(i)*par(12)
c	new multi:
		biggauss(i)=biggauss(i)+sgauss5(i)*par(21)
                biggauss(i)=biggauss(i)+sgauss6(i)*par(22)
		biggauss(i)=biggauss(i)+sgauss7(i)*par(23)
                biggauss(i)=biggauss(i)+sgauss8(i)*par(24)
		biggauss(i)=biggauss(i)+sgauss9(i)*par(25)
                biggauss(i)=biggauss(i)+sgauss10(i)*par(26)
                biggauss(i)=biggauss(i)+sgauss11(i)*par(27)
                biggauss(i)=biggauss(i)+sgauss12(i)*par(28)

c==     negative wings:
                if (biggauss(i).lt.0.) biggauss(i)=0.
c==

        end do

        fisum=0.
        do i=1,sizfi
                fi(i)=biggauss(i)
                fisum=fisum+fi(i)
        end do
	
81000	CONTINUE

        do i=1,sizfi
                fi(i)=fi(i)/fisum
        end do
                
cc        if (sizfi.ne.49) then
cc        write(*,*)'Size of single gaussian is not correct!=',sizfi
cc        read(*,*)reply
cc        end if

c        open(32,file='./plot/chunk/test.dat')
c        do i=1,sizfi
c                write(32,*)fi(i)
c        end do
c        close(32)
                
                        
        call
& mread2(sizf,f,sizg,sizfi,fi,g,g_simu,q,p,s,wn,par,
& ka,sizka,fchi2,star,ka2,sizka2)
        
c        write(*,*)'Chi2 with new gauss=',fchi2

c        open(32,file='./plot/chunk/megauss.dat')
c        do i=1,sizfi
c                write(32,*)fi(i) 
c        end do
c        close(32)
        
        
        multi1=fchi2

c	write(*,*)'Return?'
c	read(*,*)reply
	
        return          
        end             
        
c***********************************************************************

        function multi2(x)
        parameter(nb_params=40, maxsiz=1000)
c	parameter(nb_params=40, maxsiz=5000)
        real multi2,x
        real fchi2,fisum
	REAL par(nb_params)
        integer sizf,sizg,sizfi,q,p,sizka,sizka2
        real*8 wn
c        real fi(50),g(maxsiz),g_simu(maxsiz),s(maxsiz)
	real fi(maxsiz),g(maxsiz),s(maxsiz)
	REAL f(5000),g_simu(5000)
c	real ka(10000)
	real ka(40000),ka2(40000)
c	real ka(20000),ka2(20000)

c	real*8 ka(10000)
	integer star
        real*8 pi,sigma,mu,gaus(50),ix
        real*8 term1,term2,term3
        real realgauss(50),biggauss(245),sgauss1(245),sgauss2(245)
	real sgauss3(245),sgauss4(245)
c	new multi:
	real sgauss5(245),sgauss6(245),sgauss7(245),sgauss8(245)
	real sgauss9(245),sgauss10(245),sgauss11(245),sgauss12(245)

c	real smallgauss(121)
        real mgpos(30)
        
        common /params/ par,mgpos,star
        common /sizes/ sizka,sizfi,sizka2
        common /convol/ sizf,sizg,p,q,fi,g,s,ka,ka2


        pi=3.1415927

        par(10)=x  

	goto 82500

c       size of center gaussian=245 => center=123.
        mu=123.  

        call megauss(245,par(6),123.,biggauss)

c       size of left satellite gaussian=97 => center=49.

ccc        call megauss(97,18.75,49.,smallgauss)

cc	write(*,*)'OKAY, pos of second sat.gaussian=',mgpos(2)
cc	read(*,*)reply

cc	call megauss(245,18.75,49.,sgauss1)
cc	call megauss(245,18.75,197.,sgauss2)
c	call megauss(245,18.75,mgpos(1),sgauss1)
c       call megauss(245,18.75,mgpos(2),sgauss2)

        call megauss(245,10.75,mgpos(1),sgauss1)
        call megauss(245,10.75,mgpos(2),sgauss2)
        
c       write(*,*)'Amplitude of smallgauss=',x
ccc----        
c        do i=1,97
c                biggauss(i)=biggauss(i)+smallgauss(i)*par(9)
c		biggauss(61+i)=biggauss(61+i)+smallgauss(i)*par(11)
c                biggauss(87+i)=biggauss(87+i)+smallgauss(i)*par(12)
c		biggauss(148+i)=biggauss(148+i)+smallgauss(i)*x
c       end do
ccc----

	do i=1,245
		biggauss(i)=biggauss(i)+sgauss1(i)*par(9)
		biggauss(i)=biggauss(i)+sgauss2(i)*x
	end do


c-------------- downsampling & normalizing -------------
        
        do i=1,sizfi
                fi(i)=0.
        end do   
                
        sizfi=0.
        fisum=0.
        j=1
        count=0

        do i=1,245

                fi(j)=fi(j)+biggauss(i)
                 count=count+1

                  if(count.eq.5) then
                        fi(j)=fi(j)/5.

cc	negative Wings?
			if (fi(j).lt.0.) then
				fi(j)=0.
			end if
cc			

                        fisum=fisum+fi(j)
                        sizfi=sizfi+1
                        j=j+1
                        count=0
                  end if
        end do
	GOTO 82600
	
c==================== START ============================
82500	CONTINUE
c        call megauss(sizfi,par(6),25.,biggauss)
	call megauss(sizfi,par(6),FLOAT(p+1),biggauss)
	

c        call megauss(sizfi,3.,mgpos(1),sgauss1)
c	call megauss(sizfi,mgpos(5),mgpos(1),sgauss1)
c	new widths
	call megauss(sizfi,par(29),mgpos(1),sgauss1)

c        call megauss(sizfi,3.,mgpos(2),sgauss2)
c	call megauss(sizfi,mgpos(5),mgpos(2),sgauss2)
c       new widths
	call megauss(sizfi,par(30),mgpos(2),sgauss2)

c	 call megauss(sizfi,3.,mgpos(3),sgauss3)
c	call megauss(sizfi,mgpos(6),mgpos(3),sgauss3)
c        call megauss(sizfi,3.,mgpos(4),sgauss4)
c	call megauss(sizfi,mgpos(6),mgpos(4),sgauss4)
c       new widths
        call megauss(sizfi,par(31),mgpos(3),sgauss3)
        call megauss(sizfi,par(32),mgpos(4),sgauss4)

c	new multi:
	call megauss(sizfi,mgpos(13),mgpos(11),sgauss5)
        call megauss(sizfi,mgpos(13),mgpos(12),sgauss6)
	call megauss(sizfi,mgpos(16),mgpos(14),sgauss7)
        call megauss(sizfi,mgpos(16),mgpos(15),sgauss8)
	call megauss(sizfi,mgpos(19),mgpos(17),sgauss9)
        call megauss(sizfi,mgpos(19),mgpos(18),sgauss10)
        call megauss(sizfi,mgpos(22),mgpos(20),sgauss11)
        call megauss(sizfi,mgpos(22),mgpos(21),sgauss12)


        do i=1,sizfi
                biggauss(i)=biggauss(i)+sgauss1(i)*par(9)
                biggauss(i)=biggauss(i)+sgauss2(i)*x
		biggauss(i)=biggauss(i)+sgauss3(i)*par(11)
                biggauss(i)=biggauss(i)+sgauss4(i)*par(12)
c       new multi:
		biggauss(i)=biggauss(i)+sgauss5(i)*par(21)
                biggauss(i)=biggauss(i)+sgauss6(i)*par(22)
		biggauss(i)=biggauss(i)+sgauss7(i)*par(23)
                biggauss(i)=biggauss(i)+sgauss8(i)*par(24)
		biggauss(i)=biggauss(i)+sgauss9(i)*par(25)
                biggauss(i)=biggauss(i)+sgauss10(i)*par(26)
                biggauss(i)=biggauss(i)+sgauss11(i)*par(27)
                biggauss(i)=biggauss(i)+sgauss12(i)*par(28)
c==     negative wings:
                if (biggauss(i).lt.0.) biggauss(i)=0.
c==

        end do

        fisum=0.
        do i=1,sizfi
                fi(i)=biggauss(i)
                fisum=fisum+fi(i)
        end do

82600	CONTINUE

        do i=1,sizfi
                fi(i)=fi(i)/fisum
        end do
        
cc        if (sizfi.ne.49) then
cc        write(*,*)'Size of single gaussian is not correct!=',sizfi
cc        read(*,*)reply
cc        end if
                  
        call
& mread2(sizf,f,sizg,sizfi,fi,g,g_simu,q,p,s,wn,par,
& ka,sizka,fchi2,star,ka2,sizka2)
                        
c        write(*,*)'Chi2 with new gauss=',fchi2
                        
c        open(32,file='./plot/chunk/megauss.dat')
c        do i=1,sizfi
c                write(32,*)fi(i)
c        end do
c        close(32)
        
        
        multi2=fchi2
        
        
        return
        end

c****************** function multi3 ************************************

        function multi3(x)
        parameter(nb_params=40, maxsiz=1000)
c	parameter(nb_params=40, maxsiz=5000)
        real multi3,x
        real fchi2,fisum
	REAL par(nb_params)
        integer sizf,sizg,sizfi,q,p,sizka,sizka2
        real*8 wn
c        real fi(50),g(maxsiz),g_simu(maxsiz),s(maxsiz)
	real fi(maxsiz),g(maxsiz),s(maxsiz)
	REAL f(5000),g_simu(5000)
c	real ka(10000)

	real ka(40000),ka2(40000)
c	real ka(20000),ka2(20000)

c	real*8 ka(10000)
	integer star
        real*8 pi,sigma,mu,gaus(50),ix
        real*8 term1,term2,term3
        real realgauss(50),biggauss(245)
c	real smallgauss(121)
	real mgpos(30)
	REAL sgauss1(245),sgauss2(245),sgauss3(245),sgauss4(245)
c	new multi:
	REAL sgauss5(245),sgauss6(245),sgauss7(245),sgauss8(245)
	real sgauss9(245),sgauss10(245),sgauss11(245),sgauss12(245)
        common /params/ par,mgpos,star
        common /sizes/ sizka,sizfi,sizka2
        common /convol/ sizf,sizg,p,q,fi,g,s,ka,ka2
        
        
        pi=3.1415927
	
        par(11)=x

	GOTO 84500

c=========================================================
c       size of center gaussian=245 => center=123.
        mu=123.
        
        call megauss(245,par(6),123.,biggauss)

	call megauss(245,18.75,mgpos(1),sgauss1)
	call megauss(245,18.75,mgpos(2),sgauss2)
	call megauss(245,18.75,mgpos(3),sgauss3)
        call megauss(245,18.75,mgpos(4),sgauss4)
        
        do i=1,245
                biggauss(i)=biggauss(i)+sgauss1(i)*par(9)
                biggauss(i)=biggauss(i)+sgauss2(i)*par(10)
		biggauss(i)=biggauss(i)+sgauss3(i)*x
		biggauss(i)=biggauss(i)+sgauss4(i)*par(12)
        end do


        
c-------------- downsampling & normalizing -------------
        
        do i=1,sizfi
                fi(i)=0.
        end do
                
        sizfi=0.
        fisum=0.
        j=1
        count=0

        do i=1,245

                 fi(j)=fi(j)+biggauss(i)
                 count=count+1

                  if(count.eq.5) then
                        fi(j)=fi(j)/5.
cc      negative Wings!
                        if (fi(j).lt.0.) then
                                fi(j)=0.
                        end if
cc
                        fisum=fisum+fi(j)
                        sizfi=sizfi+1
                        j=j+1
                        count=0
                  end if
        end do
c======================= START ==================================
84500	CONTINUE

c	call megauss(sizfi,par(6),25.,biggauss)
	call megauss(sizfi,par(6),FLOAT(p+1),biggauss)

c        call megauss(sizfi,3.,mgpos(1),sgauss1)
c	call megauss(sizfi,mgpos(5),mgpos(1),sgauss1)
c	new widths
	call megauss(sizfi,par(29),mgpos(1),sgauss1)

c        call megauss(sizfi,3.,mgpos(2),sgauss2)
c	call megauss(sizfi,mgpos(5),mgpos(2),sgauss2)
c       new widths
	call megauss(sizfi,par(30),mgpos(2),sgauss2)
c       new widths
        call megauss(sizfi,par(31),mgpos(3),sgauss3)
        call megauss(sizfi,par(32),mgpos(4),sgauss4)

c	 call megauss(sizfi,3.,mgpos(3),sgauss3)
c	call megauss(sizfi,mgpos(6),mgpos(3),sgauss3)	
c        call megauss(sizfi,3.,mgpos(4),sgauss4)
c	call megauss(sizfi,mgpos(6),mgpos(4),sgauss4)
c	new multi:
	call megauss(sizfi,mgpos(13),mgpos(11),sgauss5)
        call megauss(sizfi,mgpos(13),mgpos(12),sgauss6)
	call megauss(sizfi,mgpos(16),mgpos(14),sgauss7)
        call megauss(sizfi,mgpos(16),mgpos(15),sgauss8)
	call megauss(sizfi,mgpos(19),mgpos(17),sgauss9)
        call megauss(sizfi,mgpos(19),mgpos(18),sgauss10)
        call megauss(sizfi,mgpos(22),mgpos(20),sgauss11)
        call megauss(sizfi,mgpos(22),mgpos(21),sgauss12)

        do i=1,sizfi
                biggauss(i)=biggauss(i)+sgauss1(i)*par(9)
                biggauss(i)=biggauss(i)+sgauss2(i)*par(10)
		biggauss(i)=biggauss(i)+sgauss3(i)*x
		biggauss(i)=biggauss(i)+sgauss4(i)*par(12)
c	new multi:
		biggauss(i)=biggauss(i)+sgauss5(i)*par(21)
                biggauss(i)=biggauss(i)+sgauss6(i)*par(22)
		biggauss(i)=biggauss(i)+sgauss7(i)*par(23)
                biggauss(i)=biggauss(i)+sgauss8(i)*par(24)
		biggauss(i)=biggauss(i)+sgauss9(i)*par(25)
                biggauss(i)=biggauss(i)+sgauss10(i)*par(26)
                biggauss(i)=biggauss(i)+sgauss11(i)*par(27)
                biggauss(i)=biggauss(i)+sgauss12(i)*par(28)


c==     negative wings:
                if (biggauss(i).lt.0.) biggauss(i)=0.
c==
        
        end do

        fisum=0.
        do i=1,sizfi
                fi(i)=biggauss(i)
                fisum=fisum+fi(i)
        end do


        do i=1,sizfi
                fi(i)=fi(i)/fisum
        end do
        
cc        if (sizfi.ne.49) then
cc        write(*,*)'Size of single gaussian is not correct!=',sizfi
cc        read(*,*)reply
cc        end if
        
        call
& mread2(sizf,f,sizg,sizfi,fi,g,g_simu,q,p,s,wn,par,
& ka,sizka,fchi2,star,ka2,sizka2)
                        
        multi3=fchi2
        
        return
        end

c********************* new function multi4 *****************************

        function multi4(x)
        parameter(nb_params=40, maxsiz=1000)
c	parameter(nb_params=40, maxsiz=5000)
        real multi4,x
        real fchi2,fisum
	REAL par(nb_params)
        integer sizf,sizg,sizfi,q,p,sizka,sizka2
        real*8 wn
c        real fi(50),g(maxsiz),g_simu(maxsiz),s(maxsiz)
	real fi(maxsiz),g(maxsiz),s(maxsiz)
	integer star
c	real ka(10000)
	real ka(40000),ka2(40000)
c	real ka(20000),ka2(20000)
	REAL f(5000),g_simu(5000)
c	real*8 ka(10000)

        real*8 pi,sigma,mu,gaus(50),ix
        real*8 term1,term2,term3
        real realgauss(50),biggauss(245)
c	real smallgauss(121)
	real mgpos(30)
	REAL sgauss1(245),sgauss2(245),sgauss3(245),sgauss4(245)
c	new multi:
	REAL sgauss5(245),sgauss6(245),sgauss7(245),sgauss8(245)
	real sgauss9(245),sgauss10(245),sgauss11(245),sgauss12(245)

        common /params/ par,mgpos,star
        common /sizes/ sizka,sizfi,sizka2
        common /convol/ sizf,sizg,p,q,fi,g,s,ka,ka2

c------
        
        par(12)=x

	GOTO 86500
c====================================================

        call megauss(245,par(6),123.,biggauss)
        
	call megauss(245,18.75,mgpos(1),sgauss1)
        call megauss(245,18.75,mgpos(2),sgauss2)
        call megauss(245,18.75,mgpos(3),sgauss3)
        call megauss(245,18.75,mgpos(4),sgauss4)

        do i=1,245
                biggauss(i)=biggauss(i)+sgauss1(i)*par(9)
                biggauss(i)=biggauss(i)+sgauss2(i)*par(10)
                biggauss(i)=biggauss(i)+sgauss3(i)*par(11)
                biggauss(i)=biggauss(i)+sgauss4(i)*x
        end do



	
c-------------- downsampling & normalizing -------------
        
        do i=1,sizfi
                fi(i)=0.
        end do
                
        sizfi=0.
        fisum=0.
        j=1
        count=0

        do i=1,245

                fi(j)=fi(j)+biggauss(i)
                 count=count+1

                  if(count.eq.5) then
                        fi(j)=fi(j)/5.
cc      no negative Wings!
                        if (fi(j).lt.0.) then
                                fi(j)=0.
                        end if
cc
                        fisum=fisum+fi(j)
                        sizfi=sizfi+1
                        j=j+1
                        count=0
                  end if
        end do

c============================================================
86500	CONTINUE
	call megauss(sizfi,par(6),FLOAT(p+1),biggauss)
c	call megauss(sizfi,par(6),25.,biggauss)

c        call megauss(sizfi,3.,mgpos(1),sgauss1)
c	call megauss(sizfi,mgpos(5),mgpos(1),sgauss1)
c	new widths:
	call megauss(sizfi,par(29),mgpos(1),sgauss1)	

c        call megauss(sizfi,3.,mgpos(2),sgauss2)
c	call megauss(sizfi,mgpos(5),mgpos(2),sgauss2)
c       new widths:
	call megauss(sizfi,par(30),mgpos(2),sgauss2)
c       new widths
        call megauss(sizfi,par(31),mgpos(3),sgauss3)
        call megauss(sizfi,par(32),mgpos(4),sgauss4)

c        call megauss(sizfi,3.,mgpos(3),sgauss3)
c	call megauss(sizfi,mgpos(6),mgpos(3),sgauss3)
c        call megauss(sizfi,3.,mgpos(4),sgauss4)
c	call megauss(sizfi,mgpos(6),mgpos(4),sgauss4)
c	new multi:
	call megauss(sizfi,mgpos(13),mgpos(11),sgauss5)
        call megauss(sizfi,mgpos(13),mgpos(12),sgauss6)
	call megauss(sizfi,mgpos(16),mgpos(14),sgauss7)
        call megauss(sizfi,mgpos(16),mgpos(15),sgauss8)
	call megauss(sizfi,mgpos(19),mgpos(17),sgauss9)
        call megauss(sizfi,mgpos(19),mgpos(18),sgauss10)
        call megauss(sizfi,mgpos(22),mgpos(20),sgauss11)
        call megauss(sizfi,mgpos(22),mgpos(21),sgauss12)	


	do i=1,sizfi
                biggauss(i)=biggauss(i)+sgauss1(i)*par(9)
                biggauss(i)=biggauss(i)+sgauss2(i)*par(10)
                biggauss(i)=biggauss(i)+sgauss3(i)*par(11)
                biggauss(i)=biggauss(i)+sgauss4(i)*x
c       new multi:
		biggauss(i)=biggauss(i)+sgauss5(i)*par(21)
                biggauss(i)=biggauss(i)+sgauss6(i)*par(22)
		biggauss(i)=biggauss(i)+sgauss7(i)*par(23)
                biggauss(i)=biggauss(i)+sgauss8(i)*par(24)
		biggauss(i)=biggauss(i)+sgauss9(i)*par(25)
                biggauss(i)=biggauss(i)+sgauss10(i)*par(26)
                biggauss(i)=biggauss(i)+sgauss11(i)*par(27)
                biggauss(i)=biggauss(i)+sgauss12(i)*par(28)

c==     negative wings:
                if (biggauss(i).lt.0.) biggauss(i)=0.
c==     
        
        end do
              
        fisum=0.

        do i=1,sizfi
                fi(i)=biggauss(i)
                fisum=fisum+fi(i)
        end do
        

        do i=1,sizfi
                fi(i)=fi(i)/fisum
        end do
        
cc        if (sizfi.ne.49) then
cc        write(*,*)'Size of single gaussian is not correct!=',sizfi
cc        read(*,*)reply
cc        end if
        
        call
& mread2(sizf,f,sizg,sizfi,fi,g,g_simu,q,p,s,wn,par,
& ka,sizka,fchi2,star,ka2,sizka2)
                        
        multi4=fchi2
        
        return
        end

c=================================================================================================

        function multi5(x)
        parameter(nb_params=40, maxsiz=1000)
        real multi5,x
        real fchi2,fisum
        REAL par(nb_params)
        integer sizf,sizg,sizfi,q,p,sizka,sizka2
        real*8 wn
        real fi(maxsiz),g(maxsiz),s(maxsiz)
        REAL f(5000),g_simu(5000)
        real ka(40000),ka2(40000)
        integer star

        real*8 pi,sigma,mu,gaus(50),ix
        real*8 term1,term2,term3
        real realgauss(50),biggauss(245),sgauss1(245)
        real sgauss2(245),sgauss3(245),sgauss4(245)
	real sgauss5(245),sgauss6(245),sgauss7(245),sgauss8(245)
        real mgpos(30)
	real sgauss9(245),sgauss10(245),sgauss11(245),sgauss12(245)

        common /params/ par,mgpos,star
        common /sizes/ sizka,sizfi,sizka2
        common /convol/ sizf,sizg,p,q,fi,g,s,ka,ka2

        pi=3.1415927

        par(21)=x

c====================== START ==================================

	call megauss(sizfi,par(6),FLOAT(p+1),biggauss)
c        call megauss(sizfi,par(6),25.,biggauss)
c	new widths:
        call megauss(sizfi,par(29),mgpos(1),sgauss1)
        call megauss(sizfi,par(30),mgpos(2),sgauss2)
c       new widths
        call megauss(sizfi,par(31),mgpos(3),sgauss3)
        call megauss(sizfi,par(32),mgpos(4),sgauss4)

c
c        call megauss(sizfi,mgpos(6),mgpos(3),sgauss3)
c        call megauss(sizfi,mgpos(6),mgpos(4),sgauss4)
	call megauss(sizfi,mgpos(13),mgpos(11),sgauss5)
	call megauss(sizfi,mgpos(13),mgpos(12),sgauss6)
	call megauss(sizfi,mgpos(16),mgpos(14),sgauss7)
        call megauss(sizfi,mgpos(16),mgpos(15),sgauss8)
	call megauss(sizfi,mgpos(19),mgpos(17),sgauss9)
        call megauss(sizfi,mgpos(19),mgpos(18),sgauss10)
        call megauss(sizfi,mgpos(22),mgpos(20),sgauss11)
        call megauss(sizfi,mgpos(22),mgpos(21),sgauss12)

        do i=1,sizfi

                biggauss(i)=biggauss(i)+sgauss1(i)*par(9)
                biggauss(i)=biggauss(i)+sgauss2(i)*par(10)
                biggauss(i)=biggauss(i)+sgauss3(i)*par(11)
                biggauss(i)=biggauss(i)+sgauss4(i)*par(12)
		biggauss(i)=biggauss(i)+sgauss5(i)*x
		biggauss(i)=biggauss(i)+sgauss6(i)*par(22)
		biggauss(i)=biggauss(i)+sgauss7(i)*par(23)
                biggauss(i)=biggauss(i)+sgauss8(i)*par(24)
		biggauss(i)=biggauss(i)+sgauss9(i)*par(25)
                biggauss(i)=biggauss(i)+sgauss10(i)*par(26)
                biggauss(i)=biggauss(i)+sgauss11(i)*par(27)
                biggauss(i)=biggauss(i)+sgauss12(i)*par(28)

c==     negative wings:
                if (biggauss(i).lt.0.) biggauss(i)=0.
c==

        end do

        fisum=0.
        do i=1,sizfi
                fi(i)=biggauss(i)
                fisum=fisum+fi(i)
        end do

        do i=1,sizfi
                fi(i)=fi(i)/fisum
        end do

        call
& mread2(sizf,f,sizg,sizfi,fi,g,g_simu,q,p,s,wn,par,
& ka,sizka,fchi2,star,ka2,sizka2)

        multi5=fchi2

        return
        end

c==========================================================================

        function multi6(x)
        parameter(nb_params=40, maxsiz=1000)
        real multi6,x
        real fchi2,fisum
        REAL par(nb_params)
        integer sizf,sizg,sizfi,q,p,sizka,sizka2
        real*8 wn
        real fi(maxsiz),g(maxsiz),s(maxsiz)
        REAL f(5000),g_simu(5000)
        real ka(40000),ka2(40000)
        integer star

        real*8 pi,sigma,mu,gaus(50),ix
        real*8 term1,term2,term3
        real realgauss(50),biggauss(245),sgauss1(245)
        real sgauss2(245),sgauss3(245),sgauss4(245)
        real sgauss5(245),sgauss6(245),sgauss7(245),sgauss8(245)
        real mgpos(30)
	real sgauss9(245),sgauss10(245),sgauss11(245),sgauss12(245)
        common /params/ par,mgpos,star
        common /sizes/ sizka,sizfi,sizka2
        common /convol/ sizf,sizg,p,q,fi,g,s,ka,ka2

        pi=3.1415927

        par(22)=x
c====================== START ==================================
	call megauss(sizfi,par(6),FLOAT(p+1),biggauss)
c        call megauss(sizfi,par(6),25.,biggauss)

c       new widths:
        call megauss(sizfi,par(29),mgpos(1),sgauss1)
        call megauss(sizfi,par(30),mgpos(2),sgauss2)
c
c        call megauss(sizfi,mgpos(6),mgpos(3),sgauss3)
c        call megauss(sizfi,mgpos(6),mgpos(4),sgauss4)
c       new widths
        call megauss(sizfi,par(31),mgpos(3),sgauss3)
        call megauss(sizfi,par(32),mgpos(4),sgauss4)

        call megauss(sizfi,mgpos(13),mgpos(11),sgauss5)
        call megauss(sizfi,mgpos(13),mgpos(12),sgauss6)
	call megauss(sizfi,mgpos(16),mgpos(14),sgauss7)
        call megauss(sizfi,mgpos(16),mgpos(15),sgauss8)
	call megauss(sizfi,mgpos(19),mgpos(17),sgauss9)
        call megauss(sizfi,mgpos(19),mgpos(18),sgauss10)
        call megauss(sizfi,mgpos(22),mgpos(20),sgauss11)
        call megauss(sizfi,mgpos(22),mgpos(21),sgauss12)

        do i=1,sizfi

                biggauss(i)=biggauss(i)+sgauss1(i)*par(9)
                biggauss(i)=biggauss(i)+sgauss2(i)*par(10)
                biggauss(i)=biggauss(i)+sgauss3(i)*par(11)
                biggauss(i)=biggauss(i)+sgauss4(i)*par(12)
                biggauss(i)=biggauss(i)+sgauss5(i)*par(21)
                biggauss(i)=biggauss(i)+sgauss6(i)*x
		biggauss(i)=biggauss(i)+sgauss7(i)*par(23)
                biggauss(i)=biggauss(i)+sgauss8(i)*par(24)
		biggauss(i)=biggauss(i)+sgauss9(i)*par(25)
                biggauss(i)=biggauss(i)+sgauss10(i)*par(26)
                biggauss(i)=biggauss(i)+sgauss11(i)*par(27)
                biggauss(i)=biggauss(i)+sgauss12(i)*par(28)

c==     negative wings:
                if (biggauss(i).lt.0.) biggauss(i)=0.
c==

        end do

        fisum=0.
        do i=1,sizfi
                fi(i)=biggauss(i)
                fisum=fisum+fi(i)
        end do

        do i=1,sizfi
                fi(i)=fi(i)/fisum
        end do

        call
& mread2(sizf,f,sizg,sizfi,fi,g,g_simu,q,p,s,wn,par,
& ka,sizka,fchi2,star,ka2,sizka2)

        multi6=fchi2

        return
        end

c************************************************************************
        function multi7(x)
        parameter(nb_params=40, maxsiz=1000)
        real multi7,x
        real fchi2,fisum
        REAL par(nb_params)
        integer sizf,sizg,sizfi,q,p,sizka,sizka2
        real*8 wn
        real fi(maxsiz),g(maxsiz),s(maxsiz)
        REAL f(5000),g_simu(5000)
        real ka(40000),ka2(40000)
        integer star

        real*8 pi,sigma,mu,gaus(50),ix
        real*8 term1,term2,term3
        real realgauss(50),biggauss(245),sgauss1(245)
        real sgauss2(245),sgauss3(245),sgauss4(245)
        real sgauss5(245),sgauss6(245),sgauss7(245),sgauss8(245)
        real mgpos(30)
	real sgauss9(245),sgauss10(245),sgauss11(245),sgauss12(245)
        common /params/ par,mgpos,star
        common /sizes/ sizka,sizfi,sizka2
        common /convol/ sizf,sizg,p,q,fi,g,s,ka,ka2

        pi=3.1415927

        par(23)=x
c====================== START ==================================
	call megauss(sizfi,par(6),FLOAT(p+1),biggauss)
c        call megauss(sizfi,par(6),25.,biggauss)

c       new widths:
        call megauss(sizfi,par(29),mgpos(1),sgauss1)
        call megauss(sizfi,par(30),mgpos(2),sgauss2)
c
c        call megauss(sizfi,mgpos(6),mgpos(3),sgauss3)
c        call megauss(sizfi,mgpos(6),mgpos(4),sgauss4)
c       new widths
        call megauss(sizfi,par(31),mgpos(3),sgauss3)
        call megauss(sizfi,par(32),mgpos(4),sgauss4)

        call megauss(sizfi,mgpos(13),mgpos(11),sgauss5)
        call megauss(sizfi,mgpos(13),mgpos(12),sgauss6)
	call megauss(sizfi,mgpos(16),mgpos(14),sgauss7)
	call megauss(sizfi,mgpos(16),mgpos(15),sgauss8)
	call megauss(sizfi,mgpos(19),mgpos(17),sgauss9)
        call megauss(sizfi,mgpos(19),mgpos(18),sgauss10)
        call megauss(sizfi,mgpos(22),mgpos(20),sgauss11)
        call megauss(sizfi,mgpos(22),mgpos(21),sgauss12)

        do i=1,sizfi
                biggauss(i)=biggauss(i)+sgauss1(i)*par(9)
                biggauss(i)=biggauss(i)+sgauss2(i)*par(10)
                biggauss(i)=biggauss(i)+sgauss3(i)*par(11)
                biggauss(i)=biggauss(i)+sgauss4(i)*par(12)
                biggauss(i)=biggauss(i)+sgauss5(i)*par(21)
                biggauss(i)=biggauss(i)+sgauss6(i)*par(22)
		biggauss(i)=biggauss(i)+sgauss7(i)*x
                biggauss(i)=biggauss(i)+sgauss8(i)*par(24)
		biggauss(i)=biggauss(i)+sgauss9(i)*par(25)
                biggauss(i)=biggauss(i)+sgauss10(i)*par(26)
                biggauss(i)=biggauss(i)+sgauss11(i)*par(27)
                biggauss(i)=biggauss(i)+sgauss12(i)*par(28)

c==     negative wings:
                if (biggauss(i).lt.0.) biggauss(i)=0.
c==

        end do

        fisum=0.
        do i=1,sizfi
                fi(i)=biggauss(i)
                fisum=fisum+fi(i)
        end do

        do i=1,sizfi
                fi(i)=fi(i)/fisum
        end do

        call
& mread2(sizf,f,sizg,sizfi,fi,g,g_simu,q,p,s,wn,par,
& ka,sizka,fchi2,star,ka2,sizka2)

        multi7=fchi2

        return
        end

c************************************************************************
       function multi8(x)
        parameter(nb_params=40, maxsiz=1000)
        real multi8,x
        real fchi2,fisum
        REAL par(nb_params)
        integer sizf,sizg,sizfi,q,p,sizka,sizka2
        real*8 wn
        real fi(maxsiz),g(maxsiz),s(maxsiz)
        REAL f(5000),g_simu(5000)
        real ka(40000),ka2(40000)
        integer star

        real*8 pi,sigma,mu,gaus(50),ix
        real*8 term1,term2,term3
        real realgauss(50),biggauss(245),sgauss1(245)
        real sgauss2(245),sgauss3(245),sgauss4(245)
        real sgauss5(245),sgauss6(245),sgauss7(245),sgauss8(245)
        real mgpos(30)
	real sgauss9(245),sgauss10(245),sgauss11(245),sgauss12(245)

        common /params/ par,mgpos,star
        common /sizes/ sizka,sizfi,sizka2
        common /convol/ sizf,sizg,p,q,fi,g,s,ka,ka2

        pi=3.1415927

        par(24)=x
c====================== START ==================================
	call megauss(sizfi,par(6),FLOAT(p+1),biggauss)
c        call megauss(sizfi,par(6),25.,biggauss)
c       new widths:
        call megauss(sizfi,par(29),mgpos(1),sgauss1)
        call megauss(sizfi,par(30),mgpos(2),sgauss2)
c
c       new widths
        call megauss(sizfi,par(31),mgpos(3),sgauss3)
        call megauss(sizfi,par(32),mgpos(4),sgauss4)

c        call megauss(sizfi,mgpos(6),mgpos(3),sgauss3)
c        call megauss(sizfi,mgpos(6),mgpos(4),sgauss4)
        call megauss(sizfi,mgpos(13),mgpos(11),sgauss5)
        call megauss(sizfi,mgpos(13),mgpos(12),sgauss6)
        call megauss(sizfi,mgpos(16),mgpos(14),sgauss7)
        call megauss(sizfi,mgpos(16),mgpos(15),sgauss8)
	call megauss(sizfi,mgpos(19),mgpos(17),sgauss9)
        call megauss(sizfi,mgpos(19),mgpos(18),sgauss10)
        call megauss(sizfi,mgpos(22),mgpos(20),sgauss11)
        call megauss(sizfi,mgpos(22),mgpos(21),sgauss12)

        do i=1,sizfi
                biggauss(i)=biggauss(i)+sgauss1(i)*par(9)
                biggauss(i)=biggauss(i)+sgauss2(i)*par(10)
                biggauss(i)=biggauss(i)+sgauss3(i)*par(11)
                biggauss(i)=biggauss(i)+sgauss4(i)*par(12)
                biggauss(i)=biggauss(i)+sgauss5(i)*par(21)
                biggauss(i)=biggauss(i)+sgauss6(i)*par(22)
                biggauss(i)=biggauss(i)+sgauss7(i)*par(23)
                biggauss(i)=biggauss(i)+sgauss8(i)*x
		biggauss(i)=biggauss(i)+sgauss9(i)*par(25)
                biggauss(i)=biggauss(i)+sgauss10(i)*par(26)
                biggauss(i)=biggauss(i)+sgauss11(i)*par(27)
                biggauss(i)=biggauss(i)+sgauss12(i)*par(28)

c==     negative wings:
                if (biggauss(i).lt.0.) biggauss(i)=0.
c==

        end do

        fisum=0.
        do i=1,sizfi
                fi(i)=biggauss(i)
                fisum=fisum+fi(i)
        end do

        do i=1,sizfi
                fi(i)=fi(i)/fisum
        end do

        call
& mread2(sizf,f,sizg,sizfi,fi,g,g_simu,q,p,s,wn,par,
& ka,sizka,fchi2,star,ka2,sizka2)

        multi8=fchi2

        return
        end


c************************************************************************
       function multi9(x)
        parameter(nb_params=40, maxsiz=1000)
        real multi9,x
        real fchi2,fisum
        REAL par(nb_params)
        integer sizf,sizg,sizfi,q,p,sizka,sizka2
        real*8 wn
        real fi(maxsiz),g(maxsiz),s(maxsiz)
        REAL f(5000),g_simu(5000)
        real ka(40000),ka2(40000)
        integer star

        real*8 pi,sigma,mu,gaus(50),ix
        real*8 term1,term2,term3
        real realgauss(50),biggauss(245),sgauss1(245)
        real sgauss2(245),sgauss3(245),sgauss4(245)
        real sgauss5(245),sgauss6(245),sgauss7(245),sgauss8(245)
        real sgauss9(245),sgauss10(245),sgauss11(245),sgauss12(245)
        real mgpos(30)

        common /params/ par,mgpos,star
        common /sizes/ sizka,sizfi,sizka2
        common /convol/ sizf,sizg,p,q,fi,g,s,ka,ka2

        pi=3.1415927

        par(25)=x
c====================== START ==================================
	call megauss(sizfi,par(6),FLOAT(p+1),biggauss)
c        call megauss(sizfi,par(6),25.,biggauss)
c       new widths:
        call megauss(sizfi,par(29),mgpos(1),sgauss1)
        call megauss(sizfi,par(30),mgpos(2),sgauss2)
c
c        call megauss(sizfi,mgpos(6),mgpos(3),sgauss3)
c        call megauss(sizfi,mgpos(6),mgpos(4),sgauss4)
c       new widths
        call megauss(sizfi,par(31),mgpos(3),sgauss3)
        call megauss(sizfi,par(32),mgpos(4),sgauss4)
        call megauss(sizfi,mgpos(13),mgpos(11),sgauss5)
        call megauss(sizfi,mgpos(13),mgpos(12),sgauss6)
        call megauss(sizfi,mgpos(16),mgpos(14),sgauss7)
        call megauss(sizfi,mgpos(16),mgpos(15),sgauss8)
        call megauss(sizfi,mgpos(19),mgpos(17),sgauss9)
        call megauss(sizfi,mgpos(19),mgpos(18),sgauss10)
        call megauss(sizfi,mgpos(22),mgpos(20),sgauss11)
        call megauss(sizfi,mgpos(22),mgpos(21),sgauss12)
        do i=1,sizfi
                biggauss(i)=biggauss(i)+sgauss1(i)*par(9)
                biggauss(i)=biggauss(i)+sgauss2(i)*par(10)
                biggauss(i)=biggauss(i)+sgauss3(i)*par(11)
                biggauss(i)=biggauss(i)+sgauss4(i)*par(12)
                biggauss(i)=biggauss(i)+sgauss5(i)*par(21)
                biggauss(i)=biggauss(i)+sgauss6(i)*par(22)
                biggauss(i)=biggauss(i)+sgauss7(i)*par(23)
                biggauss(i)=biggauss(i)+sgauss8(i)*par(24)
                biggauss(i)=biggauss(i)+sgauss9(i)*x
                biggauss(i)=biggauss(i)+sgauss10(i)*par(26)
                biggauss(i)=biggauss(i)+sgauss11(i)*par(27)
                biggauss(i)=biggauss(i)+sgauss12(i)*par(28)
c==     negative wings:
                if (biggauss(i).lt.0.) biggauss(i)=0.
c==

        end do
        fisum=0.
        do i=1,sizfi
                fi(i)=biggauss(i)
                fisum=fisum+fi(i)
        end do

        do i=1,sizfi
                fi(i)=fi(i)/fisum
        end do

        call
& mread2(sizf,f,sizg,sizfi,fi,g,g_simu,q,p,s,wn,par,
& ka,sizka,fchi2,star,ka2,sizka2)

        multi9=fchi2

        return
        end
c************************************************************************
        function multi10(x)
        parameter(nb_params=40, maxsiz=1000)
        real multi10,x
        real fchi2,fisum
        REAL par(nb_params)
        integer sizf,sizg,sizfi,q,p,sizka,sizka2
        real*8 wn
        real fi(maxsiz),g(maxsiz),s(maxsiz)
        REAL f(5000),g_simu(5000)
        real ka(40000),ka2(40000)
        integer star

        real*8 pi,sigma,mu,gaus(50),ix
        real*8 term1,term2,term3
        real realgauss(50),biggauss(245),sgauss1(245)
        real sgauss2(245),sgauss3(245),sgauss4(245)
        real sgauss5(245),sgauss6(245),sgauss7(245),sgauss8(245)
        real sgauss9(245),sgauss10(245),sgauss11(245),sgauss12(245)
        real mgpos(30)

        common /params/ par,mgpos,star
        common /sizes/ sizka,sizfi,sizka2
        common /convol/ sizf,sizg,p,q,fi,g,s,ka,ka2

        pi=3.1415927

        par(26)=x
c====================== START ==================================
	call megauss(sizfi,par(6),FLOAT(p+1),biggauss)
c        call megauss(sizfi,par(6),25.,biggauss)
c       new widths:
        call megauss(sizfi,par(29),mgpos(1),sgauss1)
        call megauss(sizfi,par(30),mgpos(2),sgauss2)
c
c        call megauss(sizfi,mgpos(6),mgpos(3),sgauss3)
c        call megauss(sizfi,mgpos(6),mgpos(4),sgauss4)
c       new widths
        call megauss(sizfi,par(31),mgpos(3),sgauss3)
        call megauss(sizfi,par(32),mgpos(4),sgauss4)

        call megauss(sizfi,mgpos(13),mgpos(11),sgauss5)
        call megauss(sizfi,mgpos(13),mgpos(12),sgauss6)
        call megauss(sizfi,mgpos(16),mgpos(14),sgauss7)
        call megauss(sizfi,mgpos(16),mgpos(15),sgauss8)
        call megauss(sizfi,mgpos(19),mgpos(17),sgauss9)
        call megauss(sizfi,mgpos(19),mgpos(18),sgauss10)
        call megauss(sizfi,mgpos(22),mgpos(20),sgauss11)
        call megauss(sizfi,mgpos(22),mgpos(21),sgauss12)
        do i=1,sizfi
                biggauss(i)=biggauss(i)+sgauss1(i)*par(9)
                biggauss(i)=biggauss(i)+sgauss2(i)*par(10)
                biggauss(i)=biggauss(i)+sgauss3(i)*par(11)
                biggauss(i)=biggauss(i)+sgauss4(i)*par(12)
                biggauss(i)=biggauss(i)+sgauss5(i)*par(21)
                biggauss(i)=biggauss(i)+sgauss6(i)*par(22)
                biggauss(i)=biggauss(i)+sgauss7(i)*par(23)
                biggauss(i)=biggauss(i)+sgauss8(i)*par(24)
                biggauss(i)=biggauss(i)+sgauss9(i)*par(25)
                biggauss(i)=biggauss(i)+sgauss10(i)*x
                biggauss(i)=biggauss(i)+sgauss11(i)*par(27)
                biggauss(i)=biggauss(i)+sgauss12(i)*par(28)
c==     negative wings:
                if (biggauss(i).lt.0.) biggauss(i)=0.
c==

        end do

        fisum=0.
        do i=1,sizfi
                fi(i)=biggauss(i)
                fisum=fisum+fi(i)
        end do

        do i=1,sizfi
                fi(i)=fi(i)/fisum
        end do

        call
& mread2(sizf,f,sizg,sizfi,fi,g,g_simu,q,p,s,wn,par,
& ka,sizka,fchi2,star,ka2,sizka2)

        multi10=fchi2

        return
        end

c************************************************************************
        function multi11(x)
        parameter(nb_params=40, maxsiz=1000)
        real multi11,x
        real fchi2,fisum
        REAL par(nb_params)
        integer sizf,sizg,sizfi,q,p,sizka,sizka2
        real*8 wn
        real fi(maxsiz),g(maxsiz),s(maxsiz)
        REAL f(5000),g_simu(5000)
        real ka(40000),ka2(40000)
        integer star

        real*8 pi,sigma,mu,gaus(50),ix
        real*8 term1,term2,term3
        real realgauss(50),biggauss(245),sgauss1(245)
        real sgauss2(245),sgauss3(245),sgauss4(245)
        real sgauss5(245),sgauss6(245),sgauss7(245),sgauss8(245)
        real sgauss9(245),sgauss10(245),sgauss11(245),sgauss12(245)
        real mgpos(30)

        common /params/ par,mgpos,star
        common /sizes/ sizka,sizfi,sizka2
        common /convol/ sizf,sizg,p,q,fi,g,s,ka,ka2

        pi=3.1415927

        par(27)=x
c====================== START ==================================
	call megauss(sizfi,par(6),FLOAT(p+1),biggauss)
c        call megauss(sizfi,par(6),25.,biggauss)
c       new widths:
        call megauss(sizfi,par(29),mgpos(1),sgauss1)
        call megauss(sizfi,par(30),mgpos(2),sgauss2)
c
c        call megauss(sizfi,mgpos(6),mgpos(3),sgauss3)
c        call megauss(sizfi,mgpos(6),mgpos(4),sgauss4)
c       new widths
        call megauss(sizfi,par(31),mgpos(3),sgauss3)
        call megauss(sizfi,par(32),mgpos(4),sgauss4)

        call megauss(sizfi,mgpos(13),mgpos(11),sgauss5)
        call megauss(sizfi,mgpos(13),mgpos(12),sgauss6)
        call megauss(sizfi,mgpos(16),mgpos(14),sgauss7)
        call megauss(sizfi,mgpos(16),mgpos(15),sgauss8)
        call megauss(sizfi,mgpos(19),mgpos(17),sgauss9)
        call megauss(sizfi,mgpos(19),mgpos(18),sgauss10)
        call megauss(sizfi,mgpos(22),mgpos(20),sgauss11)
        call megauss(sizfi,mgpos(22),mgpos(21),sgauss12)
        do i=1,sizfi
                biggauss(i)=biggauss(i)+sgauss1(i)*par(9)
                biggauss(i)=biggauss(i)+sgauss2(i)*par(10)
                biggauss(i)=biggauss(i)+sgauss3(i)*par(11)
                biggauss(i)=biggauss(i)+sgauss4(i)*par(12)
                biggauss(i)=biggauss(i)+sgauss5(i)*par(21)
                biggauss(i)=biggauss(i)+sgauss6(i)*par(22)
                biggauss(i)=biggauss(i)+sgauss7(i)*par(23)
                biggauss(i)=biggauss(i)+sgauss8(i)*par(24)
                biggauss(i)=biggauss(i)+sgauss9(i)*par(25)
                biggauss(i)=biggauss(i)+sgauss10(i)*par(26)
                biggauss(i)=biggauss(i)+sgauss11(i)*x
                biggauss(i)=biggauss(i)+sgauss12(i)*par(28)
c==     negative wings:
                if (biggauss(i).lt.0.) biggauss(i)=0.
c==

        end do

        fisum=0.
        do i=1,sizfi
                fi(i)=biggauss(i)
                fisum=fisum+fi(i)
        end do

        do i=1,sizfi
                fi(i)=fi(i)/fisum
        end do

        call
& mread2(sizf,f,sizg,sizfi,fi,g,g_simu,q,p,s,wn,par,
& ka,sizka,fchi2,star,ka2,sizka2)

        multi11=fchi2

        return
        end

c************************************************************************
        function multi12(x)
        parameter(nb_params=40, maxsiz=1000)
        real multi12,x
        real fchi2,fisum
        REAL par(nb_params)
        integer sizf,sizg,sizfi,q,p,sizka,sizka2
        real*8 wn
        real fi(maxsiz),g(maxsiz),s(maxsiz)
        REAL f(5000),g_simu(5000)
        real ka(40000),ka2(40000)
        integer star

        real*8 pi,sigma,mu,gaus(50),ix
        real*8 term1,term2,term3
        real realgauss(50),biggauss(245),sgauss1(245)
        real sgauss2(245),sgauss3(245),sgauss4(245)
        real sgauss5(245),sgauss6(245),sgauss7(245),sgauss8(245)
        real sgauss9(245),sgauss10(245),sgauss11(245),sgauss12(245)
        real mgpos(30)

        common /params/ par,mgpos,star
        common /sizes/ sizka,sizfi,sizka2
        common /convol/ sizf,sizg,p,q,fi,g,s,ka,ka2

        pi=3.1415927

        par(28)=x
c====================== START ==================================
	call megauss(sizfi,par(6),FLOAT(p+1),biggauss)
c        call megauss(sizfi,par(6),25.,biggauss)
c       new widths:
        call megauss(sizfi,par(29),mgpos(1),sgauss1)
        call megauss(sizfi,par(30),mgpos(2),sgauss2)
c
c        call megauss(sizfi,mgpos(6),mgpos(3),sgauss3)
c        call megauss(sizfi,mgpos(6),mgpos(4),sgauss4)
c       new widths
        call megauss(sizfi,par(31),mgpos(3),sgauss3)
        call megauss(sizfi,par(32),mgpos(4),sgauss4)

        call megauss(sizfi,mgpos(13),mgpos(11),sgauss5)
        call megauss(sizfi,mgpos(13),mgpos(12),sgauss6)
        call megauss(sizfi,mgpos(16),mgpos(14),sgauss7)
        call megauss(sizfi,mgpos(16),mgpos(15),sgauss8)
        call megauss(sizfi,mgpos(19),mgpos(17),sgauss9)
        call megauss(sizfi,mgpos(19),mgpos(18),sgauss10)
        call megauss(sizfi,mgpos(22),mgpos(20),sgauss11)
        call megauss(sizfi,mgpos(22),mgpos(21),sgauss12)
        do i=1,sizfi
                biggauss(i)=biggauss(i)+sgauss1(i)*par(9)
                biggauss(i)=biggauss(i)+sgauss2(i)*par(10)
                biggauss(i)=biggauss(i)+sgauss3(i)*par(11)
                biggauss(i)=biggauss(i)+sgauss4(i)*par(12)
                biggauss(i)=biggauss(i)+sgauss5(i)*par(21)
                biggauss(i)=biggauss(i)+sgauss6(i)*par(22)
                biggauss(i)=biggauss(i)+sgauss7(i)*par(23)
                biggauss(i)=biggauss(i)+sgauss8(i)*par(24)
                biggauss(i)=biggauss(i)+sgauss9(i)*par(25)
                biggauss(i)=biggauss(i)+sgauss10(i)*par(26)
                biggauss(i)=biggauss(i)+sgauss11(i)*par(27)
                biggauss(i)=biggauss(i)+sgauss12(i)*x
c==     negative wings:
                if (biggauss(i).lt.0.) biggauss(i)=0.
c==

        end do

        fisum=0.
        do i=1,sizfi
                fi(i)=biggauss(i)
                fisum=fisum+fi(i)
        end do

        do i=1,sizfi
                fi(i)=fi(i)/fisum
        end do

        call
& mread2(sizf,f,sizg,sizfi,fi,g,g_simu,q,p,s,wn,par,
& ka,sizka,fchi2,star,ka2,sizka2)

        multi12=fchi2

        return
        end

c************************************************************************
        function width1(x)
        parameter(nb_params=40, maxsiz=1000)
        real width1,x
        real fchi2,fisum
        REAL par(nb_params)
        integer sizf,sizg,sizfi,q,p,sizka,sizka2
        real*8 wn
        real fi(maxsiz),g(maxsiz),s(maxsiz)
        REAL f(5000),g_simu(5000)
        real ka(40000),ka2(40000)
        integer star

        real*8 pi,sigma,mu,gaus(50),ix
        real*8 term1,term2,term3
        real realgauss(50),biggauss(245),sgauss1(245)
        real sgauss2(245),sgauss3(245),sgauss4(245)
        real sgauss5(245),sgauss6(245),sgauss7(245),sgauss8(245)
        real sgauss9(245),sgauss10(245),sgauss11(245),sgauss12(245)
        real mgpos(30)

        common /params/ par,mgpos,star
        common /sizes/ sizka,sizfi,sizka2
        common /convol/ sizf,sizg,p,q,fi,g,s,ka,ka2

        pi=3.1415927

        par(29)=x
c====================== START ==================================
	call megauss(sizfi,par(6),FLOAT(p+1),biggauss)
c        call megauss(sizfi,par(6),25.,biggauss)
c       new widths:
        call megauss(sizfi,x,mgpos(1),sgauss1)
        call megauss(sizfi,par(30),mgpos(2),sgauss2)
c
c        call megauss(sizfi,mgpos(6),mgpos(3),sgauss3)
c        call megauss(sizfi,mgpos(6),mgpos(4),sgauss4)
c       new widths
        call megauss(sizfi,par(31),mgpos(3),sgauss3)
        call megauss(sizfi,par(32),mgpos(4),sgauss4)

        call megauss(sizfi,mgpos(13),mgpos(11),sgauss5)
        call megauss(sizfi,mgpos(13),mgpos(12),sgauss6)
        call megauss(sizfi,mgpos(16),mgpos(14),sgauss7)
        call megauss(sizfi,mgpos(16),mgpos(15),sgauss8)
        call megauss(sizfi,mgpos(19),mgpos(17),sgauss9)
        call megauss(sizfi,mgpos(19),mgpos(18),sgauss10)
        call megauss(sizfi,mgpos(22),mgpos(20),sgauss11)
        call megauss(sizfi,mgpos(22),mgpos(21),sgauss12)
        do i=1,sizfi
                biggauss(i)=biggauss(i)+sgauss1(i)*par(9)
                biggauss(i)=biggauss(i)+sgauss2(i)*par(10)
                biggauss(i)=biggauss(i)+sgauss3(i)*par(11)
                biggauss(i)=biggauss(i)+sgauss4(i)*par(12)
                biggauss(i)=biggauss(i)+sgauss5(i)*par(21)
                biggauss(i)=biggauss(i)+sgauss6(i)*par(22)
                biggauss(i)=biggauss(i)+sgauss7(i)*par(23)
                biggauss(i)=biggauss(i)+sgauss8(i)*par(24)
                biggauss(i)=biggauss(i)+sgauss9(i)*par(25)
                biggauss(i)=biggauss(i)+sgauss10(i)*par(26)
                biggauss(i)=biggauss(i)+sgauss11(i)*par(27)
                biggauss(i)=biggauss(i)+sgauss12(i)*par(28)
c==     negative wings:
                if (biggauss(i).lt.0.) biggauss(i)=0.
c==

        end do

        fisum=0.
        do i=1,sizfi
                fi(i)=biggauss(i)
                fisum=fisum+fi(i)
        end do

        do i=1,sizfi
                fi(i)=fi(i)/fisum
        end do

        call
& mread2(sizf,f,sizg,sizfi,fi,g,g_simu,q,p,s,wn,par,
& ka,sizka,fchi2,star,ka2,sizka2)

        width1=fchi2

        return
        end
c************************************************************************
        function width2(x)
        parameter(nb_params=40, maxsiz=1000)
        real width2,x
        real fchi2,fisum
        REAL par(nb_params)
        integer sizf,sizg,sizfi,q,p,sizka,sizka2
        real*8 wn
        real fi(maxsiz),g(maxsiz),s(maxsiz)
        REAL f(5000),g_simu(5000)
        real ka(40000),ka2(40000)
        integer star

        real*8 pi,sigma,mu,gaus(50),ix
        real*8 term1,term2,term3
        real realgauss(50),biggauss(245),sgauss1(245)
        real sgauss2(245),sgauss3(245),sgauss4(245)
        real sgauss5(245),sgauss6(245),sgauss7(245),sgauss8(245)
        real sgauss9(245),sgauss10(245),sgauss11(245),sgauss12(245)
        real mgpos(30)

        common /params/ par,mgpos,star
        common /sizes/ sizka,sizfi,sizka2
        common /convol/ sizf,sizg,p,q,fi,g,s,ka,ka2

        pi=3.1415927

        par(30)=x

	call megauss(sizfi,par(6),FLOAT(p+1),biggauss)
c        call megauss(sizfi,par(6),25.,biggauss)
c       new widths:
        call megauss(sizfi,par(29),mgpos(1),sgauss1)
        call megauss(sizfi,x,mgpos(2),sgauss2)
c
c        call megauss(sizfi,mgpos(6),mgpos(3),sgauss3)
c        call megauss(sizfi,mgpos(6),mgpos(4),sgauss4)
c       new widths
        call megauss(sizfi,par(31),mgpos(3),sgauss3)
        call megauss(sizfi,par(32),mgpos(4),sgauss4)

        call megauss(sizfi,mgpos(13),mgpos(11),sgauss5)
        call megauss(sizfi,mgpos(13),mgpos(12),sgauss6)
        call megauss(sizfi,mgpos(16),mgpos(14),sgauss7)
        call megauss(sizfi,mgpos(16),mgpos(15),sgauss8)
        call megauss(sizfi,mgpos(19),mgpos(17),sgauss9)
        call megauss(sizfi,mgpos(19),mgpos(18),sgauss10)
        call megauss(sizfi,mgpos(22),mgpos(20),sgauss11)
        call megauss(sizfi,mgpos(22),mgpos(21),sgauss12)
        do i=1,sizfi
                biggauss(i)=biggauss(i)+sgauss1(i)*par(9)
                biggauss(i)=biggauss(i)+sgauss2(i)*par(10)
                biggauss(i)=biggauss(i)+sgauss3(i)*par(11)
                biggauss(i)=biggauss(i)+sgauss4(i)*par(12)
                biggauss(i)=biggauss(i)+sgauss5(i)*par(21)
                biggauss(i)=biggauss(i)+sgauss6(i)*par(22)
                biggauss(i)=biggauss(i)+sgauss7(i)*par(23)
                biggauss(i)=biggauss(i)+sgauss8(i)*par(24)
                biggauss(i)=biggauss(i)+sgauss9(i)*par(25)
                biggauss(i)=biggauss(i)+sgauss10(i)*par(26)
                biggauss(i)=biggauss(i)+sgauss11(i)*par(27)
                biggauss(i)=biggauss(i)+sgauss12(i)*par(28)
c==     negative wings:
                if (biggauss(i).lt.0.) biggauss(i)=0.
c==

        end do

        fisum=0.
        do i=1,sizfi
                fi(i)=biggauss(i)
                fisum=fisum+fi(i)
        end do

        do i=1,sizfi
                fi(i)=fi(i)/fisum
        end do

        call
& mread2(sizf,f,sizg,sizfi,fi,g,g_simu,q,p,s,wn,par,
& ka,sizka,fchi2,star,ka2,sizka2)

        width2=fchi2

        return
        end


c************************************************************************
        function width3(x)
        parameter(nb_params=40, maxsiz=1000)
        real width3,x
        real fchi2,fisum
        REAL par(nb_params)
        integer sizf,sizg,sizfi,q,p,sizka,sizka2
        real*8 wn
        real fi(maxsiz),g(maxsiz),s(maxsiz)
        REAL f(5000),g_simu(5000)
        real ka(40000),ka2(40000)
        integer star

        real*8 pi,sigma,mu,gaus(50),ix
        real*8 term1,term2,term3
        real realgauss(50),biggauss(245),sgauss1(245)
        real sgauss2(245),sgauss3(245),sgauss4(245)
        real sgauss5(245),sgauss6(245),sgauss7(245),sgauss8(245)
        real sgauss9(245),sgauss10(245),sgauss11(245),sgauss12(245)
        real mgpos(30)

        common /params/ par,mgpos,star
        common /sizes/ sizka,sizfi,sizka2
        common /convol/ sizf,sizg,p,q,fi,g,s,ka,ka2

        pi=3.1415927

        par(31)=x

	call megauss(sizfi,par(6),FLOAT(p+1),biggauss)
c        call megauss(sizfi,par(6),25.,biggauss)
c       new widths:
        call megauss(sizfi,par(29),mgpos(1),sgauss1)
        call megauss(sizfi,par(30),mgpos(2),sgauss2)
        call megauss(sizfi,x,mgpos(3),sgauss3)
        call megauss(sizfi,par(32),mgpos(4),sgauss4)

        call megauss(sizfi,mgpos(13),mgpos(11),sgauss5)
        call megauss(sizfi,mgpos(13),mgpos(12),sgauss6)
        call megauss(sizfi,mgpos(16),mgpos(14),sgauss7)
        call megauss(sizfi,mgpos(16),mgpos(15),sgauss8)
        call megauss(sizfi,mgpos(19),mgpos(17),sgauss9)
        call megauss(sizfi,mgpos(19),mgpos(18),sgauss10)
        call megauss(sizfi,mgpos(22),mgpos(20),sgauss11)
        call megauss(sizfi,mgpos(22),mgpos(21),sgauss12)
        do i=1,sizfi
                biggauss(i)=biggauss(i)+sgauss1(i)*par(9)
                biggauss(i)=biggauss(i)+sgauss2(i)*par(10)
                biggauss(i)=biggauss(i)+sgauss3(i)*par(11)
                biggauss(i)=biggauss(i)+sgauss4(i)*par(12)
                biggauss(i)=biggauss(i)+sgauss5(i)*par(21)
                biggauss(i)=biggauss(i)+sgauss6(i)*par(22)
                biggauss(i)=biggauss(i)+sgauss7(i)*par(23)
                biggauss(i)=biggauss(i)+sgauss8(i)*par(24)
                biggauss(i)=biggauss(i)+sgauss9(i)*par(25)
                biggauss(i)=biggauss(i)+sgauss10(i)*par(26)
                biggauss(i)=biggauss(i)+sgauss11(i)*par(27)
                biggauss(i)=biggauss(i)+sgauss12(i)*par(28)
c==     negative wings:
                if (biggauss(i).lt.0.) biggauss(i)=0.
c==

        end do
        fisum=0.
        do i=1,sizfi
                fi(i)=biggauss(i)
                fisum=fisum+fi(i)
        end do

        do i=1,sizfi
                fi(i)=fi(i)/fisum
        end do

        call
& mread2(sizf,f,sizg,sizfi,fi,g,g_simu,q,p,s,wn,par,
& ka,sizka,fchi2,star,ka2,sizka2)

        width3=fchi2

        return
        end

c************************************************************************
        function width4(x)
        parameter(nb_params=40, maxsiz=1000)
        real width4,x
        real fchi2,fisum
        REAL par(nb_params)
        integer sizf,sizg,sizfi,q,p,sizka,sizka2
        real*8 wn
        real fi(maxsiz),g(maxsiz),s(maxsiz)
        REAL f(5000),g_simu(5000)
        real ka(40000),ka2(40000)
        integer star

        real*8 pi,sigma,mu,gaus(50),ix
        real*8 term1,term2,term3
        real realgauss(50),biggauss(245),sgauss1(245)
        real sgauss2(245),sgauss3(245),sgauss4(245)
        real sgauss5(245),sgauss6(245),sgauss7(245),sgauss8(245)
        real sgauss9(245),sgauss10(245),sgauss11(245),sgauss12(245)
        real mgpos(30)

        common /params/ par,mgpos,star
        common /sizes/ sizka,sizfi,sizka2
        common /convol/ sizf,sizg,p,q,fi,g,s,ka,ka2

        pi=3.1415927

        par(32)=x

	call megauss(sizfi,par(6),FLOAT(p+1),biggauss)
c        call megauss(sizfi,par(6),25.,biggauss)
c       new widths:
        call megauss(sizfi,par(29),mgpos(1),sgauss1)
        call megauss(sizfi,par(30),mgpos(2),sgauss2)
        call megauss(sizfi,par(31),mgpos(3),sgauss3)
        call megauss(sizfi,x,mgpos(4),sgauss4)

        call megauss(sizfi,mgpos(13),mgpos(11),sgauss5)
        call megauss(sizfi,mgpos(13),mgpos(12),sgauss6)
        call megauss(sizfi,mgpos(16),mgpos(14),sgauss7)
        call megauss(sizfi,mgpos(16),mgpos(15),sgauss8)
        call megauss(sizfi,mgpos(19),mgpos(17),sgauss9)
        call megauss(sizfi,mgpos(19),mgpos(18),sgauss10)
        call megauss(sizfi,mgpos(22),mgpos(20),sgauss11)
        call megauss(sizfi,mgpos(22),mgpos(21),sgauss12)
        do i=1,sizfi
                biggauss(i)=biggauss(i)+sgauss1(i)*par(9)
                biggauss(i)=biggauss(i)+sgauss2(i)*par(10)
                biggauss(i)=biggauss(i)+sgauss3(i)*par(11)
                biggauss(i)=biggauss(i)+sgauss4(i)*par(12)
                biggauss(i)=biggauss(i)+sgauss5(i)*par(21)
                biggauss(i)=biggauss(i)+sgauss6(i)*par(22)
                biggauss(i)=biggauss(i)+sgauss7(i)*par(23)
                biggauss(i)=biggauss(i)+sgauss8(i)*par(24)
                biggauss(i)=biggauss(i)+sgauss9(i)*par(25)
                biggauss(i)=biggauss(i)+sgauss10(i)*par(26)
                biggauss(i)=biggauss(i)+sgauss11(i)*par(27)
                biggauss(i)=biggauss(i)+sgauss12(i)*par(28)
c==     negative wings:
                if (biggauss(i).lt.0.) biggauss(i)=0.
c==

        end do
        fisum=0.
        do i=1,sizfi
                fi(i)=biggauss(i)
                fisum=fisum+fi(i)
        end do

        do i=1,sizfi
                fi(i)=fi(i)/fisum
        end do

        call
& mread2(sizf,f,sizg,sizfi,fi,g,g_simu,q,p,s,wn,par,
& ka,sizka,fchi2,star,ka2,sizka2)

        width4=fchi2

        return
        end



c*********** new function wing1 ****************************************

	function wing1(x)
	parameter(nb_params=40, maxsiz=1000)
c	parameter(nb_params=40, maxsiz=5000)
        real wing1,x
        real fchi2,fisum
	REAL par(nb_params)
        integer sizf,sizg,sizfi,q,p,sizka,sizka2
        real*8 wn
c        real fi(50),g(maxsiz),g_simu(maxsiz),s(maxsiz)
	real fi(maxsiz),g(maxsiz),g_simu(maxsiz),s(maxsiz)

c	real ka(10000)
	real ka(40000),ka2(40000)
c	real ka(20000),ka2(20000)
c	real*8 ka(10000)
	integer star
        real*8 pi,sigma,mu,wingaus(50),ix,mu1,t1,t2,t3,sigma1
	real*8 mu2,sigma2,tm1,tm2,tm3	
        real*8 trm1,trm2,trm3,gaus(50),wingaus2(50)
        real rwingauss(50),rgaus(50),rwingaus2(50),realgauss(50)
	real mgpos(30)

        common /params/ par,mgpos,star
        common /sizes/ sizka,sizfi,sizka2
        common /convol/ sizf,sizg,p,q,fi,g,s,ka,ka2
	
	mu1=25.
        mu=7.
	mu2=43

        pi=3.1415927

	sigma1=5.5+par(6)
	t1=1./(sigma1*(SQRT(2*pi)))
	do ix=1.,49.
		t2=-((ix-mu1)**2/(2*sigma1**2))
		t3=EXP(t2)
		gaus(ix)=t1*t3
		rgaus(ix)=gaus(ix)
	end do

c        par(7)=x
        sigma=1.5 
	sigma2=1.5

	do i=1,sizfi
		rwingauss(i)=0.
		rwingaus2(i)=0.
	end do

c       write(*,*)'Sigma (5.5+x)=',sigma 
	trm1=1/(sigma*(SQRT(2*pi)))
	tm1=1/(sigma2*(SQRT(2*pi)))
        do ix=1.,13.
                trm2=-((ix-mu)**2/(2*sigma**2))
		tm2=-((ix-mu)**2/(2*sigma2**2))
                trm3=EXP(trm2)
		tm3=EXP(tm2)
                wingaus(ix)=trm1*trm3
		wingaus2(ix)=tm1*tm3
                rwingauss(ix)=wingaus(ix)
c		rwingaus2(ix)=wingaus2(ix)/par(8)
		rwingauss(ix)=rwingauss(ix)/x

        end do

	fisum=0.
        do i=1,sizfi
                fi(i)=rgaus(i)+rwingauss(i)+rwingaus2(i)
		fisum=fisum+fi(i)
        end do
	do i=1,sizfi
		fi(i)=fi(i)/fisum
	end do


c	open(12,file='./plot/iptest_5.dat')
c	do i=1,sizfi
c		write(12,*)fi(i)
c	end do
c	close(12)


        call
& mread2(sizf,f,sizg,sizfi,fi,g,g_simu,q,p,s,wn,par,
& ka,sizka,fchi2,star,ka2,sizka2)

c        write(*,*)'Chi2 with new wing1=',fchi2,' using factor x=',x

        wing1=fchi2 


c	open(12,file='./plot/ficheck2')
c	do i=1,sizfi
c		write(12,*)fi(i)
c	end do
c	close(12)


        return
        end



c################################################################################

c############# new function wing2 (right satellite gaussian) ############

        function wing2(x)
        parameter(nb_params=40, maxsiz=1000)
c	parameter(nb_params=40, maxsiz=5000)
        real wing1,x
        real fchi2,fisum
	REAL par(nb_params)
        integer sizf,sizg,sizfi,q,p,sizka,sizka2
        real*8 wn
c        real fi(50),g(maxsiz),g_simu(maxsiz),s(maxsiz)
	real fi(maxsiz),g(maxsiz),g_simu(maxsiz),s(maxsiz)
	integer star
c	real ka(10000)
	real ka(40000),ka2(40000)
c	real ka(20000),ka2(20000)
c	real*8 ka(10000)

        real*8 pi,sigma,mu,wingaus(50),ix,mu1,t1,t2,t3,sigma1
        real*8 mu2,sigma2,tm1,tm2,tm3
        real*8 trm1,trm2,trm3,gaus(50),wingaus2(50)
        real rwingauss(50),rgaus(50),rwingaus2(50),realgauss(50)
	real mgpos(30)
	
        common /params/ par,mgpos,star
        common /sizes/ sizka,sizfi,sizka2
        common /convol/ sizf,sizg,p,q,fi,g,s,ka,ka2

        mu1=25.
        mu=7.
        mu2=43

        pi=3.1415927
                
        sigma1=5.5+par(6)
        t1=1./(sigma1*(SQRT(2*pi)))
        do ix=1.,49.
                t2=-((ix-mu1)**2/(2*sigma1**2))
                t3=EXP(t2)
                gaus(ix)=t1*t3
                rgaus(ix)=gaus(ix)
        end do

c        par(8)=x
        sigma=1.5
        sigma2=1.5

        do i=1,sizfi
                rwingauss(i)=0.
                rwingaus2(i)=0.
        end do
        trm1=1/(sigma*(SQRT(2*pi)))
        tm1=1/(sigma2*(SQRT(2*pi)))
        do ix=1.,13.
                trm2=-((ix-mu)**2/(2*sigma**2))
                tm2=-((ix-mu)**2/(2*sigma2**2))
                trm3=EXP(trm2)
                tm3=EXP(tm2)
                wingaus(ix)=trm1*trm3
                wingaus2(ix)=tm1*tm3
                rwingauss(ix)=wingaus(ix)
                rwingaus2(ix)=wingaus2(ix)/x
c                rwingauss(ix)=rwingauss(ix)/par(7)

        end do  

	fisum=0.
        do i=1,sizfi
                fi(i)=rgaus(i)+rwingauss(i)+rwingaus2(i)
		fisum=fisum+fi(i)
        end do
	do i=1,sizfi
		fi(i)=fi(i)/fisum
	end do

        call
& mread2(sizf,f,sizg,sizfi,fi,g,g_simu,q,p,s,wn,par,
& ka,sizka,fchi2,star,ka2,sizka2)

        wing2=fchi2 
                
        return
        end


c################# new function boxip #########################

        function boxip(x)
        parameter(nb_params=40, maxsiz=1000)
c	parameter(nb_params=40, maxsiz=5000)
        real boxip,x
        real fchi2,fisum
	REAL par(nb_params)
        integer sizf,sizg,sizfi,q,p,sizka,sizka2
        real*8 wn
c        real fi(50),g(maxsiz),g_simu(maxsiz),s(maxsiz)
	real fi(maxsiz),g(maxsiz),s(maxsiz)
	REAL f(5000),g_simu(5000)
c	real ka(10000)
	real ka(40000),ka2(40000)
c	real ka(20000),ka2(20000)
c	real*8 ka(10000)

	integer width,star
c	real*8 pi,sigma,mu,gaus(50),ix
c        real*8 term1,term2,term3
        real convgauss(1000)

	integer sizbox,count,sizfconv
	real box(1000),f_conv(1000),phisav(1000)
        real mgpos(30)
        
        common /params/ par,mgpos,star
        common /sizes/ sizka,sizfi,sizka2
        common /convol/ sizf,sizg,p,q,fi,g,s,ka,ka2
	
        
c        sizbox=195
c	sizbox=245
	sizbox=441

c	write(*,*)'THIS IS FUNCTION BOXIP'

c        write(*,*)'Creating box....'

        do i=1,800
                box(i)=0.
		convgauss(i)=0.
        end do   
	

c	write(*,*)'x=',x
c	write(*,*)'98-x =',98-x
c	write(*,*)'98+x =',98+x

c	if (x.lt.-122.) then
	if (x.lt.-220.) then
		boxip=9999999.+ABS(x)
		goto 45000
	end if

c	if (x.gt.122.) then 
	if (x.gt.220.) then
		boxip=9999999.+ABS(x)
		goto 45000
	end if

	width=ABS(IFIX(x))

c	write(*,*)'OK, Box parameter=',x,' and width=',width

        par(7)=x

c        do i=98-width,98+width

c	do i=123-width,123+width

c	write(*,*)'220-width=',220-width
c	write(*,*)'222+width=',222+width
c	write(*,*)'width*2=',width*2


	do i=220-width,222+width

                box(i)=1.

        end do

c	GAUSSIAN with overs=5 
c	call megauss(245,par(13),123.,convgauss)
c	GAUSSIAN with overs=9
c	write(*,*)'Parameter #13=',par(13)
	call megauss(441,par(13),221.,convgauss)
        
c        write(*,*)'Convolve with gaussian....'
c        write(*,*)'Size of box-vector=',sizbox
c       write(*,*)'q=',q,' fi(13)=',fi(13),' Sizefi=',sizfi
        
c        CALL mconv2(box,sizbox,sizg,q,f_conv,convgauss,245,sizfconv)
	CALL mconv2(box,sizbox,sizg,q,f_conv,convgauss,441,sizfconv)
        
c        write(*,*)'Size of convolved vector=',sizfconv
c        open(unit=30, file='./plot/test_box.dat')
c                
c        do i=1,sizfconv
c                write(30,*)f_conv(i),box(i),convgauss(i)
c        end do
c        close(30)
c
c        write(*,*)'Check the convolution of the box......!'
c	read(*,*)reply


        do i=1,sizfi
                fi(i)=0.
        end do
        
        j=1
        count=1
        sizfi=0
        
        do i=1,sizfconv
        
                fi(j)=fi(j)+f_conv(i)
c                if (count.eq.5) then
		 if (count.eq.9) then
c                        fi(j)=fi(j)/5.
			 fi(j)=fi(j)/9.
                        sizfi=sizfi+1
                        count=0
                        j=j+1
c               write(*,*)'sizfi=',sizfi,' j=',j,' i=',i   
                end if
                count=count+1
        end do
        
c	write(*,*)'Size of new boxed IP=',sizfi

	fisum=0.
	do i=1,sizfi
		fisum=fisum+fi(i)
	end do

        do i=1,sizfi
                fi(i)=fi(i)/fisum
        end do


c        open(30,file='./plot/boxip.dat')
c        do i=1,sizfi
c                write(30,*)fi(i)
c        end do   
c        close(30)
c        write(*,*)'OK, boxed IP is ready'
        
c        read(*,*)reply

        call
& mread2(sizf,f,sizg,sizfi,fi,g,g_simu,q,p,s,wn,par,
& ka,sizka,fchi2,star,ka2,sizka2)
                
c        write(*,*)'Chi2 with BOX IP par(7):',par(7),' =',fchi2

c	open(26,file='./plot/box.dat')
c	do i=1,sizfi
c		write(26,*)fi(i)
c	end do
c	close(26)
c	write(*,*)'OK, boxed IP is ready'
c	read(*,*)reply

        
        boxip=fchi2
 
45000	continue
        return
        end   


c################# new function boxip2 #########################
        
        function boxip2(x)
        parameter(nb_params=40, maxsiz=1000)
c	parameter(nb_params=40, maxsiz=5000)
        real boxip2,x
        real fchi2,fisum
	REAL par(nb_params)
        integer sizf,sizg,sizfi,q,p,sizka,sizka2
        real*8 wn  
c        real fi(50),g(maxsiz),g_simu(maxsiz),s(maxsiz)
	real fi(maxsiz),g(maxsiz),s(maxsiz)
	REAL f(5000),g_simu(5000)
c	real ka(10000)
	real ka(40000),ka2(40000)
c	real ka(20000),ka2(20000)
c	real*8 ka(10000)

        integer width,star
c       real*8 pi,sigma,mu,gaus(50),ix
c        real*8 term1,term2,term3
        real convgauss(1000)

        integer sizbox,count,sizfconv
        real box(1000),f_conv(1000),phisav(1000)
        real mgpos(30)

        common /params/ par,mgpos,star
        common /sizes/ sizka,sizfi,sizka2
        common /convol/ sizf,sizg,p,q,fi,g,s,ka,ka2
        
        
c        sizbox=195
c        sizbox=245
	sizbox=441
        
c        write(*,*)'THIS IS FUNCTION BOXIP2'
        
c        write(*,*)'Creating box....'
        
        do i=1,800
                box(i)=0.
		convgauss(i)=0.
        end do
        
        
c       write(*,*)'x=',x
c       write(*,*)'98-x =',98-x
c       write(*,*)'98+x =',98+x
     
	width=ABS(IFIX(par(7)))

c        if (width.lt.0.) then
c                write(*,*)'width of box smaller than 0!!'
c                width=0. 
c        end if

c        if (width.gt.122.) then
c                write(*,*)'x larger than 122!!'
c                width=122.
c        end if
c        write(*,*)'OK, Box parameter=',par(7),' and width=',width
c        write(*,*)'OK, and sigma of gaussian=',par(13)
	
        par(13)=x

c---	CREATING BOX        
c        do i=98-width,98+width
c        do i=123-width,123+width

	do i=220-width,222+width

                box(i)=1.

        end do
c---

c	Oversampling=5        
c        call megauss(245,x,123.,convgauss)
c	Oversampling=9

c	call megauss(441,x,221.d0,convgauss)
	call megauss(441,par(13),221.,convgauss)

c        CALL mconv2(box,sizbox,sizg,q,f_conv,convgauss,245,sizfconv)
	CALL mconv2(box,sizbox,sizg,q,f_conv,convgauss,441,sizfconv)
        
c        write(*,*)'Size of convolved vector=',sizfconv

c        open(unit=30, file='./plot/test_box.dat')
c        do i=1,sizfconv
c
c               write(30,*)f_conv(i),box(i),convgauss(i)
c
c        end do
c        close(30)
                
c        write(*,*)'Check the convolution of the box......!'
        
        
        do i=1,sizfi
                fi(i)=0.
        end do  

        j=1
        count=1
        sizfi=0
                
        do i=1,sizfconv
        
                fi(j)=fi(j)+f_conv(i)
c                if (count.eq.5) then
		 if (count.eq.9) then
c                        fi(j)=fi(j)/5.
			 fi(j)=fi(j)/9.
                        sizfi=sizfi+1
                        count=0
                        j=j+1
c               write(*,*)'sizfi=',sizfi,' j=',j,' i=',i   
                end if
                count=count+1
        end do
        
c        write(*,*)'Size of new boxed IP=',sizfi  
        
        fisum=0.
        do i=1,sizfi
                fisum=fisum+fi(i)
        end do   
                
        do i=1,sizfi
                fi(i)=fi(i)/fisum
        end do
        
       call
& mread2(sizf,f,sizg,sizfi,fi,g,g_simu,q,p,s,wn,par,
& ka,sizka,fchi2,star,ka2,sizka2)
                        
c        write(*,*)'Chi2 with opt. par(13):',par(13),' =',fchi2
                        
c       open(20,file='./plot/g_simu.dat')
c       do i=1,1000   
c               write(20,*)g_simu(i)
c       end do
c       close(20)
        
        
        boxip2=fchi2
        return
        end

c----------------------- new function lorentz -----------------------

        function lorentz(x)  
        parameter(nb_params=40, maxsiz=1000)
c	parameter(nb_params=40, maxsiz=5000)
        real lorentz,x
        real fchi2,fisum
	REAL par(nb_params)
        integer sizf,sizg,sizfi,q,p,sizka,sizka2
        real*8 wn 
c        real fi(50),g(maxsiz),g_simu(maxsiz),s(maxsiz)
	real fi(maxsiz),g(maxsiz),s(maxsiz)
	integer star
c	real ka(10000)
	real ka(40000),ka2(40000)
c	real ka(20000),ka2(20000)
c	real*8 ka(10000)
	REAL f(5000),g_simu(5000)
        real*8 pi,sigma,alp,ix,lor1(50)
        real*8 term1,term2,term3
        real lor(50)
	integer sizlor
	real mgpos(30)

        common /params/ par,mgpos,star
        common /sizes/ sizka,sizfi,sizka2
        common /convol/ sizf,sizg,p,q,fi,g,s,ka,ka2

c	write(*,*)'THIS IS NEW FUNCTION LORENTZ!'
	
	sizlor=49.
        alp=25.
        pi=3.1415927

	par(14)=x

c	write(*,*)'OK, x=',x

	do ix=1.,49.,1.
		lor1(ix)=(1./pi)*(x/(x**2.+(ix-alp)**2.))
		
	end do
	fisum=0.
	do i=1,sizlor
		lor(i)=lor1(i)
		fi(i)=lor(i)
		fisum=fisum+fi(i)
c		write(*,*)lor1(i),lor(i),fi(i)
	end do
	do i=1,sizfi
		fi(i)=fi(i)/fisum
	end do

	
        call
& mread2(sizf,f,sizg,sizfi,fi,g,g_simu,q,p,s,wn,par,
& ka,sizka,fchi2,star,ka2,sizka2)

c	open(27,file='./plot/lorentz.dat')
c	do i=1,sizfi
c		write(27,*)fi(i)
c	end do
c	close(27)

c	write(*,*)'Chi2 with par#14:',x,' is=',fchi2

	lorentz=fchi2
	return
	end

c--------------------------------------------------------------------------



c##############################################################################
        subroutine est_params(g,g_simu,sizg,s,par)
c
c	estimates par(5) = normalization
c
c##############################################################################


c       parameter (maxsiz=1000,nb_params=8)
        implicit none
	integer maxsiz,nb_params
c	parameter (maxsiz=1000,nb_params=40)
	parameter (maxsiz=5000,nb_params=40)

	
        integer i,j,k,sizg,cutg,sizf,sizfi,sizka
        real stddev,devg_simu,devg,meang_simu,meang,chi2min,meanfact
        real meang2,devfact,chi2
        real g(maxsiz),g_simu(maxsiz),gcopy(maxsiz)
        real s(maxsiz),fi(maxsiz)
c	real ka(10000)
c	real f(5000),ka(20000)
	real f(5000),ka(40000)

	REAL par(nb_params)

c       ** Renormalization ***********************
	
	meanfact=0.
	
	do k=1,sizg
		if (g_simu(k).gt.meanfact) then
			meanfact=g_simu(k)
		end if
	end do

	par(5)=meanfact

	do k=1,sizg
		g_simu(k)=g_simu(k)/par(5)
	end do

	
	chi2=0.
	do i=1,sizg
c		g_simu(i)=((g_simu(i)-1.)*par(4))+1.
		chi2=chi2+((g(i)-g_simu(i))/s(i))**2
	end do

c	OPEN(09,file='plot/chunk/test_est.dat')
c
c	do i=1,sizg
c		WRITE(09,*) i, g(i), g_simu(i), s(i)
c	end do
c	CLOSE(09)
c
c	WRITE(*,*)'Output written to file: test_est.dat'

c	********************************************************	

	
c	 write(*,*)' Chi2 at end of est_params:',chi2
c	 write(*,*) ' estimated Par :',par

         return
         end

c###########################################################################

c------------------------------------------------------------------------
        SUBROUTINE MCAL_MAT2(f,sizf,matF,p,q,sizg)
      
        IMPLICIT NONE

	INTEGER maxsiz
        PARAMETER(maxsiz=1000)
c	PARAMETER(maxsiz=5000)

        INTEGER sizf,sizg,p,q
c        REAL f(maxsiz)
	REAL f(5000)

        REAL matF(maxsiz,maxsiz)
        INTEGER j,js,i,k
        REAL sumf,jdown,jup
ccc        write(*,*)'This is MCAL_MAT2!'
ccc        write(*,*)'Size of f=',sizf
ccc        write(*,*)'Size of g=',sizg
ccc        write(*,*)'Oversampling factor=',q
ccc        write(*,*)'Half size of IP=',p
        
c       BEWARE: index for IP runs from now from +p to -p
c       like in the formula

c       Index for the matrix: 
        k=1
        
        do i=1,sizg   
        
c       open(unit=999, file='./plot/testmatf.dat',type='new')
        k=1
                do js=p*2,0,-1
c       js=1
                        jdown=((q*i)-(q-1)+p)-(js-p)
                        jup=((q*(i+1)-1)-(q-1)+p)-(js-p)
                        sumf=0.
        
c                       write(*,*)'jdown=',jdown
c                       write(*,*)'jup=',jup
c                       write(999,*)'....js=',(js-p)

                        do j=jdown,jup
c                               write(999,*)'f(',j,')=',f(j)
        
                                sumf=sumf+f(j)
        
                        end do
           
                        matF(i,k)=sumf
c                       write(999,*)'matF(',i,'',k,')=',matF(i,k)
                        k=k+1
                end do
        
        end do

c       close(999)

                        
        RETURN
        END





c********************************************************************   
c** MREAD2
c********************************************************************   

      subroutine 
& mread2(sizf,f,sizg,sizfi,fi,g,g_simu,q,p,s,wn,par,
& ka,sizka,fchi2,star,ka2,sizka2)

c**********************************************************************
c  This routine constructs the parametrized function F=f(lbd,par(i=1,5))
c  after having looked for its location in the master table,and convolves 
c  it with the default IP vector fi. The resulting vector is returned as g.
c**********************************************************************
c     ------------------------------
c     description of main variables:
c
c     f    Real 1-D array       f-vector! not conv.                OUT	
c     p    Integer              Cut-off on fi                      IN
c     sizg Integer              Size of g vector (px)              IN      
c     sizf Integer              Size of f vector (px)              IN 
c     wn   real*8               Start wavenumber                   IN
c     fi   Real 1-D array       Default instrumental profile       OUT
c     g    Real 1-D array       Discrete observed spectrum vector  OUT
c     ka   Real 1-D array       Hires Array read from masttab      IN
c     sizka Integer             Size of ka vector                  IN 
c     fchi2 real		Chi2 value (g-g_simu)		   OUT		
c     star  Integer             flag stellar spectrum (0=n/1=y)    IN
c     ka2  Real 1-D array	Hires array stellar mstb	   IN
c     sizka2 Integer		Size of ka2		
c**********************************************************************
     

	IMPLICIT NONE

	integer maxsiz,splin_div,nb_params
	parameter (maxsiz=1000,splin_div=10,nb_params=40)
c	parameter (maxsiz=5000,splin_div=10,nb_params=40)

        integer i,j,k,lr,count,sizfconv,star
        integer sizf,sizg,q,p,sizfi,sizka,sizgsimu
        integer start_try,kaindex,sizka2
c      real fi(50),f(maxsiz),g_simu(maxsiz),s(maxsiz),g(maxsiz)
c	real fi(maxsiz),f(maxsiz),g_simu(maxsiz),s(maxsiz),g(maxsiz)
	real fi(maxsiz),s(maxsiz),g(maxsiz),g_samp(maxsiz)

c	real f_conv(maxsiz),g_samp(maxsiz)
	REAL g_simu(5000)
c	real ka(10000),f(5000),f_conv(5000)
ccc	real ka(20000),f(5000),f_conv(5000)
	real ka(40000),f(5000),f_conv(5000)
c	real*8 ka(10000)

c	REAL ka2(20000),fc(5000),f1(5000)
	REAL ka2(40000),fc(5000),f1(5000)

      	real slop
	REAL par(nb_params)
      	real*8  wl,wn,wn0,f0,wtry
	real*8 ratio_wn_mtb
	real*8 step,rest,diff,realkaindex,startkaindex
	real ka0,ka1,fchi2,gsimax,gdummy
	character reply

	ratio_wn_mtb=0.01409413961
c**********************************************************************



	step=par(2)

	rest=step-int(step)

c	write(*,*)'Old size of f, size of Phi:',sizf,sizfi
c	sizf is already calculated in MREAD!!!!
c	sizf=sizf+sizfi

c	write(*,*)'New size of f(=f+2p):',sizf


	do i=1,sizf
		f(i)=0.
		f1(i)=0.
                fc(i)=0.
	end do

c	open(unit=37,file='./plot/chunk/indeces1.dat')

c	realkaindex=2500.-((sizfi/2)*step)+par(1)
c	realkaindex=2500.d0-(FLOAT(sizfi/2)*step)+par(1)

cc	startkaindex=2500.d0-(FLOAT(sizfi/2)*step)-
cc&       (par(8)*(FLOAT(sizfi/2)**2.))+par(1)
	startkaindex=2500.d0-(DBLE(sizfi/2)*step)-
&       (par(8)*(DBLE(sizfi/2)**2.))+par(1)


	realkaindex=startkaindex

	kaindex=int(realkaindex)


c	write(*,*)'..... SHIFTING the f-vector....'
c	write(*,*)'step (dispersion)=',step
c	write(*,*)'rest=',rest
c	write(*,*)'START realkaindex is now='
c	write(*,119) realkaindex
c	write(37,119) realkaindex
c	write(*,*)'kaindex=',kaindex
	
	i=1
	ka0=ka(kaindex)
	ka1=ka(kaindex+1)
	diff=ka1-ka0
	rest=realkaindex-kaindex

c	write(*,*)'i=, ka0, ka1:',i,ka0,ka1
c	write(*,*)'realkaindex, rest=',realkaindex,rest

c	f(1)=(ka0+diff*rest)

c------- CREATION OF PARAMETRIZED OVERSAMPLED F-VECTOR --------

c	Normalizing:	
	f(1)=(ka0+diff*rest)/par(5)

c	Line-depth:
	f(1)=((f(1)-1.)*par(4))+1.

c	Old slope:
c	f(1)=f(1)+(par(3))

c	New slope:
	slop=par(3)/(sizf-1)

	f(1)=((f(1)-1.)+(par(3)/2.))+1.

c	Loop over f-vector:
	
	do i=2,sizf
		
c	linear dispersion:
c		realkaindex=realkaindex+step
c	non-linear dispersion:

c		if (i.eq.sizf) then
c		write(*,*)'(par(8)*(i**2))=',(par(8)*(i**2)),'par(8)=',par(8)
c		end if
ccc
		step=par(2)*i+(par(8)*(i**2))
ccc
		realkaindex=startkaindex+step
c		realkaindex=realkaindex+step+(par(8)*(i**2))
ccc
c		write(37,119)realkaindex

		kaindex=int(realkaindex)
		rest=realkaindex-kaindex

		ka0=ka(kaindex)
		ka1=ka(kaindex+1)
		diff=ka1-ka0


		f(i)=(ka0+diff*rest)/par(5)

		f(i)=((f(i)-1.)*par(4))+1.

c	Old slope:		
c		f(i)=f(i)+(par(3)*i)

c	New slope:
		f(i)=((f(i)-1.)+(par(3)/2.)-(slop*(i-1)))+1.		



c		if (i.lt.5) then
c			write(*,*)'i=, ka0, ka1:',i,ka0,ka1
c			write(*,*)'realkaindex, rest=',realkaindex,rest
c			write(*,*)'rest, diff, f(i):',rest,diff,f(i)
c		end if
		

	end do

c	write(*,*)'And ending with index:'
c	write(*,119) realkaindex


cc	CLOSE(37)

c--------------------------------------------------------------------------
c               
c       STELLAR SPECTRUM
c
c       f1-vector
c       
c       
c--------------------------------------------------------------------------

	IF (star.eq.1) THEN
	
	step=par(2)
	
cc	startkaindex=2500.d0-(FLOAT(sizfi/2)*step)-
cc&       (par(8)*(FLOAT(sizfi/2)**2.))+par(16)
	startkaindex=2500.d0-(DBLE(sizfi/2)*step)-
&       (par(8)*(DBLE(sizfi/2)**2.))+par(16)


        realkaindex=startkaindex

        kaindex=int(realkaindex)
        i=1
        ka0=ka2(kaindex)
        ka1=ka2(kaindex+1)
        diff=ka1-ka0
        rest=realkaindex-kaindex

c------- CREATION OF PARAMETRIZED OVERSAMPLED F1-VECTOR --------

c       Normalizing:
        f1(1)=(ka0+diff*rest)/par(17)

c       Line-depth:
        f1(1)=((f1(1)-1.)*par(18))+1.

c       Old slope:
c       f(1)=f(1)+(par(3))

c       New slope:
        slop=par(19)/(sizf-1)
       
        f1(1)=((f1(1)-1.)+(par(19)/2.))+1.

c--------- Loop over f1-vector: -----------------------------------

	do i=2,sizf

	step=par(2)*i+(par(8)*(i**2))

	realkaindex=startkaindex+step

		kaindex=int(realkaindex)
                rest=realkaindex-kaindex

                ka0=ka2(kaindex)
                ka1=ka2(kaindex+1)
                diff=ka1-ka0

                
                f1(i)=(ka0+diff*rest)/par(17)

                f1(i)=((f1(i)-1.)*par(18))+1.
                
		f1(i)=((f1(i)-1.)+(par(19)/2.)-(slop*(i-1)))+1.		

	end do
c------------ closing F1 Loop --------------------------------------

c***********************************************************************
c
c       COMPLETE MODEL SPECTRUM (STAR * IODINE)
c
c       fc vector
c
c***********************************************************************


        do i=1,sizf
        
                fc(i)=f(i)*f1(i)

        end do

c***********************************************************************

c       LETS CALL MCONV!

        CALL MCONV(fc,sizf,sizg,q,f_conv,fi,sizfi,sizfconv)

	do i=1,sizf
		f(i)=fc(i)
	end do

	goto 9999
c=============== END OF STELLAR PART =================================

	END IF


c	open(8,file='./plot/f_dconv2.dat')
c	do i=1,sizf-2*p
c		write(8,*)f(p+i)
c	end do
c	close(8)
c	write(*,*)sizf-2*p,' = size of deconv. f-vector'

cc	open(8,file='./plot/test_f.dat')
cc	do i=1,sizf
cc		write(8,*)f(i)
cc	end do
cc	close(8)



c	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
c	LETS CALL MCONV!
c	write(*,*)'Calling MCONV.........'

	CALL MCONV(f,sizf,sizg,q,f_conv,fi,sizfi,sizfconv)

c	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

9999	continue

c	open(unit=30,file='./plot/f_conv.dat')
c       
c	    do i=1,sizfconv
c                      write(30,*)f_conv(i)
c              end do
c              
c	close(30)


c	write(*,*)'.......Convolution (MCONV) done'
c	write(*,*)'MREAD2: F_CONV(1)=',f_conv(1)
c	write(*,*)'MREAD2: Size of F_CONV=',sizfconv
c	write(*,*)'now parametrizing & calculating chi2....'
c	write(*,*)'Parameters:',par

c	write(*,*)'g-value vs. g_simu-value,i=23',g(23),g_simu(23),s(23)
c	write(*,*)'Size g=',sizg

c	********* Chi2 *******************
	fchi2=0.
c	********* f_conv & g_simu **********	
	
c	write(*,*)'Parametrizing f_conv & g_simu with par:',par


	do i=1,sizfconv

		g_simu(i)=f_conv(i)	

	end do


c	creating g_samp as equally sampled vector

	gdummy=0.
	sizgsimu=0.
        count=1
        j=1

        do i=1,sizfconv
                gdummy=gdummy+g_simu(i)
c       write(*,*)'i ,count, j, g_new(i),gdummy',i,count,j,g_new(i),gdummy
                count=count+1
                if (count.gt.q) then
                        count=1
                        g_samp(j)=gdummy/q
c                       write(*,*)'gsimu(j)=',g_simu(j)
                        j=j+1
                        sizgsimu=sizgsimu+1
                        gdummy=0.
                end if
        end do

c--------------- CHI^2 --------------------------------
	do i=1,sizg

		fchi2=fchi2+((g(i)-g_samp(i))/s(i))**2

	end do
c--------------- CHI^2 --------------------------------
	

c	open(400, file='./plot/testf.dat', type='new')
c	do i=1,sizf
c		write(400,*)f_conv(i),f(i)
c	end do
c	close(400)

c	write(*,*)'Chi2=',fchi2,' Par:',par

c	write(*,*)'Plot it (y/n)?'
c	read(*,*)reply

c	if (reply.eq.'y') then

c       open(unit=300,file='./plot/testg.dat', type='new')
c        do i=1,sizgsimu
c                write(300,*)g(i),g_samp(i)
c         end do
c         close(300)
c
c	end if


c	read(*,*)reply
	
c	write(*,*)'MREAD2: Chi2=',fchi2,' Sizg=',sizg 
c	write(*,*)'MREAD2: fi(1)=',fi(1),' s(1)=',s(1),' ka(1)=',ka(1)
c	write(*,*)'MREAD2: g(1)=',g(1),' g_samp(1)=',g_samp(1)
c	write(*,*)'MREAD2: g(2)=',g(2),' g_samp(2)=',g_samp(2)

c	do i=1,sizg
c	  write(*,*)'MREAD2:g(i),gsamp(i),s(i)=',g(i),g_samp(i),s(i)
c	end do


c	*******************************************************

 119	format(1(3x,e25.15))	

        RETURN
        
 	end


c----------------------------------------------------------------
c	SUBROUTINE MEGAUSS
c----------------------------------------------------------------
	subroutine megauss(sizgauss,sigma,mu,meigauss)

c	sizgauss	Size of gaussian	INPUT
c	sigma		Sigma of gaussian	INPUT
c	mu		Center of gaussian	INPUT
c	meigauss	resulting gaussian 	OUTPUT

        parameter(nb_params=40, maxsiz=1000)
c	parameter(nb_params=40, maxsiz=5000)

	integer sizgauss
	real sigma,mu
c	REAL*8 sigma,mu

c        real*8 pi,sigma,mu,gaus(1000),ix
	real*8 pi,gaus(1000),ix
        real*8 term1,term2,term3
        real meigauss(1000),sumgauss
        
        
        pi=3.1415927

c        write(*,*)'This is subroutine MEGAUSS....'
c       write(*,*)'x=',x 
        
        
c	write(*,*)'Size of the Gaussian=',sizgauss
c        write(*,*)'Sigma=',sigma
c	write(*,*)'mu=',mu
        
        term1=1/(sigma*(SQRT(2*pi)))  
        
c        do ix=1.,49.
	do ix=1.,sizgauss
 
                term2=-((ix-mu)**2/(2*sigma**2))
                term3=EXP(term2)
                gaus(ix)=term1*term3
                meigauss(ix)=gaus(ix)

        end do
c------------------------------------------------------------
c	NORMALIZING:

        sumgauss=0.
        do i=1,sizgauss
                sumgauss=sumgauss+meigauss(i)
        end do
        do i=1,sizgauss
                meigauss(i)=meigauss(i)/sumgauss
        end do

c------------------------------------------------------------


c       write(*,*)'Gauss(13)=',fi(13)
c        call
c&mread2(sizf,f,sizg,sizfi,fi,g,g_simu,q,p,s,wn,par,ka,sizka,fchi2)
c       write(*,*)'Chi2 with new gauss=',fchi2
c        gauss=fchi2




        return
        end

c####################################################################
c	**************************************************************
c	* Michls convolution subroutine 2  
c	* to be used for main gaussian IP and the boxed IP   
c	**************************************************************
	
	SUBROUTINE MCONV2(f,sizf,sizg,q,f_conv,phi,sizphi,sizfconv)

c       **************************************************************
c	* this routine convolves the vector f with the vector phi 
c       **************************************************************

c	*  f_conv    oversampled & convolved model vector  OUTPUT
c	*  f	     oversampled & not conv. model vector  INPUT
c	*  sizg      size of the observed vector           INPUT
c	*  sizf      =sizg*q                               INPUT
c	*  q	     oversampling factor                   INPUT
c	*  phi       instrumental profile for the conv.    INPUT
c       *  sizphi    size of IP vector                     INPUT
c	*  sizfconv  size of f_conv                        OUTPUT	

	INTEGER i,sizf,sizphi,j,k,sizg,p,sizgnew,sizgsimu,q,count
	INTEGER sizfconv
	REAL f(1000),phi(1000),g_simu(1000),g_new(1000),conv(1000)
	REAL f_conv(1000)
	REAL gdummy
c	REAL sumphi,sumidu
	REAL*8 sumidu,sumphi

	CHARACTER reply
	
c	write(*,*)'Size of vector PHI=',sizphi
c	write(*,*)'Size of input vector f=',sizf
 
	p=sizphi/2

	sizgsimu=0

c	write(*,*)'Cut off value for Phi, p=',p


	do j=1,sizf
		
		sumidu=0.
		
		do k=1,sizphi

c			if (j.eq.50) then

c			    write(*,*)'k ,Phi(k)',k,phi(k)
c			    write(*,*)'(j-(p+1)+k)=',j-(p+1)+k
c			    write(*,*)'f(j-(p+1)+k)=',f(j-(p+1)+k)
c	      write(*,*)'f(j-(p+1)+k)*Phi(k)=',f(j-(p+1)+k)*phi(k)
c			write(*,*)'sumidu=',sumidu	
c
c			end if

		  
		 if ((j-(p+1)+k).gt.0) then	
		
		  sumidu=sumidu+(f(j-(p+1)+k)*phi(k))
			
		 end if



		end do

		conv(j)=sumidu
		sizgsimu=sizgsimu+1

c		if (j.eq.23) then 
c		write(*,*)'Value of convolved vector(23)',conv(j)
c		end if 
		
	
	end do


c	write(*,*)'Convolution done.....'
c	write(*,*)

c	do i=1,sizf
c		f_conv(i)=conv(i)
c	end do
c	sizfconv=sizf

c	goto 978


	sizfconv=sizf


c	open(17,file='./plot/mconv2.dat')
c
	do i=1,sizfconv
		f_conv(i)=conv(i)
c		write(17,*)f_conv(i),f(i),phi(i)
	end do
c	close(17)

	return

	end
		

c============================================================================

	SUBROUTINE FUNC_VALUE(AX,FA,FUNC)
	
	EXTERNAL FUNC

	FA=FUNC(AX)

	RETURN

	END
c============================================================================

